Kea 3.0.2 (stable) released on October 29, 2025

2384.	[sec]		tmark
	When a hostname or FQDN received from a client is
	reduced to an empty string by hostname sanitizing,
	kea-dhcp4 and kea-dhcp6 will now drop the option.
	CVE:2025-11232
	(Gitlab #4142, #4155)

2383.	[build]		razvan
	The library version numbers have been bumped up for the Kea 3.0.2
	stable release.
	(Gitlab #4173)

2382.	[bug]		razvan
	Removed logging an error in ping check hook library if
	using lease cache treshold.
	(Gitlab #4129, #4182)

2381.	[bug]		razvan, liyunqing_kylin
	Fixed deadlock in ping-check hooks library. Thanks to
	liyunqing_kylin for reporting and providing a patch.
	(Gitlab #4140, #4177)

2380.	[bug]		razvan, liyunqing_kylin
	Fixed a data race in ping-check hooks library. Thanks to
	liyunqing_kylin for reporting and testing the fix for this
	issue.
	(Gitlab #4164, #4178)

Kea 3.0.1 (stable) released on August 27, 2025

2379.	[build]		tmark
	The library version numbers have been bumped up for the Kea 3.0.1
	stable release.
	(Gitlab #4060)

2378.	[build]*	fdupont, razvan
	Moved Botan crypto backend support to version 3.
	(Gitlab #4057, #3553)

2377.	[bug]		tmark, razvan
	Avoid adding the qualifying-suffix to fully qualified
	host names specified in host reservations.
	(Gitlab #4056, #3949)

2376.	[sec]		tmark
	Corrected an issue in kea-dhcp4 that caused the server
	to abort if a client sent a unicast request with particular
	options, and Kea failed to find an appropriate subnet
	for that client.
	CVE:2025-40779
	(Gitlab #4055, #4048)

Kea 3.0.0 (stable) released on June 25, 2025

2375.	[build]		wlodek
	The library version numbers have been bumped up for the Kea 3.0.0
	stable release.
	(Gitlab #3968)

2374.	[doc]		bscott
	Clarified applicability of Kea Configuration Backend in
	the ARM.
	(Gitlab #3881)

2373.	[doc]		marcin
	Added example subnet selectors to default DHCP configs.
	(Gitlab #3628)

2372.	[build]		andrei
	Kea now generates and installs a pkg-config .pc file.
	(Gitlab #3680)

2371.	[func]		piotrek
	Added a new argument, '--auth-password-file', which provides
	a secure method for supplying a password for basic HTTP
	authentication in kea-shell.
	(Gitlab #3940)

2370.	[build]		andrei
	Unit tests that require root privileges are now run automatically
	on "meson test" by having privileges elevated via sudo.
	(Gitlab #3493)

2369.	[doc]		tmark
	Updated list of elements supporting user-context in ARM.
	(Gitlab #3855)

2368.	[build]		fdupont
	Added the 'runstatedir' configuration option so by
	giving '-D runstatedir=run' one can override the 'var/run'
	default. This variable and its usage are described in
	GNU Coding Standards or autoconf doc since version 2.70.
	Note this variable is not in meson built-in options.
	(Gitlab #3624)

2367.	[func]*		fdupont
	Changed the default value of the High Availability listener
	'restrict-commands' configuration flag to true so commands
	which are not used by the High Availability hook are rejected.
	(Gitlab #3639)

2366.	[doc]		slawek
	Described a new shared network name parameter of the subnetX-list
	commands in ARM.
	(Gitlab #3926)

2365.	[bug]		fdupont
	Removed all references to the build directory from
	scripts when tests configuration option is not enabled.
	(Gitlab #3007)

2364.	[bug]		tmark
	Ping check hook library was corrected to skip
	ping checks when the lease is active or reserved.
	(Gitlab #3858, #3932)

2363.	[bug]		tmark
	Corrected an issue which caused config-get to return
	the full hook library pathname instead of the
	original configuration value of the `library`
	parameter.
	(Gitlab #3937)

2362.	[bug]		tmark
	Ping check hook library will now route
	pings across routers. Prior to this it
	only sent pings to directly connected
	networks.
	(Gitlab #3827)

2361.	[bug]		tmark
	Corrected an issue in logging configuration when
	parsing "syslog:<facility name>".
	(Gitlab #3921)

2360.	[func]*		tmark
	Lease caching is now enabled by default.  The default
	value for ``cache-threshold`` is 0.25,``cache-max-age``
	is left unspecified. It may be disabled at the desired
	scope either by setting ``cache-threshold`` to 0.0 or
	setting ``cache-max-age`` to 0.
	(Gitlab #3659)

2359.	[build]		andrei
	The Autootols build system has been removed and superseded by
	Meson.
	(Gitlab #3734)

2358.	[bug]		tmark
	Fixed an issue in path validation where
	the opening slash in a root-file path such
	as "/myfile.log" is discarded causing the server
	to prepend the supported path to the file name
	rather than reject the entry.
	(Gitlab #3906)

2357.	[func]		tmark
	Security restrictions may now be disabled by adding
	command line option -X to Kea server invocations.
	Supported by kea-dhcp4, kea-dhcp6, kea-dhcp-ddns, and
	kea-ctrl-agent.
	(Gitlab #3902)

2356.	[func]		razvan
	Updated YANG modules by adding only-in-additional-list,
	evaluate-additional-classes, client-classes list, ddns-ttl,
	ddns-ttl-min, ddns-ttl-max, ddns-generated-prefix,
	ddns-override-client-update, ddns-override-no-update,
	ddns-qualifying-suffix, ddns-replace-client-name,
	ddns-send-updates, ddns-update-on-renew,
	ddns-conflict-resolution-mode, hostname-char-replacement and
	hostname-char-set at pool and pd-pool level, added
	excluded-prefixes at pd-pool level. Added trust-anchor,
	cert-file, key-file, cert-required authentication and
	http-headers parameters to control sockets.
	(Gitlab #3907)

2355.	[func]		razvan
	Implemented lease4-wipe and lease6-wipe for database backends.
	The commands are no longer deprecated.
	(Gitlab #3814)

2354.	[doc]		razvan
	The DHCPv4-over-DHCPv6 implementation, perfmon hook library and
	sysrepo features are no longer considered experimental.
	(Gitlab #3920)

2353.	[func]		razvan
	Restricted location of configured scripts in loaded hook
	libraries.
	(Gitlab #3849)

2352.	[bug]		razvan
	Fix error handling when detecting a global reservation for the
	client and global reservatons are explicitly disabled in the
	configuration.
	(Gitlab #3911)

2351.	[doc]		razvan
	Updated documentation and examples related to 4over6 port.
	(Gitlab #3851)

2350.	[doc]		razvan
	Updated documentation and examples related to HTTP/HTTPS socket
	ports used by kea-ctrl-agent, kea-dhcp4, kea-dhcp6, kea-dhcp-ddns
	and High Availability hook library in order to avoid possible
	conflicts.
	(Gitlab #3541)

2349.	[func]		razvan
	The kea-ctrl-agent has been deprecated and it issues a warning
	log message on startup. As of Kea 2.7.2 the Kea servers:
	kea-dhcp4, kea-dhcp6, and kea-dhcp-ddns directly support command
	API connections over HTTPS/HTTP.
	(Gitlab #3916)

2348.	[bug]		razvan, Darwin4053
	Fix arguments order in flex option hook library debug messages.
	(Gitlab #3875)

Kea 2.7.9 (development) released on May 28, 2025

2347.	[build]		andrei
	The library version numbers have been bumped up for the Kea 2.7.9
	development release.
	(Gitlab #3892)

2346.	[sec]*		tmark, fdupont, razvan
	All files and sockets created by Kea servers have been
	restricted to default paths determined at compile time
	which may be overridden by environment variables. This
	includes lease files, log files, forensic log files, control
	channel sockets, and the output from commands such as
	cache-write, lease4-write, and lease6-write. The output
	of config-write is restricted to the directory from which the
	configuration file was read. Use of unsupported paths will
	result in servers emitting errors and refusing to start
	or rejecting commands.  The specifics including the supported
	paths and environment variable names are in the relevant
	ARM sections.
	CVE:2025-32801
	(Gitlab #3831)

2345.	[sec]*		fdupont
	Change the umask to no group write and no other access
	at the entry of Kea server/agent binaries.
	CVE:2025-32803
	(Gitlab #3832)

2344.	[sec]*		tmark
	kea-dhcp4, kea-dhcp6, kea-dhcp-ddns, and kea-ctrl-agent will
	now only load hook libraries from the default installation
	directory.  If a path other than this is specified Kea will
	not load the hook library.  For ease of use, the path may be
	omitted.
	CVE:2025-32801
	(Gitlab #3830)

Kea 2.7.8 (development) released on April 30, 2025

2343.	[build]		wlodek
	The library version numbers have been bumped up for the Kea 2.7.8
	development release.
	(Gitlab #3863)

2342.	[bug]		andrei
	A MySQL error that rarely occurs in unknown circumstances that
	can prevent Kea from renewing leases that have null or invalid
	JSON values in the user_context column is now handled in the
	lease triggers.
	(Gitlab #3763)

2341.	[build]		andrei
	Kea built with Meson is now officially tested. Some bugs related
	to the Meson build system were fixed. Documentation about how to
	build Kea with Meson was added.
	(Gitlab #3732, #3812)

2340.	[func]		tmark
	The subnet commands hook library was modified such that
	the subnet's shared network name is now included for each
	subnet returned by the subnet4-list and subnet6-list
	commands.
	(Gitlab #3811)

2339.	[bug]		tmark
	Corrected an issue which caused kea-dhcp4 to
	NAK requests for an offered lease when a
	conflicting host reservation exists and
	offer-lifetime is greater than zero. The
	server will now remove the unusable lease,
	renew the temporary lease, and send it back
	in a DHCPACK.
	(Gitlab #3555)

2338.	[doc]		tmark
	Clarified how classes impact option order precedence.
	(Gitlab #3748)

2337.	[bug]		tmark
	When generating FQDNs from IP addresses for DDNS,
	kea-dhcp6 will now append a zero to the end of
	prefixes that would otherwise end in a hyphen.
	(Gitlab #3781)

2336.	[func]		razvan
	Added support for syslog backend in forensic log hook library.
	(Gitlab #3569)

Kea 2.7.7 (development) released on March 26, 2025

2335.	[func]		razvan
	The following hook libraries are now open source:
	for the kea-dhcp4 and the kea-dhcp6 servers
	'libdhcp_class_cmds', 'libdhcp_ddns_tuning',
	'libdhcp_flex_id', 'libdhcp_legal_log',
	'libdhcp_host_cache', 'libdhcp_host_cmds',
	'libdhcp_lease_query', 'libdhcp_limits',
	'libdhcp_ping_check', 'libdhcp_radius',
	'libdhcp_subnet_cmds' and for the kea-dhcp-ddns server
	'libddns_gss_tsig'.
	(Gitlab #3333)

2334.	[func]		fdupont
	Added experimental support for registering self-generated
	IPv6 addresses using DHCPv6 (RFC 9686).
	(Gitlab #3683, #3802)

2333.	[build]		andrei, fdupont
	Added meson as a build system.
	(Gitlab #3443, #3729, #3730, #3731)

2332.	[func]		tmark
	Lease reclamation is now skipped and rescheduled
	while DHCP service is disabled. This applies to
	both kea-dhcp4 and kea-dhcp6.
	(Gitlab #3693)

2331.	[bug]		tmark
	Added support for choosing from multiple
	occurrences of the same option based on
	class-tagging. Prior to this the last
	occurrence listed was the only option
	considered.
	(Gitlab #3747)

2330.	[func]		tmark
	The lease-cmds hook library now supports storing
	custom values, referred to as ``binding-variables``,
	within the lease's ``user-context``.  Supported
	in both kea-dhcp4 and kea-dhcp6.
	(Gitlab #3463)

2329.	[bug]		andrei
	An "argument list too long" error message no longer appears when
	the "kea-admin lease-upload" command tries to upload a large set
	of leases. The command is also significantly faster now.
	(Gitlab #3666)

2328.	[build]		andrei
	Kea no longer depends on a PostgreSQL server development header.
	(Gitlab #3711)

2327.	[build]		mgodzina
	The library version numbers have been bumped up for the Kea 2.7.7
	development release.
	(Gitlab #3817)

2326.	[bug]		razvan
	Fixed a bug which was causing the allocation engine to reject the
	lease if a data race caused by a different server updating the
	shared database entries was detected. The entire packet is now
	dropped in this particular case. This applies to both kea-dhcp4
	and kea-dhcp6 servers.
	(Gitlab #3648)

2325.	[bug]		razvan
	Fixed a bug which was causing address allocation counters to be
	negative when client released leases and the server has lease
	affinity and lease reclamation enabled.
	(Gitlab #1336)

2324.	[func]		razvan
	It is not necessary to restart the server to apply changes in the
	TLS configuration. Running the "config-reload" command is
	sufficient. A different address or port must be specified when
	switching from HTTP to HTTPS or from HTTPS to HTTP.
	(Gitlab #3694)

Kea 2.7.6 (development) released on January 29, 2025

2323.	[func]*		fdupont
	Kea now refuses secrets and passwords taken from examples,
	including when not built with unit tests "keatest".
	(Gitlab #3398)

2322.	[bug]		marcin
	Avoid conflicts in DNS cleanup performed by two servers in
	the terminated state in HA.
	(Gitlab #3649)

2321.	[func]		tmark
	Modified kea-dhcp4 and kea-dhcp6 to support
	DDNS behavioral parameters at the pool level.
	(Gitlab #3049)

2320.	[bug]		fdupont
	Fixed a bug where the lease in the released state was not read
	properly.
	(Gitlab #3699)

2319.	[build]		fdupont, q66
	Kea can now build with Boost 1.87. The minimum supported Boost
	version has been bumped up from 1.57 to 1.66. Thanks to q66
	for the patch.
	(Gitlab #3696)

2318.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.7.6
	development release.
	(Gitlab #3724)

2317.	[bug]		razvan
	Fixed a bug related to database connection recovery which was
	preventing the server to resume processing packets because the
	dhcp state was never re-enabled.
	(Gitlab #3727)

2316.	[func]		razvan
	The kea-dhcp4, kea-dhcp6 and kea-dhcp-ddns servers now support
	multiple http/https connections. The can be configured in the
	"control-sockets" list.
	(Gitlab #3082, #3721)

2315.	[func]		razvan
	Kea can now load hook libraries specifying only the binary name.
	It uses the default hook libraries installation path which is
	provided in the config report as "Hooks directory".
	(Gitlab #2101, #3579)

2314.	[func]		tmark
	Added three new parameters which may be used to
	influence DNS TTL to kea-dhcp4 and kea-dhcp6:
	'ddns-ttl', 'ddns-ttl-min', and 'ddns-ttl-max'.
	(Gitlab #2819, #3663)

Kea 2.7.5 (development) released on December 11, 2024

2313.	[doc]		marcin
	Clarified that the FLQ allocator should not be used with shared
	lease database.
	(Gitlab #3577)

2312.	[doc]		fdupont
	Made clear that when a HTTP control channel is reconfigured
	with the same address and port the listener socket is reused
	so any TLS setup change is ignored.
	(Gitlab #3255)

2311.	[doc]		piotrek
	Added a more extensive definition of the tuple DHCP option
	type in the ARM documentation.
	(Gitlab #3661)

2310.	[bug]		andrei
	Kea servers no longer increase in memory when being reconfigured.
	(Gitlab #3652)

2309.	[build]		mgodzina
	The library version numbers have been bumped up for the Kea 2.7.5
	development release.
	(Gitlab #3695)

2308.	[bug]		marcin
	Prevent the servers from returning to HA maintenance
	states after receiving the ha-maintenance-cancel command
	while they also respond to the DHCP traffic.
	(Gitlab #3655)

2307.	[func]		tmark
	The parameter "client-class" (a single class name) in
	shared networks, subnets, and pools has been replaced with
	"client-classes" (a list of one or more class names).
	This applies to both kea-dhcp4 and kea-dhcp6.
	(Gitlab #3592)

2306.	[func]		fdupont
	Added a new "http-headers" parameter to the CA and
	HTTP control socket configuration sections which can
	be used to specify extra 'name: value' headers to be
	added to HTTP responses.
	(Gitlab #3609)

2305.	[func]		tmark
	Both kea-dhcp4 and kea-dhcp6 servers will now
	log a warning message when they detect classes that
	configure lease life time parameters (e.g. 'valid-lifetime',
	'preferred-lifetime') while also setting
	'only-in-additional-list' to true.
	(Gitlab #2736)

2304.	[bug]		tmark
	Modified both kea-dhcp4 and kea-dhcp6 to avoid
	generating DDNS update requests when leases are
	being reused due to lease caching.
	(Gitlab #3257)

Kea 2.7.4 (development) released on October 30, 2024

2303.	[func]		tmark
	The parameters 'require-client-classes' and
	'only-if-required' have been replaced with 'evaluate-
	additional-classes' and 'only-in-additional-list'
	respectively and deprecated. This applies to both
	kea-dhcp4 and kea-dhcp6.
	(Gitlab #3587)

2302.	[func]		tmark
	Options may now be configured with a list of client
	classes for which they apply.  This feature is referred to
	as "option class-tagging" and is supported by both
	kea-dhcp4 and kea-dhcp6.
	(GitLab #3583)

2301.	[func]		fdupont
	Added support of DHCPv4 "cablelab-client-conf" (122) option
	and its associated suboptions specified by RFC 3495, 3594
	and 3634 in the "cablelabs-client-conf" space at the
	exception of the suboption 3.
	(Gitlab #3404)

2300.	[build, func]	andrei
	Standalone fuzz target binaries used in fuzz testing were added
	to the "fuzz" directory.
	(Gitlab #3605)

2299.	[func]*		fdupont
	Required classes are now evaluated in the same order as
	for option data, i.e. (pd-)pool, subnet and shared network.
	Before the order was reversed but this feature was not
	used.
	(Gitlab #3590)

2298.	[bug]		fdupont
	Fixed a bug where Kea did not return the value of
	vendor-encapsulated-options when redefined in a client class.
	(Gitlab #3582)

2297.	[build]*	fdupont
	Made the Botan boost TLS support mandatory. Changed
	the configure argument to --with-botan using
	the Botan pkg-config library name e.g. "botan-2".
	(Gitlab #3552)

2296.	[func]*		fdupont
	Classes included in 'require-client-classes' that do
	not have test expressions will now be unconditionally
	added to the client's list of matching classes.
	Previously they were ignored.
	(Gitlab #3388)

2295.	[func]		fdupont
	Relaxed the lease, host and config database backend types
	in the configuration syntax. This change is introduced to
	better handle optional backends provided in hooks, such as
	currently available MySQL or PostgreSQL hooks.
	(Gitlab #3585)

2294.	[func]		fdupont
	Added support of DHCPv6 "ntp-server" (56) option
	specified by RFC 5908 and its associated suboptions
	in the "v6-ntp-server-suboptions" space.
	(Gitlab #3390)

2293.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.7.4
	development release.
	(Gitlab #3639)

2292.	[doc]		tmark
	Updated the ARM to include and an explanation for why
	the default values for 'calculate-tee-times' are
	different for kea-dhcp4 and kea-dhcp6.
	(Gitlab #3538)

2291.	[func]		fdupont
	Added three new API commands: subnet4-select-test and
	subnet4o6-select-test to kea-dhcp4, and subnet6-select-test
	to kea-dhcp6.  These commands can be used to check which
	subnet the server will select based on given input parameters.
	(Gitlab #2974)

2290.	[bug]		razvan
	Fixed applying 'output_options' when using the 'config-set'
	command. Deprecated 'output_options' which will be removed in
	future versions. Configurations should be updated by switching
	to using 'output-options' instead.
	(Gitlab #3594)

2289.	[func]*		razvan
	Support for lease, host, and config backends for MySQL and
	PostgreSQL have been consolidated into a single hook library for
	each data base: 'libdhcp_mysql.so' and 'libdhcp_pgsql.so'
	respectively.
	(Gitlab #3536)

2288.	[bug]		marcin
	Prevent the clients from declining expired or released leases.
	Only a valid lease assigned to the declining client can now
	be declined. When a misbehaving client declined a lease it did
	not own it often led to inconsistent statistics of assigned and
	declined leases.
	(Gitlab #3565)

2287.	[bug]		razvan
	Fixed the serialization of 'retry-on-startup' database
	configuration parameter as boolean instead of string.
	(Gitlab #3578)

Kea 2.7.3 (development) released on August 25, 2024

2286.	[func]		fdupont
	Reorganized UNIX control socket code.
	(Gitlab #3506)

2285.	[build]		tomek
	Changed image type in the Developer's guide from PNG to SVG.
	This drastically reduced the size of the generated docs
	(from 2.7GB to 560MB).
	(Gitlab #3566)

2284.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.7.3
	development release.
	(Gitlab #3597)

2283.	[func]		tmark
	The order or precedence of options specified in a
	template class and its spawned classes has been
	reversed.  An option specified in a spawned class now
	takes precedence over the same option if specified in
	the template class. This change applies to both
	kea-dhcp4 and kea-dhcp6.
	(Gitlab #3576)

2282.	[bug]		razvan
	Fixed a bug caused by starting listeners when checking the
	configuration using the '-T' command line parameter. This was
	also causing the check to fail if loading the High Availability
	hook library.
	(Gitlab #3542)

2281.	[bug]		andrei
	An issue was fixed where kea-admin and kea-lfc were not found by
	the Kea DHCP servers when installed via a custom defined sbindir.
	(Gitlab #3504)

2280.	[func]		fdupont
	IPv6 host reservation syntax now accepts a new entry
	"excluded-prefixes": a pd-exclude option (RFC6603)
	can now be added into an iaprefix option carrying
	a reserved prefix.
	(Gitlab #1387)

2279.	[build]		pprindeville
	Replace the cut and rev utilities with shell variable expansions,
	improving compatibility with minimal setups on embedded systems.
	(Gitlab #3533)

2278.	[build]		dim
	Replace ``std::basic_string<uint8_t>`` with equivalent
	``std::vector<uint8_t>`` constructs, since the former has been
	deprecated for a while in libc++, and has been completely
	removed as of libc++ 19.
	(Gitlab #3532)

Kea 2.7.2 (development) released on August 28, 2024

2277.	[build]		andrei
	"libca_rbac.so" is now a symbolic link to "libdhcp_rbac.so".
	(Gitlab #3550)

2276.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.7.2
	development release.
	(Gitlab #3549)

2275.	[func]		andrei
	When running with High-Availability (HA) enabled, the status-get
	command now includes in its response the system time for each HA
	node and the clock skew in seconds between active peers.
	(Gitlab #3513)

2274.	[doc, func, build]		andrei
	The events that logged EVAL_RESULT now log a different message
	for each triggering event. As a result, the message was split
	into eight messages. The messages that were logged at INFO level
	are now logged at the same level as their DEBUG counterparts:
	level 50. Fixed an issue that was causing some messages to not
	appear under the "Kea Messages Manual" section. A new section
	called "Kea Debug Messages By Log Level" is added to the ARM.
	(Gitlab #1945)

2273.	[func]*		fdupont
	The RBAC (role-based access control) hook library was
	extended to support the new HTTP/HTTPS control socket
	of Kea servers. Note its name changed too from
	"libca_rbac.so" to "libdhcp_rbac.so".
	(Gitlab #3483)

2272.	[perf]		fdupont
	Implementation of "and", "or" and "ifelse" expressions
	was changed to evaluate sub-expressions only when needed.
	(Gitlab #3502)

2271.	[func]		fdupont
	Extended the control-socket entry taking a map
	specifying a UNIX/LOCAL control socket for DHCPv4,
	DHCPv6 and DHCP-DDNS servers to a control-sockets
	list of maps taking also a HTTP/HTTPS control socket
	with authentication and TLS parameters from the
	Control Agent.
	(Gitlab #3477)

2270.	[bug]		andrei
	Fixed flag -P|--port not working in kea-admin on mysql db-init,
	mysql db-upgrade, pgsql db-upgrade, pgsql lease-dump.
	pgsql db-upgrade now properly reports an upgrade failure instead
	of attempting to upgrade to subsequent schema versions.
	(Gitlab #2882)

2269.	[func]		tmark
	Extended kea-dhcp4 and kea-dhcp6 lenient option parsing
	to drop FQDN options such as v4-lost and v6-access-domain
	if they contain malformed FQDNs.
	(Gitlab #3492)

Kea 2.7.1 (development) released on July 31, 2024

2268.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.7.1
	development release.
	(Gitlab #3515)

2267.	[bug]		tmark
	Corrected an issue in MySQL config back end that
	causes preferred life time values to be overwritten
	when updating client classes via remote-set-class6.
	command.
	(Gitlab #3469)

2266.	[bug]		fdupont
	Improved the code handling multiple instances of
	the same v4 option according to RFC 3396.
	(Gitlab #3440)

2265.	[bug]*		fdupont
	The 'control-socket' ('control-socket.socket-name' and
	'control-socket.socket-type') was removed from the global maps
	which can be managed by the config backend because in fact if
	it is possible to change values they are not applied.
	(Gitlab #3479)

2264.	[bug]*		tmark
	Corrected an issue with overlapping enum values
	for option definition data type.  This was causing
	option definitions of type "record", created via
	config backend commands, to not load properly when
	fetched from the back end.
	(Gitlab #3476)

2263.	[func]		fdupont
	RFC 8925 "IPv6-Only Preferred Option for DHCPv4" is now
	fully implemented: 0.0.0.0 address can be offerred.
	(Gitlab #3094)

2262.	[bug]		marcin
	Corrected a bug in storing and fetching the encapsulated DHCP
	options from the configuration backend. These options were
	sometimes not returned when they were specified at the subnet,
	shared network or client class level.
	(Gitlab #3481)

2261.	[bug]		razvan
	Reset the local and remote disabled state when applying
	configuration. The dhcp-state is now included in the 'status-get'
	command. It indicates if the dhcp service is enabled or the
	reason why it is disabled (user command, HA command or database
	connection failure).
	(Gitlab #3446)

2260.	[bug]		razvan
	Fixed a file descriptor leak in the High Availability hook
	library.
	(Gitlab #3449)

2259.	[func]		fdupont
	All permissions for other users are now removed from files
	created by Kea agents and servers.
	(Gitlab #3050)

Kea 2.7.0 (development) released on June 26, 2024

2258.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.7.0
	development release.
	(Gitlab #3459)

2257.	[func]		andrei
	Exceptions thrown from Sysrepo while processing a NETCONF config
	change or while sending notifications are now caught and logged.
	The configuration is not applied in that case, but at least
	kea-netconf recovers instead of crashing. These scenarios are
	corner cases that are likely not found in production and that
	trigger bugs in upstream code.
	(Gitlab #3435)

2256.	[func]		marcin
	High Availability hook now supports lease affinity for the
	released leases. When a lease is released but left in the
	database for a possible re-allocation this information is
	propagated to the partner server. Previously, a released
	lease was always deleted in the partner, causing a loss of
	the association between the lease and the client in the
	partner's lease database. This change introduces a new
	"released" lease state which appears for the released leases
	in the lease database and in the lease updates exchanged
	between the HA partners. It is a backward incompatible change
	for the HA partners that haven't been upgraded to the latest
	Kea version. They will reject the lease updates for the
	released leases holding the new state value.
	(Gitlab #3246)

2255.	[bug]		razvan
	The environment is now inherited by kea-lfc when started by
	the Kea DHCP server.
	(Gitlab #3450)

2254.	[func]		tmark
	Added two API commands to Perfmon hook library:
	"perfmon-control" which can be used to enable
	or disable monitoring and reporting at runtime;
	and "perfmon-get-all-durations" which fetches
	a snapshot of raw performance data.
	(Gitlab #3328)

2253.	[func]		fdupont
	Added the predicate token "match" which evaluates regular
	expression matching to classification expression.
	(Gitlab #3170)

2252.	[bug]		fdupont
	Corrected an issue in kea-dhcp6 which caused reserved prefixes
	to not be removed when their host reservation was deleted by
	ip address.
	(Gitlab #3375)

2251.	[func]		tmark
	A new global statistic, "queue-mgr-queue-full", has been
	added to kea-dhcp-ddns.  It tracks the number of times
	then receive queue for DNS update requests (NCRs) has
	reached maxium capacity.
	(Gitlab #2611)

2250.	[func]		razvan
	Kea now pretty prints options with binary data whenever possible.
	(Gitlab #2844)

2249.	[func]		razvan
	Made v6 relay options 18 (interface-id), 37 (remote-id) and
	38 (subscriber-id) available to the run script hook library.
	(Gitlab #3035)

2248.	[bug]		tmark
	Fixed a corner-case issue in kea-dhcp6 that was
	causing it to attempt to update a lease for an address
	with a generated FQDN even though the address was not
	available to be leased.
	(Gitlab #3356)

Kea 2.6.0 (stable) released on May 29, 2024

2247.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.6.0
	stable release.
	(Gitlab #3430)

2246.	[bug]		razvan
	Permit configuring pool-id in pd-pools which can be useful in
	statistics. Previously, Kea would emit an error when configured
	with PD pool ids.
	(Gitlab #3424)

2245.	[doc]		tomek
	Many already supported RFCs are now listed in the Supported
	DHCP standards and Supported DHCPv6 standards in the Kea
	Administrator Reference Manual (ARM).
	(Gitlab #3346)

2244.	[func]		mgodzina
	The lease4-wipe and lease6-wipe commands now log a deprecation
	warning.
	(Gitlab #3427)

2243.	[func]		razvan
	Updated yang modules: removed qualifying-suffix,
	override-no-update, override-client-update,
	replace-client-name, generated-prefix, hostname-char-set
	and hostname-char-replacement from dhcp-ddns, removed
	reservation-mode and added retry-on-startup,
	stash-agent-options and ddns-conflict-resolution-mode.
	(Gitlab #3301)

2242.	[func]		razvan
	Removed deprecated command "libreload".
	(Gitlab #2960)

2241.	[doc]		tomek
	Several aspects of lease_cmds documentation were updated.
	The examples and error messages were corrected.
	(Gitlab #3340)

2240.	[doc]		slawek
	Updated the documentation to consider the restricted default
	privileges provided in Postgres 15 when creating a database.
	(Gitlab #2773)

2239.	[func]*		razvan
	Removed deprecated parameter: "reservation-mode".
	(Gitlab #2959)

2238.	[func]*		razvan
	Removed the following deprecated parameters from "dhcp-ddns"
	global element: "generated-prefix", "qualifying-suffix",
	"replace-client-name", "override-client-update",
	"override-no-update", "hostname-char-replacement",
	"hostname-char-set".
	(Gitlab #2958)

2237.	[doc]		slawek
	Added an instruction to the ARM on how to verify the PGP
	signature of the tarball with the source code.
	(Gitlab #3021)

2236.	[doc]		marcin
	Documented incompatibility of the subnet reselection by
	RADIUS with the hub-and-spoke configurations in HA.
	(Gitlab #3252)

2235.   [bug]       tmark
	Remove defaulted on-update behavior from 'expire'
	columns in lease4 and lease6 tables for MySQL/Mariadb
	lease databases.  Corrects an issue when upgrading from
	releases prior to Kea 2.4.0 to Kea 2.4.0 or later with
	Mariadb version 10.10 or later that causes all existing
	v6 leases to expire immediately.
	(Gitlab #3396)

2234.	[build]		andrei
	Kea now builds with MySQL client libraries that have removed the
	mysql_ssl_set function which was deprecated in MySQL 8.0.35.
	The mysql_options function is used instead.
	(Gitlab #3256)

2233.	[bug]		razvan
	Fixed a bug which was causing the status-get command to return
	an error when the lease database connection had not yet been
	established.
	(Gitlab #3223)

2232.	[func]*		fdupont
	Auto-generated subnet identifiers are no longer supported.
	Configurations that contain subnets without explicit subnet
	identifiers (i.e. without an "id" entry) will now be rejected.
	(Gitlab #2961)

2231.	[func]		fdupont
	The "ip-address" configuration parameter in the "relay" map has
	been removed. In its place, use "ip-addresses" introduced in
	Kea 1.4.
	(Gitlab #3378)

2230.	[func]		tmark
	Both kea-dhcp4 and kea-dhcp6 will now emit an INFO
	level log statement for each packet received and
	sent by the server. Formerly these logs were only
	emitted at DEBUG level.
	(Gitlab #3203)

2229.	[bug]		tmark
	Kea now builds with MySQL client libraries that have removed the
	the MYSQL_OPT_RECONNECT feature and, in those cases, no longer
	explicitly disables the reconnect feature, but relies on its
	default disabled state.
	(Gitlab #3311)

Kea 2.5.8 (development) released on April 30, 2024

2228.	[build]		piotrek
	The library version numbers have been bumped up for the Kea 2.5.8
	development release.
	(Gitlab #3355)

2227.	[func]		fdupont
	Implemented the stash-agent-options global parameter
	for DHCPv4 (new feature from ISC DHCP allowing to
	renew reserved address when the host reservation identifier
	is based on the dhcp-agent-options option added by a relay.
	(Gitlab #2976)

2226.	[func]		piotrek
	Added information about transaction ID in all possible
	places in loggers: alloc-engine, bad-packets, ddns,
	eval, leases, options, packets.
	(Gitlab #2820)

2225.	[func]		marcin
	Ensure backward compatibility of High Availability
	between Kea 2.5.8+ and earlier versions. It introduces
	a new origin-id argument to the dhcp-enable, dhcp-disable
	and ha-sync-complete-notify commands. It is ignored by the
	earlier Kea versions. The origin argument is sent in addition
	to the origin-id and has the format recognizable by the old
	Kea versions.
	(Gitlab #3344)

2224.	[func]		andrei
	Printing the version now mentions if premium is included and
	shows the git commit hash for the premium source code repository
	if the executable is built from sources.
	(Gitlab #3254)

2223.	[bug]		tmark
	Fixed an issue in PerfMon hook library which causes
	the kea6_server to crash when the server responds
	to a client query for which no subnet was selected.
	(Gitlab #3347)

2222.	[bug]		piotrek
	Fixed a bug in host_cmds. When PostgreSQL was used as
	hosts database storage, reservation-del command called
	with given IPv6 host address and the subnet Id deleted
	all IPv6 hosts in given subnet.
	Corrected the issue so that now only given host
	reservation is deleted.
	(Gitlab #3294)

2221.	[bug]		tmark
	Corrected an index on the dhcp4_servers table
	in the PostgreSQL schema.
	(Gitlab #2957)

2220.	[bug]		marcin
	Exclude packets ignored during load balancing from the
	pkt6-receive-drop statistics. The packets dropped by the
	HA hook library during subnet selection are counted in
	the pkt4-receive-drop and pkt6-receive-drop statistics.
	(Gitlab #3125)

2219.	[bug]		marcin
	Corrected an issue in processing the server-name argument
	of the ha-sync command. The argument was ignored when the
	synchronization with a backup server was performed.
	(Gitlab #3276)

2218.	[func]		marcin
	Addressed an inconsistent state of the High Availability
	service that occurs when one of the terminated services is
	restarted and another one is not. The restarted service waits 10
	minutes for the partner restart. If the partner is not restarted
	the service transitions to the terminated state to continue
	responding to the DHCP traffic.
	(Gitlab #3250)

2217.	[func]		fdupont
	Extended the lenient-option-parsing compatibility
	flag to ignore DHCPv4 fqdn (81) and DHCPv6 client-fqdn
	(39) options with some invalid domain names (e.g.
	beginning with an empty label).
	(Gitlab #3289)

2216.	[func]		tmark
	PerfMon hook library is now functional. It accumulates
	and reports performance data, and supports alarms. Still
	lacking are API commands.
	(Gitlab #3297)

2215.	[bug]		tmark
	Corrected an issue that can cause kea-dhcp-ddns to
	stop processing queued requests. Thanks to Shawn
	Routhier from Infoblox for reporting the issue.
	(Gitlab #3295)

2214.	[func]		tmark
	PerfMon hook library can now parse its configuration
	and the ARM has been updated with more detailed
	information. Functionality is still limited.
	(Gitlab #3278)

Kea 2.5.7 (development) released on March 27, 2024

2213.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.7
	development release.
	(Gitlab #3304)

2212.	[build]		tomek
	The jinja dependency, used in building documentation, was
	updated.
	(Gitlab #3079)

2211.	[bug]		razvan, tmark
	Corrected an issue in kea-dhcp4 and kea-dhcp6 that
	causes an infinite loop when database does not exist
	at startup introduced by #2692.
	(Gitlab #3300)

2210.	[func]		piotrek
	Added libkea-dhcp++, libkea-cfgclient, libkea-d2srv,
	libkea-dhcpsrv, libkea-util and libkea-util-io headers that were
	missing after Kea install. Now all needed headers are installed.
	(Gitlab #3267)

2209.	[func]		fdupont
	Some hooks using multi-threading postpone their startup until
	after the configuration has been completed.  If the hook
	subsequently failed the startup, the error would not have been
	properly propagated. The fix ensures that the errors are
	reported during the configuration stage.
	(Gitlab #2692)

Kea 2.5.6 (development) released on February 28, 2024

2208.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.6
	development release.
	(Gitlab #3261)

2207.	[func]		piotrek
	Kea now supports DNR options as specified in RFC9463,
	RFC9461, RFC9460. The option may be configured using
	convenient notation, where Kea takes care of complex
	option encoding to be inline with RFCs.
	(Gitlab #3141)

2206.	[func]		andrei
	DHCP servers now initialize the database schema automatically on
	startup or on reconfiguration if there is at least one database
	backend configured and if the configured database is empty.
	(Gitlab #3025)

2205.	[func]		tmark
	Perfmon hook library now dumps the packet event stack
	of query packets to debug logging after they have been
	processed.
	(Gitlab #3231)

2204.	[func]		tmark
	The skeleton of a new open source hook library,
	libdhcp_perfmon.so, has been added.  The library is
	still in development and does not yet provide any functionality.
	(Gitlab #3242)

Kea 2.5.5 (development) released on January 31, 2024

2203.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.5
	development release.
	(Gitlab #3235)

2202.	[func]		razvan
	The Configuration Backend now supports scalar parameters
	contained by top level global maps: 'compatibility',
	'control-socket', 'dhcp-ddns', 'expired-leases-processing',
	'multi-threading', 'sanity-checks', 'server-id' and
	'dhcp-queue-control'.
	(Gitlab #1790)

2201.	[func]		andrei
	To facilitate setting multiple option-data entries with same code
	and space, but different data, the set of keys for the
	option-data list was extended with the "data" leaf in YANG
	modules.
	(Gitlab #3198)

2200.	[func]		piotrek
	Kea now supports new DHCPv4 option code 121, Classless Static
	Route option defined in RFC 3442.
	Option may be defined in binary format and also as a string
	using convenient static route notation.
	(Gitlab #3074)

2199.	[func]		marcin
	Added support for hub-and-spoke high availability configuration.
	(Gitlab #3106, #3178)

2198.	[func]		razvan
	A new log message
	DHCPSRV_CFGMGR_IP_RESERVATIONS_UNIQUE_DUPLICATES_DETECTED is
	shown when multiple reservations are detected for the same IP
	address.
	(Gitlab #3108)

2197.	[func]		razvan
	Added support for database connection retry on server startup.
	The new 'retry-on-startup' parameter controls this behavior along
	with the other existing parameters: 'on-fail',
	'max-reconnect-tries' and 'reconnect-wait-time'.
	(Gitlab #3019)

2196.	[func]		tmark
	The ping-check hook library can now be used with kea-dhcp4
	in either multi-threaded or single-threaded mode.
	(Gitlab #3107)

2195.	[func]		tmark
	Added a new hook point to kea-dhcp4, "lease4_server_decline".
	DHCPv4 leases declined by ping-check hook library are now
	propagated to HA peers.
	(Gitlab #3110)

Kea 2.5.4 (development) released on November 29, 2023

2194.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.4
	development release.
	(Gitlab #3173)

2193.	[func]		tmark, piotrek
	The ping-check hook library is now functional.  It provides
	the ability of kea-dhcp4 to check the availability of an
	address prior to offering it to a client using ICMP ECHO
	REQUESTs.
	(Gitlab #3084)

2192.	[func]		razvan
	The packet logging is now more consistent between DHCPv4 and
	DHCPv6. Also, extra details are now logged.
	(Gitlab #3109)

2191.	[doc]		andrei
	The new RADIUS hook library is now operational. Documentation has
	been updated. A section about differences to the old RADIUS hook
	library is included.
	(Gitlab #2442)

Kea 2.5.3 (development) released on October 25, 2023

2190.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.3
	development release.
	(Gitlab #3118)

2189.	[doc]		tomek
	Security reporting process described in a Github-friendly format.
	There is no new information, mostly pointers to already existing
	documents.
	(Gitlab #3080)

2188.	[bug]		razvan
	Fixed a race condition in free lease queue allocator.
	(Gitlab #3111)

2187.	[func]		tmark
	To facilitate use in containers, the restriction from listening
	on 0.0.0.0 or :: addresses has been removed from kea-dhcp-ddns.
	The server will now issue a warning if configured to use either
	address.
	(Gitlab #3116)

2186.	[bug]		andrei
	Fixed interface redetection which had stopped working since
	Kea 2.3.6.
	(Gitlab #3017)

2185.	[func]		razvan
	Added extended log messages: DHCP4_DISCOVER, DHCP4_REQUEST,
	DHCP6_PROCESS_IA_NA_SOLICIT, DHCP6_PROCESS_IA_PD_SOLICIT, which
	include the hint address in the client request. The log message
	tag DHCP4_LEASE_ADVERT has been renamed to DHCP4_LEASE_OFFER.
	(Gitlab #2918)

2184.	[bug]		razvan
	Fixed a bug in evaluated expression parser which was not properly
	handling escaped null characters.
	(Gitlab #3086)

2183.	[bug]		andrei
	Fixed a bug where one of the commands that retrieve statistic
	values sent to the kea-ctrl-agent would get an overflow error in
	the response if the inquired statistic was intended to have a big
	integer data type, and if the integer value would not be
	representable on 64 bits. Affected statistics are "total-nas" and
	"total-pds", and the bug only manifests if the inquired pool, or
	the inquired subnet's aggregated pool space, is large enough.
	Prior to this fix, commands would get a correct response over
	unix socket.
	(Gitlab #3068)

Kea 2.5.2 (development) released on September 27, 2023

2182.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.2
	development release.
	(Gitlab #3085)

2181.	[func]		razvan
	Added additional tokens which evaluate string expressions:
	"lcase" which converts to lower case and "ucase" which
	converts to upper case.
	(Gitlab #3048)

2180.	[build]		andrei
	Apart from enabling log4cplus's own logging, and adding more
	sanity checks in DNS code, the --enable-debug configure flag
	now also makes the compiler produce more abundant debugging
	information that can be read by a debugger.
	(Gitlab #1520)

2179.	[doc]		piotrek
	Updated Developer's Guide with information about new hook
	point "lease4_offer".
	(Gitlab #3067)

2178.	[doc]		andrei
	Clarified in the ARM that DHCPv6 clients with unstable DUIDs can
	be handled using the flex-id library. The configuration examples
	that can help with that are found in the flex-id documentation.
	(Gitlab #181)

2177.	[func]		piotrek
	Implemented new DHCPv4 hook point "lease4_offer".
	The callout is executed after the server has received
	the DHCPDISCOVER and the DHCPOFFER has been constructed
	but not yet sent to the client.
	(Gitlab #3038, #3063)

2176.	[doc]		piotrek, razvan
	Updated ARM docs with new configuration key "output-options" and
	alias "output_options". All config examples, where previous
	"output_options" key appeared, were updated.
	(Gitlab #2904, #3004)

Kea 2.5.1 (development) released on August 30, 2023

2175.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.5.1
	development release.
	(Gitlab #3026)

2174.	[func]		fdupont
	Added a new information message which displays the
	client and the transaction identification information
	for received queries between message unpacking and
	first classification.
	(Gitlab #2854)

2173.	[bug]		tmark
	Fixed a sporadic failure of IOSignaltest.mixedSignals
	unit test.  Test no longer relies on signals arriving
	in order they are sent as it cannot be guaranteed.
	(Gitlab #2954)

2172.	[func]		fdupont
	Completed and improved logs showing what client classes
	are assigned to queries during processing.
	(Gitlab #2908)

Kea 2.5.0 (development) released on July 26, 2023

2171.	[build]		andrei
	The library version numbers have been bumped up for the Kea 2.5.0
	development release.
	(Gitlab #2990)

2170.	[build]		fdupont
	Moved from C++ 11 to C++ 14 as the minimal C++ version
	which must be supported by the C++ compiler tobuild Kea.
	(Gitlab #2876)

2169.	[bug]		marcin
	Applied a workaround in the connection to MySQL that prevents
	potential crashes in libmysqlclient library when connection
	to the database is lost and re-established.
	(Gitlab #2792)

2168.	[func]		fdupont
	Cross-reference tables to bind relay and remote
	identifiers from extended info of DHCPv6 leases
	were added to SQL backends. A new command
	"extended-info6-upgrade" (re)builds these tables
	making leases visible to Bulk Lease Queries.
	(Gitlab #2869)

2167.   [func]      tmark
	The kea-dhcp<4/6> parameter, ddns-use-conflict-resolution,
	has been deprecated and replaced with
	ddns-conflict-resolution-mode.  The new parameter supports
	four modes of behavior pertaining to DDNS update conflict
	resolution: check-with-dhcid, no-check-with-dhcid,
	check-exists-with-dhcid, and no-check-without-dhcid.
	Thanks to Shawn Routhier from Infoblox for contributing
	the patch to implement this feature.
	(Gitlab #2276)

Kea 2.4.0 (stable) released on July 05, 2023

2166.	[build]		mgodzina
	The library version numbers have been bumped up for the Kea 2.4.0
	stable release.
	(Gitlab #2939)

2165.	[bug]		marcin
	DHCP options configured in the host database are now returned
	with their encapsulated options to the clients.
	(Gitlab #2826)

2164.	[bug]		razvan
	Added checks to catch invalid prefix/prefix-len combinations in
	commands that create or update pools, leases, and reservations.
	(Gitlab #2725)

2163.	[build]		slawek
	Dropped the Kea connector for Python 2.
	(Gitlab #2467)

2162.	[doc]		marcin
	Documented renaming operation-target values in host_cmds hook
	library. The "primary" was renamed to "memory", and the
	"alternate" was renamed to "database".
	(Gitlab #2901)

2161.	[doc]		fdupont
	Clarified how Kea treats situations where there are multiple
	reservations for the same host.
	(Gitlab #2745)

2160.	[doc]		tomek
	Added clarification about RFC3046 (Relay agent option) support,
	with some examples how to use its content.
	(Gitlab #2887)

2159.	[bug]		razvan
	Fixed a crash when splitting long options or sending user defined
	options when multi-threading is enabled. Also fixed some cases
	when options are not properly split if the serialized data
	reaches the end of the 255 bytes long boundary.
	(Gitlab #2942)

2158.	[func]		piotrek
	A new command named "reservation-get-by-address" is now available
	in the host_cmds hook library. It returns all host reservations
	for given IP address either in all subnets or in a given subnet.
	(Gitlab #2795)

2157.	[func]*		fdupont
	Added a warning issued when the configuration contains subnets
	without explicit subnet identifiers (without "id" entry). The
	auto-generated subnet identifiers are now deprecated.
	(Gitlab #2866)

2156.	[func]		razvan
	Added an optional 'pool-id' parameter that can be used to enable
	per-pool statistics. Supported by kea-dhcp4 and kea-dhcp6 for all
	pool types.
	(Gitlab #2898)

2155.	[func]		fdupont, tomek
	Added the config-hash-get command which returns the
	SHA-256 hash of the current configuration, helping
	in detecting changes. Updated config-get, config-set
	commands to also return SHA-256 hash.
	(Gitlab #2707)

2154.	[doc]		darren
	Corrected minor typo in table in section 8.2.10 of the ARM where
	type was shown as ipv6-address and should have said ipv4-address.
	(Gitlab #2913)

2153.	[doc]		darren
	Changed wording of documentation of ip-reservations-unique
	flag to clarify which host reservation backends support false.
	(Gitlab #2900)

2152.	[doc]		razvan
	Added documentation and unittests for counters by pool ID.
	(Gitlab #145, #2883)

2151.	[bug]		marcin
	Corrected a bug in the host manager that affected getting a host
	by an IPv6 address or delegated prefix. This query returned only
	partial host information. It lacked other IPv6 reservations and
	some DHCP options.
	(Gitlab #2931)

2150.	[bug]		marcin
	Fixed a bug in encapsulating DHCP options fetched from the config
	backend. The suboptions are now included in the top-level options
	they belong to.
	(Gitlab #2881)

2149.	[doc]		andrei
	The vendor options documentation has been improved.
	(Gitlab #2793)

2148.	[build]		tmark
	The include file, cfg_globals.h, has been added to the
	to dhcpsrv/Makefile.am such that it now gets installed.
	Prior to this it was omitted from installation.
	(GitLab #2608)

2147.	[doc]		andrei
	There are now more cross-references in the ARM. Commands and hook
	libraries link to their own section. Programs link to their
	manual pages.
	(Gitlab #2554)

2146.	[func]		piotrek
	Making DHCP4_PACKET_DROP_* and DHCP6_PACKET_DROP_* debug prints
	more verbose. The prints are including now hwaddr for DHCP4 and
	duid for DHCP6.
	(Gitlab #2865)

2145.	[bug]		piotrek
	Fixed a bug in kea-admin script where lack of lease type argument
	was not caught correctly and kea-lfc was called without -4 or -6
	DHCP version.
	(Gitlab #2855)

Kea 2.3.8 (development) released on May 31, 2023

2144.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.3.8
	development release.
	(Gitlab #2885)

2143.	[func]		razvan
	Added v4 statistic counters per pool:
	subnet[id].pool[id].assigned-addresses
	subnet[id].pool[id].cumulative-assigned-addresses
	subnet[id].pool[id].declined-addresses
	subnet[id].pool[id].reclaimed-declined-addresses
	subnet[id].pool[id].reclaimed-leases
	subnet[id].pool[id].total-addresses
	Added v6 statistic counters per pool:
	subnet[id].pool[id].assigned-nas
	subnet[id].pd-pool[id].assigned-pds
	subnet[id].pool[id].cumulative-assigned-nas
	subnet[id].pd-pool[id].cumulative-assigned-pds
	subnet[id].pool[id].declined-addresses
	subnet[id].pool[id].reclaimed-declined-addresses
	subnet[id].pool[id].reclaimed-leases
	subnet[id].pd-pool[id].reclaimed-leases
	subnet[id].pool[id].total-nas
	subnet[id].pd-pool[id].total-pds
	Counters are stored in the lease storage and after schema
	upgrade all existing leases are considered to be part of pool
	ID 0. On lease update, the counters will be updated accordingly
	including pool IDs and statistics will converge to real values
	over time.
	(Gitlab #145)

2142.	[func]		piotrek
	New command option was added to perfdhcp: --or.
	It allows to insert extra option(s) to relayed DHCPv6 message
	at given level of encapsulation. For now only the first level of
	encapsulation is supported.
	(Gitlab #2834)

2141.	[bug]		razvan
	The High Availability hook library is sending the 'origin'
	parameter set to 'ha-partner' when sending lease update
	commands which enables the forensic log hook library to
	distinguish between administrator commands and HA partner
	commands.
	(Gitlab #2629)

2140.	[func]		slawek
	Implemented functions to delete the host reservations from the
	JSON configuration. Updated the host manager to fully support
	altering the primary source (JSON configuration). Its methods
	accept a new argument ("operation target") to specify the data
	source (JSON configuration and/or hosts database) to query or
	alter. Fixed a function that retrieves IPv6 host reservations
	from the configuration by address.
	(Gitlab #2815)

2139.	[bug]		marcin
	Fixed a bug in the delegated prefix permutations that caused
	allocating prefixes in the same order by the random and FLQ
	allocators.
	(Gitlab #2860)

2138.	[bug]		marcin
	Fixed a bug in the DHCPv4 server that sent DHCPNAK to a client
	in the INIT-REBOOT state when the server had no matching subnet
	configuration for that client.
	(Gitlab #2858)

2137.	[func]		fdupont
	A new command "extended-info4-upgrade" makes old leases
	from SQL DHCPV4 lease database visible to Bulk Lease Queries.
	(Gitlab #2757)

2136.	[func]		tmark
	The default value, in kea-dhcp6, for preferred-lifetime is
	now calculated as: 0.625 * valid-lifetime. This calculation
	is also used in the event that the specified value for
	preferred-lifetime is greater than valid-lifetime.  Prior to
	this, the default value was 3600 seconds, and there was no
	check against sending values greater than valid-lifetime.
	(Gitlab #2835)

2135.	[build]		tomek
	The CodeQL pipeline has been enabled on github. Developer's guide
	updated with details.
	(Gitlab #2760)

2134.	[func]		andrei
	Statistics total-nas and total-pds were increased from 64-bit
	values to 128-bit values to accurately represent large pools.
	(Gitlab #2658)

2133.	[func]		andrei
	Added missing YANG nodes: allocator, ddns-ttl-percent,
	exclude-first-last-24, ignore-dhcp-server-identifier,
	offer-lifetime, pd-allocator, read-timeout, tcp-user-timeout,
	write-timeout.
	Removed obsolete YANG nodes: contact-points, keyspace.
	(Gitlab #2832)

2132.	[bug]		marcin
	Fixed a bug in the allocation engine that could cause an invalid
	lease assignment in the shared networks using subnets with
	different allocator types.
	(Gitlab #2843)

2131.	[bug]		razvan
	Added support for 255 bytes long client-id and 130 bytes long
	duid (2 bytes for type and at most 128 bytes for value).
	(Gitlab #2786)

2130.	[func]		piotrek
	Added support of DHCP Options for the Discovery of
	Network-designated Resolvers (DNR) as per draft-ietf-add-dnr.
	Kea can now handle DHCPv4 Option code 162 and DHCPv6 Option
	code 144.
	(Gitlab #2536)

2129.	[func]		andrei
	New statistics were added to keep track of leases that have their
	CLTT increased in memory and their expiration time left unchanged
	in persistent storage as part of the lease caching feature. The
	statistics are: v4-lease-reuse, subnet[id].v4-lease-reuse,
	v6-ia-na-lease-reuse, subnet[id].v6-ia-na-lease-reuse,
	v6-ia-pd-lease-reuse, subnet[id].v6-ia-pd-lease-reuse.
	(Gitlab #2797)

2128.	[bug]*		razvan
	In addition to logging them, the server now sets the
	CalloutHandle status to DROP to indicate an error occurred when
	it catches unhandled exceptions thrown by a callout.
	(Gitlab #2805)

Kea 2.3.7 (development) released on April 26, 2023

2127.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.3.7
	development release.
	(Gitlab #2837)

2126.	[func]		andrei
	A new command named reservation-update is now available in the
	host_cmds hook library. It updates an existing reservation.
	(Gitlab #549)

2125.	[func]		marcin
	Allocators can now be configured in the configuration backend.
	(Gitlab #2823)

2124.	[perf]		andrei
	When not explicitly configured, multi-threading mode and the HTTP
	dedicated listener are enabled by default for the
	high-availability hook library ("enable-multi-threading" and
	"http-dedicated-listener" set to true).
	(Gitlab #2749)

2123.	[bug]		razvan
	Fixed a bug which was truncating relay suboptions (circuit-id
	code 1 and remote-id code 2) if the data ended in 0x0. The
	option definitions have been updated from OPT_STRING_TYPE to
	OPT_BINARY_TYPE.
	(Gitlab #2794)

2122.	[bug]		marcin
	Fixed a bug in the HA hook library whereby the HA service could
	sometimes terminate even after the partner's clock has been
	corrected. The last clock skew is now ignored when a
	communication failure with the partner occurs.
	(Gitlab #2754)

2121.	[func]		marcin
	Implemented Free Lease Queue allocator. It can be used for
	address assignment in DHCPv4 and prefix delegation in DHCPv6.
	The allocator is suitable when the DHCP servers work with
	nearly depleted pools, and the time to find an available
	lease becomes long with other allocators. The new allocator,
	however, slows down the server startup and reconfiguration.
	It also uses more memory.
	(Gitlab #2780, #2764)

Kea 2.3.6 (development) released on March 29, 2023

2120.	[build]		razvan
	The library version numbers have been bumped up for the Kea 2.3.6
	development release.
	(Gitlab #2807)

2119.	[func]		tmark
	Added a new parameter, ddns-ttl-percent, to kea-dhcp4
	and kea-dhcp6, that may be used to calculate DNS TTL
	as a simple percentage of the lease life time.
	(Gitlab #225)

2118.	[bug]		razvan
	Fixed a bug which was changing the multi-threading settings when
	running config-test command and the settings were different from
	the server's configuration. This also fixes the rollback on the
	multi-threading settings if there is a configuration error
	detected. Also hooks now set DROP flag on the
	dhcp4_srv_configured and dhcp6_srv_configured callouts if the
	configuration is invalid or an error occured. Proper shutdown
	of the HTTP listener is performed now instead of generating a
	server crash if the provided address is not valid.
	(Gitlab #2799)

2117.	[func]		fdupont
	Added a new ignore-dhcp-server-identifier DHCPv4 compatibility
	flag which when set to true (default is false) makes any query
	to be accepted even when the address in the DHCP Server
	Identifier option belongs to another server (standard behavior
	is to drop such queries).
	(Gitlab #2785)

2116.	[func]		piotrek
	Added support of Secure Zero Touch Provisioning options as per
	RFC8572. Kea can now handle DHCPv4 Option code #143 and DHCPv6
	Option code #136.
	(Gitlab #939)

2115.	[func]		tmark
	Added the parameter, offer-lifetime, to kea-dhcp4.  When
	greater than zero, the server temporarily allocates and
	persists leases during DHCPOFFER processing.
	(Gitlab #2719)

2114.	[func]		razvan
	Added the -T command line parameter to kea-dhcp4 and kea-dhcp6
	for testing configuration files, similar to -t, but with extra
	checks like checking database connections, checking hook
	libraries parameters, and others.
	(Gitlab #1671)

2113.	[bug]		razvan
	The reload functionality (by sending SIGHUP) of the kea-dhcp4
	and kea-dhcp6 servers has been enhanced to rollback to
	previously working configuration if the new configuration is
	invalid. There are still cases that can leave the server in an
	unrecoverable state, and such case is indicated by a FATAL
	log message. The same logic applies to the "config-set" command
	available to the server through the control channel.
	(Gitlab #2722)

2112.	[doc]		fdupont
	Added in the ARM security a section explaining how
	to tune the OpenSSL configuration file for Kea service
	accepting commands over HTTPS.
	(Gitlab #2784)

2111.	[bug]		fdupont
	Fixed a bug which advertised re-assigned released leases
	with zero lifetimes.
	(Gitlab #2766)

2110.	[func]		fdupont
	A new boolean configuration flag called "never-send" has been
	added to the option data scope. When enabled, the option is not
	sent in a response to the client, even if the client explicitly
	requests it.
	(Gitlab #719)

2109.	[bug]		fdupont
	Compatibility flags e.g. lenient-option-parsing were not
	saved by config-get and similar commands.
	(Gitlab #2790)

2108.	[func]		fdupont
	Added a new exclude-first-last-24 DHCPv4 compatibility flag
	which when set to true (default is false) skips addresses
	in .0 and .255 in subnets with prefix length less than 24
	in the allocation engine routine picking a free address.
	(Gitlab #720)

2107.	[func]		fdupont
	The Kea DHCPv4 server can now handle multiple vivco-suboptions
	options with different enterprise IDs.
	(Gitlab #467)

2106.	[bug]		tmark
	Corrected code that allowed lease6-get-* commands to return
	IA_NA leases with prefix length values of zero and logic in
	kea-dhcp6 that was incorrectly generating duplicate iaaddr
	options with lifetimes of zero for such leases in REPLYs to
	RENEWs.
	(Gitlab #2660)

2105.	[bug]		tmark
	kea-dhcp6 now consistently uses valid and preferred lifetime
	values provided via classes.  Prior to this it was not
	utilizing class-supplied lifetimes when renewing existing
	leases or when reusing expired leases.
	(Gitlab #2739)

Kea 2.3.5 (development) released on February 22, 2023

2104.	[build]		andrei
	The library version numbers have been bumped up for the Kea 2.3.5
	development release.
	(Gitlab #2768)

2103.	[perf]		andrei
	When not explicitly configured, multi-threading is now enabled by
	default for the core Kea DHCP service ("enable-multi-threading"
	set to true). For now, HA+MT is still disabled by default
	("enable-multi-threading" and "http-dedicated-listener" both
	still set to false in the high-availability library parameters).
	(Gitlab #2402)

2102.	[func]*		tmark
	The logger to which kea-dhcp4 now logs EVAL_RESULT log
	messages issued during packet classification has been
	changed from "options4" to "dhcp4".  This corrects an
	inconsistency between kea-dhcp6 and kea-dhcp4 behavior.
	(Gitlab #2720)

2101.	[build]		andrei
	Shell tests and python tests no longer run if gtest is disabled.
	This provides the ability to run distcheck without tests.
	(Gitlab #2742)

2100.	[doc]		Kevin P. Fleming
	Fixed several JSON examples in the Kea ARM.
	(Gitlab #2494)

2099.	[func]*		tmark
	An address reserved in a global reservation must now lie
	within the range of the subnet or shared-network selected
	by Kea. If it does not, the server will attempt to allocate an
	address dynamically. This change applies to both kea-dhcp4 and
	kea-dhcp6. Previously, the servers would grant a lease for any
	globally reserved address without regard for its feasibility
	within the selected subnet. Thanks to Kyle Birkeland for
	reporting the issue and contributing the patch.
	(Gitlab #2631, #2632)

2098.	[doc]		razvan
	Updated client classification examples in the ARM with a case
	where both operands of the evaluated expression are computed at
	runtime.
	(Gitlab #2664)

2097.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 will now accept renew-timer values that
	exceed rebind-timer values but will ignore them and issue a
	warning. Previously, the servers treated those values as a fatal
	configuration error.
	(Gitlab #2677)

2096.	[bug]		tmark
	Corrected a bug which allowed options to be added to themselves
	as suboptions.
	(Gitlab #2538)

2095.	[bug]		marcin, tmark
	Added a compile-time check of whether the PostgreSQL version
	supports the "tcp-user-timeout" parameter. This parameter
	is available in PostgreSQL version 12 and later. It is now
	ignored for earlier versions and a suitable warning message
	is issued.
	(Gitlab #2734)

2094.	[bug]		razvan
	Fixed a bug which caused the Kea server to crash when
	using the high-availability hooks library and running reconfigure
	commands. Thanks to Caciano Machado for reporting this bug and
	providing detailed steps on how to replicate it.
	(Gitlab #2575)

2093.	[func]		fdupont
	It is now possible to add an "empty" host reservation without any
	attribute (e.g. no address, no hostname, no client classes,
	etc.). This is useful for determining the KNOWN class.
	(Gitlab #2723)

2092.	[bug]		fdupont
	Added logic to kea-dhcp4 and kea-dhcp6 to catch and log
	database connection errors that occur during lease
	reclamation. Previously, such errors caused the
	reclamation timer to not get rescheduled.
	(Gitlab #2682)

2091.	[bug]		marcin
	Fixed a bug that caused a response to a config-get command
	to lack the configured read-timeout, write-timeout, and
	tcp-user-timeout parameters.
	(Gitlab #2741)

2090.	[build]		andrei
	Fixed the --with-site-packages configure flag, which previously
	had no effect.
	(Gitlab #2669)

Kea 2.3.4 (development) released on January 25, 2023

2089.	[build]		razvan
	The library version numbers have been bumped for the Kea 2.3.4
	development release.
	(Gitlab #2726)

2088.	[func]*		tomek
	The libreload command is now deprecated. The code is still there,
	but it will be removed in the future versions.
	(Gitlab #2693)

2087.	[func]		razvan
	The Kea DHCPv4 server can now handle multiple vendor options
	with different enterprise IDs and multiple vivso-suboptions.
	(Gitlab #1518)

2086.	[bug]		andrei
	A spacing issue in a prepared statement that prevented Config
	Backend from working with PostgreSQL 15 and above has been fixed.
	(Gitlab #2724)

2085.	[func]		tmark
	kea-dhcp-ddns uses new log messages to clearly distinguish
	between timeouts and other IO errors when communicating with
	DNS servers.
	(Gitlab #2589)

2084.	[func]		razvan
	When the client adds a prefix length in the hint, the server
	will try to select a pool with the delegated prefix length
	equal to the respective value. If no pool is found, the server
	will try to select a pool with a lower delegated prefix length
	(a larger address space) and if none is found, it will try to
	select a pool with a higher delegated prefix length (a smaller
	address space).
	(Gitlab #1958)

2083.	[func]		marcin
	New database connection parameters, "read-timeout" and
	"write-timeout", control the timeouts in communication with the
	MySQL database. The "tcp-user-timeout" controls the timeout in
	communication with the PostgreSQL database. Setting these
	timeouts can prevent occasional Kea hangs due to issues with
	the database connectivity.
	(Gitlab #2688)

2082.	[bug]		razvan
	The prefix address provided in the prefix and prefix length pair
	from the pool configuration is now checked to match the first
	address in the pool.
	(Gitlab #2612)

2081.	[func]		tmark
	The default value for the kea-dhcp-ddns parameter,
	dns-server-timeout, has been increased from 100 ms to
	500 ms.  This was done to improve the out-of-the-box
	user experience.
	(Gitlab #2590)

2080.	[func]		tmark
	Bulk Lease Query results can now include delegated prefixes.
	Memfile queries used by Bulk Lease Query (BLQ) were modified
	to include delegated prefixes when appropriate. Prior to
	this they were returning only address leases.
	(Gitlab #2713)

2079.	[func]		marcin
	The lease allocation strategy is now configurable. It is possible
	to select between iterative and random lease selection for the
	address assignment and prefix delegation, respectively, at the
	global, shared network, and subnet levels.
	(Gitlab #2348, #969)

Kea 2.3.3 (development) released on November 30, 2022

2078.	[build]		andrei
	The library version numbers have been bumped for the Kea 2.3.3
	development release.
	(Gitlab #2650)

2077.	[func]		andrei
	YANG modules have been updated with three configuration nodes:
	extended-info-checks, ignore-rai-link-selection, template-test.
	keatest-module has also gained empty, leafref and union nodes for
	proper testing of all YANG leaf types.
	Additionally, stable libyang and sysrepo versions are recommended
	for use in the ARM in place of the previous development versions.
	(Gitlab #2601)

2076.	[doc]		razvan
	Add documentation for template classes and the new parameter
	'template-test' which evaluates to a string value. This indicates
	if the class is spawning classes with the name containing the
	evaluated value: 'SPAWN_<template-class-name>_<evaluated-value>'
	only if the value is not empty string. This will also add the
	packet to the <template-class-name> class.
	(Gitlab #2606)

2075.	[bug]		razvan
	The builtin client class ALL can now be used again to apply lease
	limits and rate limits.
	(Gitlab #2615)

2074.	[func]		tmark
	Added a new library, libkea_tcp, that provides support for a
	generic TCP listener.  Initially, this library will be used
	for Bulk LeaseQuery
	(Gitlab #2583)

Kea 2.3.2 (development) released on October 26, 2022

2073.	[build]		razvan
	The library version numbers have been bumped for the Kea 2.3.2
	development release.
	(Gitlab #2607)

2072.	[func]		razvan
	If both "flush-reclaimed-timer-wait-time" and
	"hold-reclaimed-time" are non-zero, when the client sends a
	release message the lease is expired. Previously it was deleted
	from the lease storage. The default values are 25 and 3600
	respectively, effectively changing the default server behavior.
	(Gitlab #2548)

2071.	[perf]		andrei
	Significantly improved the performance of editing configuration
	with kea-netconf. Instead of making a request to the sysrepo
	datastore for each leaf and leaf-list node, a single request is
	done and the config is translated from the received data node.
	This approach is considered experimental.
	(Gitlab #2400)

2070.	[func]		andrei
	kea-netconf now requires libyang v2 and sysrepo v2 to compile and
	run. Support for libyang v1 and sysrepo v1 has been dropped.
	(Gitlab #2311)

2069.	[func]		fdupont
	Added a new sanity checker named "extended-info-checks"
	which checks and eventually upgrades lease extended
	info which store into lease user context in DHCPv4
	the dhcp-agent-options content and in DHCPv6 the
	relay-msg fields and options.
	(Gitlab #2595)

2068.	[func]		djt
	Kea's official APK, Deb, and RPM packages have been restructured
	and made to follow a consistent packaging standard. Some of the
	package names have been modified, and some packages have been
	consolidated into larger packages as a result of these changes.
	Kea now runs under a service user on RPM systems. Upgrading Kea
	on Debian and Ubuntu systems should be done with ``apt
	dist-upgrade`` when upgrading to this release or later, as some
	packages need to be removed before being reinstalled. Depending
	on how Kea was installed, upgrading to this release or later on
	Debian or Ubuntu systems could cause the DHCPv6 and/or the DDNS
	server, as well as the open-source hooks to be removed. In order
	to ensure they are properly installed, either install the
	``isc-kea`` metapackage, or install the packages explicitly by
	name. Further details can be found in the Gitlab issue.
	(Gitlab #2220)

2067.	[func]		fdupont
	Updated the layout of extended information optionally
	stored in lease user context to add remote and relay
	identifier (sub-)options.
	(Gitlab #2587)

2066.	[bug]		fdupont
	Fixed lease reuse process to clear the user context
	when the lease expired and was reclaimed.
	(Gitlab #2588)

2065.	[func]		djt
	A compatibility config option called ignore-rai-link-selection
	has been added to the DHCPv4 config allow operators to ignore
	Link Selection suboption data in Relay Agent information options.
	When this configuration value is set to true, Kea will no longer
	use data provided in the suboption for subnet selection.
	(Gitlab #2543)

Kea 2.3.1 (development) released on September 28, 2022

2064.	[build]		mgodzina
	The library version numbers have been bumped for the Kea 2.3.1
	development release.
	(Gitlab #2576)

2063.	[bug]		fdupont
	Fixed 32 bit compatibility issue with PostgreSQL time.
	(Gitlab #2532)

2062.	[func]		fdupont
	The lease_cmds hook library supports two new commands
	"lease4-write" and "lease6-write" which should help
	to recover emergency situations e.g. full disk space
	by writing the memory lease database into a CSV file.
	They are supported only by the memfile backend.
	(Gitlab #1654)

2061.	[bug]*		fdupont
	Enforce length limits on host identifier (20 bytes for
	hardware address, 128 bytes for DUID and other types).
	(Gitlab #2557)

2060.	[build]		andrei
	Two scripts that are used for checking YANG modules now
	automatically detect the location of the yanglint tool and its
	libraries based on the values passed to the configure script.
	"make check" should now pass uninterrupted on some delicate
	systems like Alpine and RPM-based. Also, reinstall.sh, used to
	install YANG modules, now detects sysrepoctl automatically.
	(Gitlab #2558)

2059.	[func]		marcin
	The lease_cmds hook library returns a new "conflict" status
	code indicating an issue with a lease update due to a mismatch
	between the received lease and the server's configuration or
	state. The HA hook library differentiates between this new
	status and a general error and avoids transitioning to the
	partner-down state when conflicts occur. The new
	"max-rejected-lease-updates" parameter sets a limit for the
	maximum number of conflicts before the server terminates the
	HA service.
	(Gitlab #2408)

2058.	[build]		fdupont
	kea-lfc is now built just after libraries.
	(Gitlab #2526)

2057.	[doc]		marcin
	Fixed broken example and documentation for long DHCPv4 options
	in the ARM.
	(Gitlab #2545)

2056.	[build]		andrei
	Improved build compatibility in Kea between g++ and Boost
	libraries. The compilation error that was fixed was reported to
	occur with g++ 8 and boost 1.75. The fix consists of passing
	callbacks directly to boost::asio::io_service::post and not
	indirectly through a functor. Thanks to rski for reporting the
	error and suggesting the fix!
	(Gitlab #2519)

2055.	[func]		andrei
	When Kea starts with an erroneous file configuration, if the
	logging is viable and is configured to log at least at ERROR
	level, it will log the errors according to the configured
	logging. Previously, it would log them in stderr which made
	gathering of the errors more difficult. A final log message is
	still logged at stderr just as before.
	(Gitlab #1955)

Kea 2.3.0 (development) released on August 31, 2022

2054.	[build]		razvan
	The library version numbers have been bumped for the Kea 2.3.0
	development release.
	(Gitlab #2546)

2053.	[doc]		razvan
	A new appendix for configuration templates added to Kea ARM.
	which include High Availability with multi-threading and secure
	connections using TLS.
	(Gitlab #2441)

2052.	[func]		andrei
	Omitted logger configuration entries are now properly inherited
	from the root logger as the ARM suggests.
	(Gitlab #2537)

2051.	[func]		razvan
	Added support for bulk lease query options defined in RFC 6926.
	The bulk lease query functionality has not been implemented yet.
	(Gitlab #2527)

2050.	[build]		andrei, tomek
	Fixed problem with preparing system using hammer on FreeBSD
	13.0. The available sphinx and python versions are now detected
	dynamically. This should prevent future package upgrades (e.g.
	to python 3.10) from breaking our builds again.
	(Gitlab #2534)

2049.	[build]		razvan, fdupont
	The distcheck rule is able to compile and run unittests for
	database backends, GSS-TSIG and Sysrepo/NETCONF.
	(Gitlab #2071)

2048.	[bug]		fdupont
	Set broadcast MAC destination address in DHCPv4 replies
	when the IP address is broadcast. Thanks to Joost Bekkers
	for reporting the issue and contributing the patch.  This
	improves Kea's compatibility with Cisco Small Business
	switches.
	(Gitlab #2211)

2047.	[func]		fdupont
	Added support of multiple instances of the DHCPv6
	"vendor-class" (code 16) and "vendor-opts" (code 17)
	options: specifying multiple options with different
	enterprise numbers is now supported by Kea.

2046.	[doc]		andrei
	Disabled smart quotes in Sphinx configuration to leave quotes
	unchanged. Prior to this change, quotes were converted into
	left-quotes and right-quotes. This made it difficult for users to
	copy and use chunks of configuration directly from the ARM.
	(Gitlab #2513)

Kea 2.2.0 (stable) released on July 27, 2022

2045.	[build]		tmark
	Bumped library version numbers for the Kea 2.2.0 stable release.
	(Gitlab #2504)

2044.	[func]		tmark
	Modified indexes on the hosts table in the postgresql
	schema to improve performance on host reservation searches.
	Thanks to Paul Kutzer for suggesting these changes.
	(Gitlab #2452)

2043.	[func]		andrei
	The status-get command now shows the status of the sockets being
	opened to receive DHCP requests, and a list of errors for the
	sockets that were not successfully created.
	(Gitlab #2434)

2042.	[func]		razvan
	Added missing parameters to YANG modules, including TLS
	parameters for database connections.
	(Gitlab #2224)

2041.	[bug]		tmark
	HA now applies load balancing and scoping only to inbound
	client packet types that apply to client lease fulfillment,
	e.g. DHCPDISCOVER, DHCPREQUEST, DHCPV6_SOLICIT, DHCPV6_REQUEST,
	etc. Previously, HA indiscriminately balanced and
	scoped all inbound packets, including those related to lease
	query.
	(Gitlab #1781)

2040.	[func]		djt
	Added support for Alpine 3.16 in hammer.py.
	(Gitlab #2491)

2039.	[doc]		andrei
	Updated the limits hook library ARM documentation to reflect
	support for lease limits.
	(Gitlab #2481)

2038.	[func]		djt
	Added a new statistic to kea-dhcp4 that counts host
	reservation conflicts. They are now tracked at both
	the global and subnet levels, as v4-reservation-conflicts
	and subnet[id].v4-reservation-conflicts, respectively.
	(Gitlab #2419)

2037.	[bug]		razvan, marcin
	Fixed a crash in the HA+MT scenario caused by a race condition
	which occurred between resetting the CalloutHandle state and
	accessing the hook point parameters, from different threads,
	when unparking packets.
	(Gitlab #2473)

2036.	[build]		andrei
	Added a tool that checks whether there are any missing REST
	commands from the API Reference section of the ARM.
	See tools/check-for-missing-api-commands.sh.
	It has been integrated into the Gitlab CI and runs on every
	push.
	(Gitlab #2379)

2035.	[doc]		Daniel Bjors
	The Developer's Guide now correctly uses the Lease4CollectionPtr
	and Lease6CollectionPtr types. Thanks to Daniel Bjors for
	reporting this typo.
	(Gitlab #2447)

2034.	[func]		andrei
	The PostgreSQL schema has been changed to provide initial support
	for the lease-limiting feature, part of the limits hook library.
	(Gitlab #2445)

2033.	[func]		tmark
	Functionality needed to support the lease-limiting feature of
	of the limits hook library has been added to Memfile_LeaseMgr.
	(Gitlab #2436)

Kea 2.1.7 (development) released on June 29, 2022

2032.	[build]		razvan
	The library version numbers have been bumped for the Kea 2.1.7
	development release.
	(Gitlab #2455)

2031.	[func]		fdupont
	Improved compatibility with OpenSSL 3.0.x, in particular
	recover system error messages.
	(Gitlab #1614)

2030.	[doc]		fdupont, tomek
	GSS-TSIG examples updated. The recommendation to not use
	client-keytab and credentials-cache at the same time added.
	(Gitlab #2247)

2029.	[bug]		fdupont
	The check of the subnet id in configuration is stricter:
	values outside the 0..4294967295 are rejected. Note that
	the value 0 means to leave Kea to assign itself the id.
	(Gitlab #2086)

2028.	[build]		orbea, fdupont
	Compatibility with LibreSSL 3.5.2 improved.
	(Github #121, Gitlab #2411)

2027.	[func]		fdupont
	The TLS is now supported with Multi-Threaded HA (HA+MT) scenario.
	Additional parameters (trust-anchor, cert-file, key-file,
	require-client-certs) are now supported in the HA configuration.
	(Gitlab #1706)

2026.	[func]		andrei
	The MySQL schema has been changed to provide initial support for
	the lease limiting feature, part of the limits hook library.
	(Gitlab #2438)

2025.	[bug]		tmark
	Added missing support for client-class user-context to
	both MySQL and PostgreSQL CB hook libraries.
	(Gitlab #2430)

2024.	[func]		djt
	The ALLOC_ENGINE_V4_ALLOC_FAIL_SUBNET log message format has been
	slightly modified, so that when it is emitted for a subnet that
	is not within a shared network, it emits "(none)" for the value
	of the shared network. The ARM documentation for this parameter
	has been updated to reflect that subnets within shared networks
	will in fact display which shared network the subnet belongs to.
	The ALLOC_ENGINE_V6_ALLOC_FAIL_SUBNET log message format has
	changed to be consistent with the format of
	ALLOC_ENGINE_V4_ALLOC_FAIL_SUBNET.
	(Gitlab #2395)

2023.	[bug]		tmark
	Corrected a MySQL CB issue that caused subnets to be
	updated without having audit entries created when the
	affiliated shared-network is deleted.  This can cause
	the subnets to be excluded from subsequent CB refresh
	cycles.
	(Gitlab #2299)

Kea 2.1.6 (development) released on May 25 2022

2022.	[func]		andrei, djt
	kea-admin lease-upload now calls the lease file cleanup (LFC)
	process to clean up entries with duplicate addresses in the input
	CSV file, to avoid a conflict error when inserting the leases in
	the database. kea-admin also no longer asks for input on
	non-interactive shells. A new -y|--yes flag has been added that
	enables automatic overwriting of any file that kea-admin writes
	to, when dumping or uploading leases.
	(Gitlab #2293)

2021.	[build]		razvan
	The library version numbers have been bumped for the Kea 2.1.6
	development release.
	(Gitlab #2421)

2020.	[doc]		andrei
	The rate-limiting feature of the new limits hook library has been
	documented. It can apply a specified limit of a certain number of
	packets per time unit to a given client class or subnet.
	(Gitlab #562, #1650)

2019.	[func]		tmark
	A new built-in class, "SKIP_DDNS", was added, which can be used
	in conjunction with the ddns-tuning hook library to skip
	performing DDNS updates for a given client.
	(Gitlab #2354)

2018.	[func]		razvan
	The kea-dhcp4 server now supports portions of RFC 3396, allowing
	it to send and receive DHCP options longer than 255 bytes.
	(Gitlab #2227)

2017.	[bug]		marcin
	A bug in the allocation engine, which caused it to write an
	allocated lease under the wrong subnet ID within a shared
	network, has been corrected. This was occurring when multiple
	clients matched the same fixed address reservation. The first
	client is now assigned the fixed address, while a subsequent
	client is then given a dynamically allocated address from a
	different subnet in the shared network.
	(Gitlab #2409)

2016.	[doc]		fdupont
	Documentation for the role-based access control (RBAC)
	premium hook library was added to the ARM.
	(Gitlab #1263)

Kea 2.1.5 (development) released on Apr 27, 2022

2015.	[bug]		tmark
	Fixed an issue in kea-dhcp6 that was causing the server
	not to update the FQDN option in outbound responses when
	the ddns-tuning hook lib calculates a new host name.
	(Gitlab #2392)

2014.	[bug]		tmark
	Correct an issue that was causing reconfigure to fail
	in kea-dhcp4 and kea-dhcp6 when using ddns-tuning hook
	library.
	(Gitlab #2390)

2013.	[build]		razvan
	Library version numbers bumped for Kea 2.1.5 development
	version.
	(Gitlab #2385)

2012.	[doc]		andrei
	Documented whether it's OK or not to have overlapping pools,
	including PD pools in IPv6.
	(Gitlab #1842)

2011.	[func]		djt
	Added CTRL_AGENT_COMMAND_RECEIVED log line with command and
	source address to the kea-ctrl-agent for commands which
	are not forwarded on to another daemon. Added client
	remote-address to CTRL_AGENT_COMMAND_FORWARDED log message if
	it is available.
	(Gitlab #687)

2010.	[func]		razvan
	Several extra log messages now detail the subnet selection
	process. The messages are available on debuglevel 40.
	(Gitlab #2352)

2009.	[func]		tmark
	Added new hook callout points: ddns4_update to Kea DHCPv4
	server and ddns6_update to Kea DHCPv6 server. This enables
	use of the ddns-tuning hook library.
	(Gitlab #1548)

2008.	[func]*		tomek
	The support for benchmarks have been removed.
	(Gitlab #2372)

2007.	[func]		tmark
	Added split() function to classification expression
	language.
	(GitLab #2272)

2006.	[func]		slawek
	Added ``service-sockets-require-all`` parameter to specify
	mandatory successfully binding all needed service sockets to
	initialize DHCP services (defaults to false). If any socket is
	unavailable, then the service fails to start. Added
	``service-sockets-max-retries`` parameter (defaults to 0) to
	specify the number of retries to open unavailable sockets and
	``service-sockets-retry-wait-time`` parameter to specify a time
	interval to wait between attempts.
	(Gitlab #1716)

2005.	[func]*		razvan
	The support for Cassandra database backend has been removed.
	(Gitlab #2116)

Kea 2.1.4 (development) released on March 30, 2022

2004.	[build]		razvan
	Library version numbers bumped for Kea 2.1.4 development
	version.
	(Gitlab #2363)

2003.	[func]		fdupont
	Added the support of sub-options in the flex_option
	hook library.
	(GitLab #2314)

2002.	[bug]		tmark
	Fixed a bug in MySql config backend that caused it to
	store unspecified, client-class valid and preferred life
	time values as zero in the database.
	(Gitlab #2344)

2001.	[bug]		razvan
	Fixed a bug which causes client classes with empty test
	expressions to fail class evaluation when those classes are
	retrieved from config backend.
	(Gitlab #2336)

2000.	[func]		fdupont
	Added the ``early-global-reservations-lookup`` configuration
	parameter which allows to perform a search for global host
	reservations and set client classes before the subnet
	selection. This is achieved when explicitly configured to
	``true`` and it defaults to ``false`` if not configured.
	(Gitlab #2249)

1999.	[func]		tmark, razvan
	The kea-dhcp6 server fully supports using PostgreSQL for config
	backend. This should be considered an experimental feature.
	(Gitlab #2355, #2356)

1998.	[func]		tmark, razvan
	With the addition of support for client classes, the kea-dhcp4
	server now fully supports using PostgreSQL for config backend.
	(Gitlab #2322)

1997.	[bug]		tmark
	The obsolete log message, DHCP4_NCR_CREATE, has been
	removed from kea-dhcp4.
	(GitLab #2301)

Kea 2.1.3 (development) released on Feb 23, 2022

1996.	[build]		razvan
	Library version numbers bumped for Kea 2.1.3 development
	version.
	(Gitlab #2317)

1995.	[func]		tmark
	kea-dhcp4 now supports using PostgreSQL for config
	backend for everything except client classes. The
	new hook library is libdhcp_pgsql_cb.so. This should
	be considered an experimental feature.
	(Gitlab #95)

1994.	[func]		razvan
	Added support for Server Identifier Override RAI sub-option
	(RFC 5107). The implementation is not complete according to the
	RFC, because the server does not store the RAI, but the
	functionality handles expected use cases.
	(Gitlab #1695)

1993.	[func]		razvan
	Added global and per subnet counters for allocation failures:
	``v4-allocation-fail``, ``v4-allocation-fail-shared-network``,
	``v4-allocation-fail-subnet``, ``v4-allocation-fail-no-pools``,
	``v4-allocation-fail-classes``, ``subnet[X].v4-allocation-fail``,
	``subnet[X].v4-allocation-fail-shared-network``,
	``subnet[X].v4-allocation-fail-subnet``,
	``subnet[X].v4-allocation-fail-no-pools``,
	``subnet[X].v4-allocation-fail-classes``,
	``v6-allocation-fail``, ``v6-allocation-fail-shared-network``,
	``v6-allocation-fail-subnet``, ``v6-allocation-fail-no-pools``,
	``v6-allocation-fail-classes``, ``subnet[X].v6-allocation-fail``,
	``subnet[X].v6-allocation-fail-shared-network``,
	``subnet[X].v6-allocation-fail-subnet``,
	``subnet[X].v6-allocation-fail-no-pools``,
	``subnet[X].v6-allocation-fail-classes``.
	There is a warning log message emitted in the logs each time one
	of the allocation failure counters is incremented.
	(Gitlab #2054)

1992.	[bug]		razvan
	The ``maxver`` and ``maxsize`` logger parameters are excluded
	from ``config-get`` command response if the logger output is
	``stdout``, ``stderr`` or ``syslog``.
	(Gitlab #2288)

1991.	[bug]		jinmei, razvan
	Fixed keactrl exit code when netconf is not build.
	(Gitlab #2262)

1990.	[func]		razvan
	Added the ``reservations-lookup-first`` configuration parameter
	which controls whether host reservations lookup should be
	performed before lease lookup. This parameter has effect only
	when multi-threading is disabled. When multi-threading is
	enabled, host reservations lookup is always performed first. The
	``reservations-lookup-first`` parameter defaults to ``false``
	when multi-threading is disabled.
	(Gitlab #2036)

Kea 2.1.2 (development) released on Jan 26, 2022

1989.	[build]		razvan
	Library version numbers bumped for Kea 2.1.2 development
	version.
	(Gitlab #2281)

1988.	[bug]		tmark
	Kea core logic now ensures options belonging
	to client classes are properly created when
	classes are read from configuration backends.
	(Gitlab #2246)

1987.	[bug]		tmark
	Fixed an issue in PostgreSQL support code that caused
	asserts when compiled with: -Wp,-D_GLIBCXX_ASSERTIONS.
	(Gitlab #2284)

1986.	[func]		fdupont
	The kea-admin command now accepts extra arguments which
	are passed to the database command tool, e.g. '--ssl' to
	'mysql' with `kea-admin ... -x --ssl'. Quotes are not
	preserved but multiple arguments can be given.
	(Gitlab #2225)

1985.	[func]		fdupont
	Added support for using files to configure basic HTTP
	credentials. Instead of configuring a value, it is taken from
	the content of a file. The new parameters of the Control Agent
	configuration are:
	- 'user-file' pointing to a file vs 'user'
	- 'password-file' pointing to a file vs 'password'
	- 'password-file' pointing to a file with the secret
	(which is <user>:<password>) vs 'user' and 'password'.
	For the High Availability hook library the new parameter
	is 'basic-auth-password-file' which can be used as an
	alternative to 'basic-auth-password'.
	(Gitlab #2006)

1984.	[func]		andrei
	Introduced the lease-upload command to kea-admin which can upload
	leases from a memfile CSV file to a database backend.
	(Gitlab #2039)

1983.	[bug]		fdupont
	Minimum and maximum values of lifetimes are no longer
	skipped when the configuration is retrieved even when
	they are the same as the default value.
	(Gitlab #2222)

1982.	[bug]		andrei
	The config for an HA peer now accepts an IPv6 address as a valid
	value for the "url" entry.
	(Gitlab #2264)

1981.	[func]		tomek
	The default-url DHCPv4 option has been replaced with
	v4-captive-portal, as defined in RFC8910.
	(Gitlab #1684)

1980.	[func]*		andrei
	The kea-admin lease-dump command now outputs a CSV file that is
	compatible with the memfile backend. This is useful when
	migrating from database to memfile. The generated output is
	backwards incompatible. Any tools that depend on it would need
	to adapt.
	(Gitlab #2038)

1979.	[bug]		fdupont
	Update and delete operations on leases no longer raise
	an error with infinite valid lifetime (used by BOOTP)
	and MySQL or PostgreSQL backends where timestamps can
	be limited to 32 bits.
	(Gitlab 897)

1978.	[doc]		tomek
	The Kea Administrator Reference Manual now correctly states that
	DHCPv6 authentication option has code 11, not 10.
	(Gitlab #2207)

1977.	[bug]		razvan
	Use only MAX_HWADDR_LEN (20) bytes from remote-id when extracting
	the MAC from relay options.
	(Gitlab #2201)

1976.	[func]		andrei
	Added hwtype and hwaddr_source columns to v6 memfile.
	(Gitlab #2236)

1975.	[func]		tmark
	Additional changes and corrections relating to Config Backend
	were made to the PostgreSQL database schema.  In addition, the
	upgrade scripts were renamed to ensure proper file name ordering.
	Note that PostgreSQL CB is not yet functional.
	(Gitlab #2183, #2244, #2245)

1974.	[func]		fdupont
	The global parameter lookup has been refactored to provide better
	performance. Proper return error code (CONTROL_RESULT_ERROR) has
	been fixed in some cases when trying to apply the new
	configuration. Old code was using wrong hardcoded '2' value
	(CONTROL_RESULT_COMMAND_UNSUPPORTED).
	(Gitlab #1082)

1973.	[func]		fdupont
	MySQL backends now can be configured to use the SSL/TLS
	support to protect connections to the server. New
	database parameters are "cert-file", "key-file",
	"trust-anchor" and "cipher-list". The negotiated cipher
	name is logged so the MySQL service configuration can
	be checked. PostgreSQL accepts the same parameters
	but they only trigger the call to the OpenSSL generic
	initialization in the Pq C-API.
	(Gitlab #34)

1972.	[func]		andrei
	Kea servers now can accept trailing commas in file
	configurations. While parsing, a warning is printed with the
	location of the comma to give the user the ability to correct
	a mistake.
	(Gitlab #2084)

1971.	[func]		tmark, jad
	Added support for embedded DHCPv6 DUIDs within DHCPv4
	Client Identifier options per RFC 4361.  This allows
	Kea to support DDNS in dual stack environments per
	RFC 4703(Sec 5.2). Thanks to John Dickinson for
	contributing the patch!
	(Gitlab #1934)

Kea 2.1.1 (development) released on Nov 24, 2021

1970.	[build]		razvan
	Library version numbers bumped for Kea 2.1.1 development
	version.
	(Gitlab #2195)

1969.	[build]		andrei
	Fixed "make check -j N" running tests in parallel in src/lib/log.
	(Gitlab #2172)

1968.	[build]		andrei
	Fixed make check failing when googletest support was disabled.
	(Gitlab #2167)

1967.	[bug]		andrei
	Fixed a bug where keactrl did not color the active status code
	for kea-dhcp-ddns as it did for the other servers.
	(Gitlab #2117)

1966.	[func]		djt
	Allow Kea to pack opaque data tuples within options with zero
	length to accommodate some DHCP clients who have been observed
	to send DHCPv4 option 124 with zero length tuples.
	(Gitlab #2021)

1965.	[func]		andrei
	Increase the value that "maxsize" can take from 2GB to 2PB.
	(Gitlab #2130)

1964.	[func]		wlodek
	Added support for Debian 11 in hammer.py.
	(Gitlab #2042, #2193)

1963.	[func]		andrei
	hammer.py has had several improvements.
	NETCONF and PostgreSQL will be properly configured when running
	prepare-system on Fedora and FreeBSD.
	vagrant will be automatically upgraded if it is too outdated.
	Error messages are more clear when running on unsupported
	systems.
	hammer.py is now able to detect Arch Linux distributions and
	offers limited support for it, being able to prepare-system with
	freeradius and netconf support.
	(Gitlab #2111, #2112)

1962.	[func]		andrei
	kea-netconf updates: fixed store-extended-info, it was an
	operational node instead of a config node. Added several
	containers and leaves: compatibility, lenient-option-parsing,
	multi-threading, enable-multi-threading, packet-queue-size,
	thread-pool-size, valid-lifetime, min-valid-lifetime,
	max-valid-lifetime, preferred-lifetime, min-preferred-lifetime,
	max-preferred-lifetime, cache-max-age, cache-threshold,
	ddns-generated-prefix, ddns-override-client-update,
	ddns-override-no-update, ddns-qualifying-suffix,
	ddns-replace-client-name, ddns-send-updates,
	ddns-update-on-renew, ddns-use-conflict-resolution,
	ip-reservations-unique, parked-packet-limit, reservations-global,
	reservations-in-subnet, reservations-out-of-pool,
	statistic-default-sample-age, statistic-default-sample-count,
	store-extended-info, on-fail.
	(Gitlab #2136)

1961.	[func]		tomek, tmark
	The initial, stubbed version of the PostgreSQL CB hook
	library has been created.  The library is not yet functional
	and does not installed.
	(Gitlab #1848)

1960.	[build]		andrei
	Froze sphinx dependency versions used to build documentation.
	Added the update-python-dependencies Makefile rule to bump the
	versions.
	(Gitlab #2161)

1959.	[doc]		djt
	Move documentation for acceptable format strings into the Kea
	ARM. The relevant section of the ARM was previously referring
	to a dead link in the Log4cpp documentation.
	(Gitlab #2134)

1958.	[func]		tomek, tmark
	PostgreSQL database schema has been extended with tables for
	Config Backend (CB). This is the first step towards PostgreSQL
	CB. However, as there is no code yet to use those new tables,
	they're not not functional yet.
	(Gitlab #90, #2166)

Kea 2.1.0 (development) released on Oct 27, 2021

1957.	[build]		razvan
	Library version numbers bumped for Kea 2.1.0 development
	version.
	(Gitlab #2141)

1956.	[bug]		tmark
	Modified stat_cmds hook library to omit statistics
	for non-existent subnets from results returned by
	stat-lease4-get and stat-lease6-get commands.
	(Gitlab #2033)

1955.	[bug]		tmark
	kea-dhcp4 no longer sends DHCPNAKs in response to
	DHCPREQUESTs for addresses for which it has no knowledge.
	(Gitlab #1584)

1954.	[doc]		fdupont
	Updated the Developer's Guide to explain what to do when
	GSS-TSIG hook unit tests fail from a system Kerberos
	incompatible configuration.
	(Gitlab #2056)

1953.	[build]		fdupont
	Changed the name of the GSS-TSIG hook library object to
	libddns_gss_tsig.so.
	(Gitlab #2115)

Kea 2.0.0 (stable) released on September 29, 2021

1952.	[build]		razvan
	Library version numbers bumped for Kea 2.0.0 stable version.
	(Gitlab #2104)

1951.	[doc]		tomek
	A new appendix for configuration templates added to Kea ARM.
	the first of which is a home power user.
	(Gitlab #2050)

1950.	[doc]		slawek
	Added a description and an example of the usage of the "include"
	statement in the Kea configuration file to the ARM.
	(Gitalb #2080)

1949.	[bug]		tmark
	kea-dhcp6 now correctly determines DNS update flags when
	the allocation engine dynamically changes the selected
	network subnet.
	(Gitlab #1622)

1948.	[func]		tmark
	HTTP library will now emit a warning log when the queue of
	pending client requests for a given URL exceeds a threshold.
	(Gitlab #2085)

1947.	[bug]		marcin
	Corrected a bug in the High Availability hooks library that could
	cause a standby server not to synchronize its lease database
	after a temporary communication interruption with its partner.
	(Gitlab #1959)

1946.	[bug]		marcin
	Fixes a bug in MySQL configuration backend schema. DHCP options
	associated with deleted client classes are now automatically
	deleted.
	(Gitlab #2094)

1945.	[build]		andrei
	Reverted qa#261 changes, which forced linking with OpenSSL 1.1
	when available. This caused a segfault, when Kea's crypto library
	used OpenSSL 1.1, but the MySQL library it linked against, used
	OpenSSL 1.0.
	(Gitlab #2081)

1944.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 both now support a global parameter,
	parked-packet-limit, that can be used to limit the number
	of client responses the server may park pending completion
	of hook library callouts.
	(Gitlab #1307)

1943.	[bug]		marcin
	Fixed a bug in fetching client classes from the Config Backend.
	The bug resulted in failures during attempts to evaluate the
	classes for a received packet.
	(Gitlab #2077)

1942.	[func]		fdupont
	Added basic statistics to the DHCP-DDNS server.
	(Gitlab #2040)

1941.	[func]		fdupont
	Per DNS server TSIG keys are now supported in the DHCP-DDNS
	(aka D2) server configuration. A new callout point 'select_key'
	gives access to the selected TSIG key before sending DNS updates.
	(Gitlab #2011)

Kea 1.9.11 (development) released on Aug 30, 2021

1940.	[build]		razvan
	Library version numbers bumped for Kea 1.9.11 development
	version.
	(Gitlab #2053)

1939.	[bug]		tmark
	Removed all MultiThreadingCriticalSections from lease_cmds
	hooks library which can cause a dead-lock when running HA+MT.
	The commands simply try to acquire the resource lock and fail
	if the resource is unavailable also logging an error message.
	(Gitlab #2051)

1938.	[bug]		razvan
	Fix dead locks caused by commands with CS on http listener
	threads and CS on main thread racing with CS on other threads.
	(Gitlab #2041, #2043)

1937.	[bug]		razvan
	The Config Backend is now capable of reestablishing database
	connection after a failure.
	(Gitlab #1982)

1936.	[build]		andrei
	Kea attempts to first link with compatibility library OpenSSL 1.1
	(usually found on CentOS 7) before falling back to the system
	OpenSSL (1.0 on CentOS 7 which is out of support).
	(Gitlab qa#261)

1935.	[func]		andrei
	The store-extended-info config entry was added to Kea YANG
	modules at root-level and at subnet-level.
	(Gitlab #1944)

1934.	[func]		tmark
	Kea-dhcp6 now supports specifying valid-lifetime and
	preferred-lifetime values in client classes (via both
	configuration file and Config Backend).  Prior to this
	it could only be specified at the global, shared-network,
	and subnet scopes.
	(Gitlab #1710)

1933.	[doc]		fdupont, tomek
	Added a new ARM section about GSS-TSIG. Currently it describes
	how to build Kea with GSS-API support. It will be expanded in
	the future.
	(Gitlab #2018)

1932.	[func]		tmark
	MySQL indexing of leases database has been improved. It now
	behaves better on older MySQL versions. In particular, the lease
	reclamation no longer causes full scans to be performed. This
	fix introduces MySQL schema update to 11.0. This should reduce
	the periodic performance slowdowns.
	(Gitlab #2030)

1931.	[bug]		tomek
	Two hook messages HOOKS_CALLOUT_ERROR and HOOKS_CALLOUT_MESSAGES
	are now printing the hook name and index properly. Thank you to
	Shawn Routhier for reporting the issue.
	(Gitlab #2020)

1930.	[doc]		razvan
	Extended documentation section about setting up the timezones in
	MySQL and PostgreSQL databases.
	(Gitlab #1978)

1929.	[build]		andrei
	Compatibility with upcoming boost 1.77 has been improved.
	Thanks to Brad Smith for the patch!
	(Gitlab #1980)

1928.	[bug]		tmark
	Modified kea-dhcp4 and kea-dhcp6 to only append the
	ddns-qualifying-suffix if the input name does not
	already end with that suffix.  Prior to this the
	suffix was always added which could lead to names
	including the suffix twice.
	(Gitlab #1529)

Kea 1.9.10 (development) released on Jul 30, 2021

1927.	[build]		razvan
	Library version numbers bumped for Kea 1.9.10 development
	version.
	(Gitlab #1984)

1926.	[func]*		marcin
	Server tags in the MySQL database are now represented as strings
	with a maximum length of 64 characters. Previously, the server
	tags could be up to 256 characters long, and it could cause
	database migrations to fail on the systems with UTF-8 encoding
	configured for MySQL. Shorter server tags avoid hitting the
	limitation on the maximum length of an indexed table column.
	(Gitlab #1976)

1925.	[build]		fdupont
	Updated parsers to bison 3.3 or later.
	(Gitlab #453)

1924.	[bug]		razvan
	The MultiThreadingCriticalSection is now thread-safe and can be
	called from http client or http listener processing threads.
	(Gitlab #1964)

1923.	[func]		andrei
	Integrate with Sysrepo v1.x branch. Building with support for
	Sysrepo now requires the latest v1.x versions:
	sysrepo v1.4.140 + libyang v1.0.240.
	Support for legacy Sysrepo versions v0.x has been dropped.
	(Gitlab #1077)

1922.	[func]		marcin
	Added support for storing client classes in the MySQL config
	backend.
	(Gitlab #1920, #1928, #1965, #1972, #1977)

1921.	[func]		fdupont
	The D2 d2_srv_configured hook point used DROP status to notify
	the D2 server that an error has occurred and the configuration
	is rejected. The error message is passed to the D2 server
	through the new 'error' hook parameter.
	(Gitlab #1950)

Kea 1.9.9 (development) released on June 30, 2021

1920.	[build]		andrei
	Bump library versions for the Kea 1.9.9 development release.
	(Gitlab #1947)

1919.	[bug]		razvan
	Fix the run script hook library leaving behind defunct processes.
	(Gitlab #1878)

1918.	[bug]		razvan
	When parsed, PSID was incorrectly ignoring the PSID value when
	psid-len was 16 instead of ignoring it when the values is 0 as
	per the RFC.
	(Gitlab #1858)

1917.	[func]		tomek
	DHCPv4 and DHCPv6 are now more consistent when logging the
	reasons	why a packet was dropped. This information is now
	available on debuglevel 15. Also added a section in the ARM
	discussing the debug levels. The subnet selection failed log
	message now provides more useful information about the subnet.
	(Gitlab #1915, #1916)

1916.	[func]		razvan
	The Kea DHCPv4 server accepts requests using server identifier
	configured at client class level.
	(Gitlab #1836)

1915.	[func]		andrei
	DOCSIS options are no longer offered to any vendor other than
	Cable Labs (vendor-id == 4491). This was not an explicit check
	previously and the match to the vendor relied on a technicality
	such that other vendors could have received these options under
	certain conditions.
	(Gitlab #1894)

1914.	[func]*		tomek
	The Cassandra (CQL) support is being deprecated, both for
	leases and host backends. For the time being the features
	will produce a warning, but will otherwise function normally.
	However, the functionality will be removed in the future
	Kea releases.
	(Gitlab #1892)

1913.	[doc]		tomek
	Kea adopted Developer Certificate of Origin for incoming
	contributions. Please see the CONTRIBUTING.md file for details.
	(Gitlab #1895)

1912.	[doc]		fdupont, tomek
	The Kea configuration syntax is now documented in BNF notation.
	See new appendix in the ARM.
	(Gitlab #504, #745)

1911.	[bug]		andrei
	Fixed a minor regression where kea-admin and keactrl would output
	technical errors like "unbound variable" instead of more helpful
	messages like "missing backend" because of the undefined variable
	checks introduced in 1.9.4. Added tests to further prevent it.
	(Gitlab #1653)

1910.	[func]		andrei
	Extended perfdhcp to send v4 DHCPRELEASE messages via -F flag.
	(Gitlab #1119)

1909.	[build]		fdupont
	Experimental support for Heimdal implementation of GSS-API
	with Kerberos 5 added.
	(Gitlab #1909)

1908.	[func]		razvan
	Added export for V4 option 82 (DHO_DHCP_AGENT_OPTIONS) and
	respective suboptions 1 (RAI_OPTION_AGENT_CIRCUIT_ID) and
	suboption 2 (RAI_OPTION_REMOTE_ID) in the run script hooks
	library.
	(Gitlab #1840)

1907.	[doc]		peterd, andrei, razvan
	Many Kea ARM corrections and updates.
	(Gitlab #1917)

1906.	[func]		fdupont
	Added support for the TKEY DNS resource record.
	(Gitlab #1880)

1905.	[build]		fdupont
	Added an optional --with-gssapi switch to the configure
	script. It checks for the presence and suitability of
	packages pertinent to GSS-TSIG. This has been added in
	anticipation of future work and does not add any
	functionality to Kea.
	(Gitlab #1884)

Kea 1.9.8 (development) released on May 26, 2021

1904.	[build]		wlodek
	Library version numbers bumped for Kea 1.9.8 development
	version.
	(Gitlab #1882)

1903.	[func]		andrei
	Kea now recognizes requests sent from vendors that include their
	information in DHCPv6 Vendor Class option (code 16) for the
	purpose of offering custom options in the response. Previously,
	only the Vendor-specific Information option (code 17) was
	searched for a vendor ID. For the purpose of classification, both
	options are looked into, now, just as before.
	(Gitlab #1837)

1902.	[func]		andrei, fdupont
	All logs that expose configuration, either in full or in snippets
	now have the values of "password" and "secret" entries replaced
	with asterisks "*****".
	(Gitlab #1721)

1901.	[bug]		marcin
	Corrected a bug in DHCPv4 subnet selection. The server ignored
	the Subnet Selection option supplied by a client if its query
	contained a Relay Agent Information (RAI) option without a Link
	Selection option. After this change, the server respects the
	Subnet Selection option when RAI lacks the Link Selection
	option. If RAI includes it, it takes precedence over the Subnet
	Selection option.
	(Gitlab #1816)

1900.	[bug]		tmark
	Fixed a sporadic failure caused by a wrong assertion in
	unit test, testMtHttpClientTest.workPauseResumeShutdown,
	introduced by #1818.
	(Gitlab #1876)

1899.	[func]		tmark,razvan
	In HA+Mt mode, the HA hook library now pauses and resumes
	its worker threads when Kea core enters and exits critical
	sections, respectively.  This eliminates race conditions
	during core processing such as reconfiguration, shutdown,
	and certain RESTful API commands.
	(Gitlab #1818)

1898.	[func]		fdupont
	The DROP class may now depend on the KNOWN or UNKNOWN classes
	and may be used after the host reservation lookup.
	(Gitlab #1815)

1897.	[func]		andrei
	Kea has a new configuration section called "compatibility" geared
	towards non-compliant clients. The only boolean parameter added
	for now called "lenient-option-parsing" changes the way DHCPv6
	option 16's vendor-class-data field is parsed. When enabled,
	instead of complaining that a length exceeds the rest of the
	option's buffer, the value is considered to be the rest of the
	buffer. This also applies to custom options defined with the
	tuple type for both DHCPv4 and DHCPv6.
	(Gitlab #1860)

1896.	[func]		wlodek
	Perfdhcp extended to send v6 traffic from multiple networks.
	(Gitlab #1416)

1895.	[func]		razvan
	Added additional evaluation tokens to extract and print data:
	addrtotext, int8totext, int16totext, int32totext, uint8totext,
	uint16totext, uint32totext.
	(Gitlab #1680)

1894.	[func]		fdupont
	Implemented 'auth' logger, dedicated to logging access
	control information, such as basic HTTP authentication.
	(Gitlab #1590)

1893.	[func]		fdupont
	Botan 2.14 or later can now be used as a crypto library for
	the TLS/HTTPS support in Kea.
	(Gitlab #1665)

1892.	[func]		fdupont
	Added + operator as an convenient alias to concat() function
	in expressions.
	(Gitlab #1824)

Kea 1.9.7 (development) released on Apr 28, 2021

1891.	[build]		razvan
	Library version numbers bumped for Kea 1.9.7 development
	version.
	(Gitlab #1820)

1890.	[doc]		fdupont
	Added a new section to the ARM, Kea Security, which describes
	various security related topics and how to address them.
	(Gitlab #1587)

1889.	[func]		fdupont
	Accept comments (shell '#', C++ '//' and C '/*...*/') in
	JSON commands sent via the control channel or the Control
	Agent.
	(Gitlab #1652)

1888.	[func]		tmark
	Added a new operational mode, HA+MT, to the HA hook library.
	HA+MT provides direct, multi-threaded HTTP communication
	between peers for the exchange HA protocol commands and
	responses.
	(Gitlab #1736)

1887.	[build]		andrei, fdupont
	Migrated autoconf macros, which became warningly deprecated
	since autoconf 2.70, to supported macros.
	(Gitlab #1632, #1651)

1886.	[doc]		tomek
	Added a section in the ARM explaining the relationship between
	keactrl and systemd scripts.
	(Gitlab #1759)

1885.	[func]		andrei
	kea-admin is now able to interactively ask for a password if no
	parameter follows the -p or the --password parameters. This
	requires the user to give it as the last parameter. The entered
	password is not echoed back to the terminal in order to prevent
	over-the-shoulder snooping or other social engineering
	techniques. Alternatively, you can set the password via the
	KEA_ADMIN_DB_PASSWORD environment variable.
	(Gitlab #1675)

1884.	[doc]		fdupont
	HTTP_CONNECTION_HANDSHAKE_FAILED log message got a
	description.
	(Gitlab #1779)

Kea 1.9.6 (development) released on March 31, 2021

1883.	[build]		andrei
	Bump library versions for Kea 1.9.6 release.
	(Gitlab #1772)

1882.	[func]		razvan
	Implemented database connection recovery for forensic logging.
	To achieve this, the "on-fail" connection parameter has been
	added to control the action performed on connection loss.
	The supported values are "stop-retry-exit", "serve-retry-exit"
	and "serve-retry-continue". They indicate if the server should
	disable the service on connection loss ("stop-retry-exit") or if
	on recovery failure the server should shut down
	("stop-retry-exit" and "serve-retry-exit") or continue
	("serve-retry-continue"). The default value used (if not
	configured) is "stop-retry-exit" for lease, host and config
	backends, and "serve-retry-continue" for forensic log.
	(Gitlab #1621)

1881.	[func]		fdupont
	Moved errors about URLs using names (vs addresses) or
	https (vs http) scheme in High Availability hook
	configuration from connection opening time to
	configuration time.
	(Gitlab #1758)

1880.	[build]		fdupont
	TLS support is now reported by configure in the
	cryptographic backend section.
	(Gitlab #1774)

1879.	[func]		fdupont
	The Control Agent now supports TLS/HTTPS. This works with
	OpenSSL and there are known problems with Botan, which will
	be addressed in the future.
	(Gitlab #1662)

1878.	[bug]		razvan
	Request enabling DHCP service when the HA hooks library is
	unloaded. It may remain disabled if it had been disabled
	outside of the HA hooks library. Prior to this change, if
	the HA hooks library disabled the DHCP service it would
	always remain disabled after the hooks library was unloaded.
	(Gitlab #1697)

1877.	[func]		fdupont
	kea-shell supports TLS/HTTPS. This is limited to the python 3
	version i.e. if kea-shell is configured with python 2 it still
	works in 1.9.6 but raises an error if a new TLS/HTTPS argument
	is specified.
	(Gitlab #1663)

1876.	[doc]		fdupont
	Added documentation for TLS/HTTPS support.
	(Gitlab #1664)

1875.	[func]		fdupont
	TLS/HTTPS support was added to asiolink and http libraries.
	(Gitlab #1661)

1874.	[doc]		marcin
	Added notes in the ARM highlighting that the address and
	delegated prefix pools must be split when HA load-balancing
	mode is used.
	(Gitlab #1726)

1873.	[func]		andrei
	kea-admin now accepts the -P|--port parameter with a custom
	port used to connect to the database.
	(Gitlab #1674)

Kea 1.9.5 (development) released on Feb 24, 2021

1872.	[build]		razvan
	Library version numbers bumped for Kea 1.9.5 development
	version.
	(Gitlab #1713)

1871.	[bug]		andrei
	The cache threshold feature introduced in 1.9.4 modified
	previously versioned schema 9.5. This caused problems for people
	who had already upgraded to 9.5 which in Kea versions means 1.9.2
	and 1.9.3.
	In this change, the upgrade commands were moved to schema 9.6 and
	are only applied if the database does not contain the required
	columns. Affected Kea installments can now be upgraded to 1.9.5
	and above seamlessly.
	(Gitlab #1698)

1870.	[bug]		razvan
	Fixed a crash when using the Kea Legal Log Hooks Library with
	multi-threading. This bug was affecting only database backends.
	The log file backend was not affected by this bug.
	(Gitlab #1711)

1869.	[func]		tmark
	Kea-dhcp4 now supports specifying valid-lifetime in client
	classes.  Prior to this it could only be specified at the
	global, shared-network, and subnet scopes.
	(Gitlab #1635)

1868.	[func]		andrei
	The forensic log hook library has gained an auto-increment
	primary key column in it's logs table. It is now able to function
	in a MySQL Percona cluster which requires a primary key for all
	it's tables when configured with pxc_strict_mode = ENFORCING
	which is also the default value.
	(Gitlab #1709)

1867.	[bug]		andrei
	MySQL connection unit tests have been modified to work with
	Percona cluster. This change doesn't fix all problems, but it
	improves the situation sufficiently to be able to run unit tests
	with positive results on a Percona cluster.
	(Gitlab #1708)

1866.	[func]		marcin
	Added new log messages issued when a dynamic lease allocation
	fails. The new messages provide comprehensive information about
	the circumstances in which the failure occurred. In particular,
	they state whether the client is connected to a shared network
	or not. If it is, the shared network name is provided. Otherwise,
	the client's subnet id is logged. The new messages also inform
	from how many subnets the server attempted to allocate a lease
	and how many subnets could not be used because of non-matching
	client classes.
	(Gitlab #1701)

1865.	[func]		razvan
	Implemented the Run Script hooks library which can be used to
	run external scripts for specific packet processing hook points.
	There are several exported environment variables available for
	the script. Currently the implementation is nonblocking and
	Kea will not wait for the script to finish execution before
	continuing to the next step. For this reason, the next step
	provided by the script is ignored.
	(Gitlab #899)

1864.	[func]		fdupont
	New parameters to handle TLS support added in Control Agent
	config: "trust-anchor", "cert-file", "key-file" and
	"cert-required". They can be configured, but their values are
	not yet used.
	(Gitlab #1662)

1863.	[func]		andrei
	The perfdhcp tool now supports the -x l option that exports the
	assigned leases to stdout in CSV format. This new capability is
	very useful for the ongoing DB cluster experiments, where we need
	to correlate leases between multiple Kea instances sharing the
	same cluster.
	(Gitlab #1703)

1862.	[build]		andrei
	Added execution permissions to the upgrade scripts in Kea's
	installation. Previously kea-admin db-upgrade would fail with a
	permission denied error. It started manifesting in 1.9.3 and
	affected 1.9.4 as well. Additionally, now, when running make in
	the source repository to recreate scripts e.g. kea-admin, after a
	change to the .in files e.g. kea-admin.in, they maintain the
	execution permissions granted in the initial build. This makes
	development more seamless.
	(Gitlab #1681)

1861.	[bug]*		tmark
	kea-dhcp4 now uses the value for each fixed field (e.g.
	next-server, server-hostname, boot-file-name) from the
	first class in query's list of classes that specifies the
	field. Prior to this it used the value from the last class
	which specified the field. It may be necessary to revise
	existing configurations to get the desired values.
	(Gitlab #1672)

Kea 1.9.4 (development) released on Jan 27, 2021

1860.	[build]		razvan
	Library version numbers bumped for Kea 1.9.4 development
	version.
	(Gitlab #1666)

1859.	[doc]		wlodek
	Added example files with configured Vendor Specific Information
	option (code 43) and Vendor-Identifying Vendor-specific
	Information option (code 125) with several suboptions each.
	(Gitlab #1546)

1858.	[bug]		razvan
	The DHCP service can be independently enabled or disabled by
	the user command, by the database connection mechanics or
	by the HA library. The DHCP service is disabled when any
	of those originators disables the service, and it is enabled
	when all those who previously disabled the service enable it.
	The 'dhcp-enable' and 'dhcp-disable' commands accept 'origin'
	parameter with valid values of 'user' (which is the default)
	indicating a user generated command and 'ha-partner' which is
	used internally by the HA library.
	(Gitlab #1601)

1857.	[build]		andrei
	Code format styles meant to be as close as possible to the
	recommended coding guidelines are now included with the Kea
	source repository in the form of .clang-format and
	.uncrustify.cfg. The clang-format.sh and uncrustify.sh scripts in
	the tools directory can be used to apply these styles to chosen
	files. See coding guidelines in CONTRIBUTING.md for more details.
	(Gitlab #1455)

1856.	[bug]		razvan
	When using the config backend, the server converts the old
	'reservation-mode' global parameter internally to new
	reservation flags. The new flags are listed when issuing the
	config-get command.
	(Gitlab #1598)

1855.	[func]		marcin
	Improved failover procedure in Kea High Availability library
	by introducing new communication-recovery state. In this
	state the load balancing servers remain responsive to DHCP
	queries when the communication between them is interrupted.
	The new feature is controlled using the delayed-updates-limit
	configuration parameter.
	(Gitlab #1402)

1854.	[func, perf]	fdupont
	Implemented "lease caching", a feature similar to ISC
	DHCP's dhcp-cache-threshold. Lease caching is configured
	through two new parameters: cache-max-age and cache-threshold,
	and is supported by both kea-dhcp4 and kea-dhcp6. When enabled,
	lease-caching allows the server to skip updating lease storage,
	when a client is requesting it's own pre-existing lease whose
	age falls under the cache threshold and for which there are no
	substantive changes to lease values such as the hostname.
	(Gitlab #1418)

1853.	[func]		fdupont
	Populated the space field of option definitions. This solved
	reported bugs where a specific standard option processing
	was applied to an option from another space but sharing the
	same code. In particular, this fixes the problem reported
	with vendor suboption 125.
	(Gitlab #1585)

1852.	[bug]		razvan
	Corrected the value of unacked-clients-left returned in response
	to the status-get command and the corresponding log messages.
	The previously returned value was too low by 1.
	(Gitlab #1578)

1851.	[func]		fdupont
	Removed methods fetching leases by both client identifier
	and hardware addresses from the API.
	(Gitlab #1540)

1850.	[build]		andrei
	Add two scripts to help with code aesthetics, insight on how Kea
	is built or minor build optimizations:
	* ./tools/check-for-duplicate-includes.sh: warns you if
	there is a source file that includes the same header twice.
	While this wouldn't normally result in any errors, it is an
	unusual practice. If you feel that a header should be included
	twice in a file, add the file under "# Exceptions:" in the
	script.
	* ./tools/print-generated-files.sh: prints all the files
	that are generated which may or may not be part of the
	repository. These consist of messages, parser files, and "built
	sources" (as called in Makefile.am files).
	(Gitlab #1602)

1849.	[doc]		tomek
	Two known DHCPv4 RFC violations are now documented in the ARM.
	They are both cases where Kea deliberately deviates from the
	RFC to accommodate some common broken-client behaviors.
	(Gitlab #1608, #1615)

1848.	[bug]		razvan
	The cql upgrade script from schema v3.0 to v4.0 was broken in
	Kea-1.9.3 and has been fixed also enabling the unittest.
	(Gitlab #1616)

Kea 1.9.3 (development) released on Dec 16, 2020

1847.	[bug]		andrei
	Harden shell scripts and fix some of the resulted test failures.
	* #!/bin/sh for all scripts
	* set -eu in all scripts
	* shellcheck all scripts, and fix all shellcheck warnings
	* and more...
	(Gitlab #1574)

1846.	[build]		razvan
	Library version numbers bumped for Kea 1.9.3 development
	version.
	(Gitlab #1605)

1845.	[func]		marcin
	Kea configuration now allows for using database passwords
	which include whitespace.
	(Gitlab #692)

1844.	[bug]		marcin
	Corrected a bug in Kea Control Agent error responses when a
	malformed command was sent. In some cases a map with an error
	response was returned instead of a list.
	(Gitlab #432)

1843.	[func]		andrei
	Allow perfdhcp to request options via option 55 PRL. perfdhcp
	adds option 55 with a few requested options by default so in
	order to allow `perfdhcp -o 55,abcd` special logic to merge all
	the buffers of option 55 was implemented. Works with multiple
	`-o` arguments.
	(Gitlab #1508)

1842.	[func]		razvan
	Fixed the db connection reconnect implementation to honor
	each connection backend configuration. The most important
	improvement is that only the affected manager will be
	recreated when a connection is lost. Previously, even
	managers which were not affected had to be recreated on
	any connection loss. Also fixed an issue with recovery
	when multi-threading is enabled.
	(Gitlab #1375)

1841.	[bug]		marcin
	Corrected issues with inheritance of the DHCPv6 interface-id
	parameter. When interface-id is set at shared network level
	but not at the subnet level this setting is properly propagated
	to the config backend and reported when responding to the
	config-get command. Prior to this change, if the interface-id
	was set for a shared network, it was always returned for the
	subnets belonging to this shared network, even when subnet
	specific value was not specified.
	(Gitlab #652)

1840.	[bug]		fdupont
	Fixed the inheritance of the triple min-valid-lifetime,
	valid-lifetime and max-valid-lifetime parameters from
	the global scope, and fixed it for preferred-lifetime too.
	Added a sanity check refusing incorrect settings, e.g.
	the lifetime not being between min and max values.
	(Gitlab #1456)

1839.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 now calculate the DDNS TTL value
	based on RFC 4702, Section 5 which suggests that the
	TTL value be 1/3 of the lease's valid life time with a
	minimum value of 10 minutes. Prior to this the servers
	set the TTL to equal to the lease's valid life time.
	(Gitlab #936)

1838.	[bug]		fdupont
	The DHCPv6 sent multiple instances of an option or a
	sub-option when it seems to be requested more than once
	directly by the client or using the always-send flag.
	(Gitlab #1449)

1837.	[doc]		cstrotm
	Several Kea ARM corrections.
	(Gitlab #1514)

Kea 1.9.2 (development) released on Nov 25, 2020

1836.	[build]		razvan
	Library version numbers bumped for Kea 1.9.2 development
	version.
	(Gitlab #1555)

1835.	[doc]		peterd
	Several Kea ARM corrections.
	(Gitlab #1536)

1834.	[func]		fdupont
	Added two new callouts (hook points) in the control agent.
	The "auth" callout is executed after the basic authentication
	(if configured) and the command processing. The "response"
	callout is executed after the command processing and before
	the HTTP response is returned.
	(Gitlab #1421)

1833.	[doc]		sgoldlust
	Many documentation corrections.
	(Gitlab #1539)

1832.	[func]		tomek, wlodek
	Perfdhcp extended with functionality to gradually
	increase elapsed time in solicit and secs field in offer.
	(Gitlab #1332)

1831.	[bug]		razvan
	Fixed the DHCPv6 server implementation of the
	reservations-out-of-pool flag to match the DHCPv4 one. When the
	flag is true:
	* the server assumes that all reserved address do not belong to
	  the dynamic pool.
	* the server will not assign reserved addresses that are inside
	  the dynamic pool to the respective clients.
	* addresses matching the respective reservations from inside
	  the dynamic pools (if any) can be dynamically assigned to any
	  client.
	(Gitlab #1550)

1830.	[func]		fdupont, razvan
	Added new configuration options reservations-global,
	reservations-in-subnet and reservations-out-of-pool to replace
	the old reservation-mode parameter. The new flags can be
	configured independently, adding support for new configuration
	scenarios when global and in subnet reservations are both
	active.
	(Gitlab #1405)

1829.	[bug]		fdupont, razvan
	Fixed a bug in the hasAddressReservation function which was
	causing the search for reservations to end as soon as no global
	reservation was found when configuring a subnet or shared
	network with global reservations enabled.
	(Gitlab #1405)

1828.	[bug]		andrei, razvan
	Fix trivial logic error in handling the "lease4-update" command
	manifesting itself on v4 if multi-threading is enabled.
	Notable affected environment is a HA with the
	"send-lease-updates" configuration setting explicitly set to
	true. Prior to this fix, lease updates would not go through to
	other HA nodes, even though some log lines would say they would.
	A simple workaround prior to this fix is to disable
	multi-threading.
	(Gitlab #1542)

1827.	[build]		andrei
	Add `tools/add-config-h.sh` script that can add
	`#include <config.h>` lines to non-generated source files that
	are missing it.
	(Gitlab #1453)

Kea 1.9.1 (development) released on Oct 28, 2020

1826.	[build]		razvan
	Library version numbers bumped for Kea 1.9.1 development
	version.
	(Gitlab #1481)

1825.	[doc]		andrei
	Examples for option definitions, option data, standardized option
	spaces other than "dhcp[46]", custom option spaces, option
	embedding under doc/examples/kea[46]/all-options.json.
	(Gitlab #1298)

1824.	[func]		tmark
	Added a new parameter, ddns-use-conflict-resolution, to
	kea-dhcp4 and kea-dhcp6. This parameter is passed per request
	to kea-dhcp-ddns which uses it to determine whether or not
	conflict resolution rules (see RFC 4703) are followed for that
	request.  The default value is true. Disabling conflict
	resolution should only be used after careful consideration.
	(Gitlab #1386)

1823.	[doc]		tomek
	Updated options documentation for DHCPv4 and DHCPv6.
	(Gitlab #1436, #1460)

1822.	[func]		fdupont
	When multi-threading is enabled the status-get command displays
	the average length of the multi-threading packet queue for last
	10, 100 and 1000 packets.
	(Gitlab #1306)

1821.	[func]		anonymous, fdupont
	The forensic log hook library now logs release and decline
	events.
	(Gitlab #1445)

1820.	[bug]		razvan
	Fixed lease update when using HA and lease_cmds hooks with
	database backend. Previously, HA updates were rejected because
	the database backend rejects operations on the lease if the old
	expiration time is different than what it is already stored, to
	act as a protection mechanism for parallel updates from several
	threads or processes.
	(Gitlab #1434)

1819.	[func]		fdupont
	Improved error messages for bad escapes in JSON strings.
	(Gitlab #151)

1818.	[doc]		andrei
	Add to the reservation documentation:
	* instructions on how to choose "reservation-mode"
	* priority of "reservation-mode" specified at all levels
	* priority of file reservations vs database reservations
	(Gitlab #1299)

1817.	[func]		fdupont
	Redact control agent logs to hide basic HTTP authentication
	passwords from the configuration files. Note that when HTTP
	headers are logged credentials are present in clear text.
	(Gitlab #1459)

1816.	[func]		fdupont
	The message logged when basic HTTP authentication succeed is
	now informative (was DEBUG, is INFO now).
	(Gitlab #1450)

1815.	[bug]		marcin
	Fixed libdhcpsrv build failures when building without database
	backends.
	(Gitlab #1468)

1814.	[func]		marcin
	Added ip-reservations-unique global parameter which controls
	whether or not it is allowed to create multiple host reservations
	for the same IP address or delegated prefix. By default, it is
	not allowed to create multiple reservations for the same lease
	within the same subnet. This change facilitates the use case
	in which a single host can communicate with the DHCP server over
	multiple network interfaces but should be assigned the same
	reserved lease regardless of which interface is used.
	(Gitlab #1428)

1813.	[func]		tmark
	A new parameter, ddns-update-on-renew, has been added to
	kea-dhcp4 and kea-dhcp6 configuration.  When true, the server
	will always update DNS when a lease is renewed even if the DNS
	information for the lease has not changed. The prior, and now
	default, behavior is for the server to only update DNS for a
	renewing lease if its DNS information has changed.
	(Gitlab #1385)

1812.	[doc]		andrei
	Document how MAC addresses can be formatted for use as attributes
	in RADIUS authentication
	(Gitlab #1441)

1811.	[func]		fdupont
	Two new parameters were added: cache-threshold and cache-max-age
	to the DHCPv4 and DHCPv6 global scopes. They will govern the
	upcoming cache threshold feature. The parameters can be set and
	retrieved, but they're not used yet.
	(Gitlab #1418)

Kea 1.9.0 (development) released on Sep 30, 2020

1810.	[build]		fdupont, razvan
	Bump up libs version for Kea 1.9.0 release.
	(Gitlab #1400)

1809.	[func]		razvan
	Added csv-format option to flex_option hook to be able to insert
	option data in csv format. The implicit value is false,
	maintaining compatibility with the previous default raw format.
	(Gitlab #1373)

1808.	[func]		razvan
	Support for new IPv6-only-preferred option for DHCPv4 has been
	added. It lets Kea to signal to compatible devices that the
	IPv6 connectivity is available and they can disable their
	IPv4 stack. This implements support for draft-ietf-dhc-v6only-08,
	which is expected to be soon published by IETF as an RFC.
	(Gitlab #1351)

1807.	[doc]		tomek
	Added separate table with DHCPv4 options that are governed by Kea
	itself, rather than configured by administrator.
	(Gitlab #1323, #1398)

1806.	[bug]		tmark
	The DNS update code behaving better when there is a shared
	network and the code initially selected one subnet, but then
	later determined that a different subnet will be used. There
	is still a corner-case in DHCPv6 if the client requests multiple
	addresses or multiple prefixes and some of them is serviced from
	one subnet and some from another.
	(Gitlab #1389)

1805.	[doc]		tomek
	API documentation for lease4-get-* and lease6-get-* commands
	has been updated.
	(Gitlab #1392)

1804.	[func]		fdupont
	Added a new reservation-get-by-id command to retrieve all host
	reservations with an identifier value and type. Made the
	subnet-id optional in the reservation-get-page command.
	(Gitlab #1163)

1803.	[doc]		fdupont
	Corrected Kea ARM sections describing how to send DHCPv6
	Vendor-specific Information Option (code 17) with sub-options.
	(Gitlab #1025)

1802.	[bug]		fdupont
	Removed the bug which allowed for repeating the same
	configuration parameter multiple times in the same scope.
	The second occurrence of the parameter overwrote the first
	occurrence causing server misconfiguration. Starting from
	this change an error is raised when the same parameter occurs
	multiple times in a given scope the location of the first value.
	(Gitlab #1102)

1801.	[doc]		fdupont
	Moved JSON files describing commands to the share directory
	and adding a new access entry taking read or write values.
	(Gitlab #1240)

1800.	[func]		fdupont
	Added support of basic HTTP authentication in HTTP library,
	control agent, kea shell and high availability hook.
	(Gitlab #1304)

1799.	[bug]		fdupont
	Checked execution of queries to get schema versions of MySQL
	and PostgreSQL database in kea-admin.
	(Gitlab #828)

1798.	[bug]		tmark
	kea-dhcp4 now correctly updates DNS when a client
	returns for lease after the lease has expired.  Prior
	to this, the server would remove the entries but then
	fail to add them unless the hostname (or FQDN) changed.
	This change also eliminates redundant DNS removes when
	expired leases are reclaimed and given to different clients.
	(Gitlab #1409)

Kea 1.8.0 (stable) released on Aug 26, 2020

1797.	[build]		razvan
	Bump up libs version for Kea 1.8.0 release.
	(Gitlab #1395)

1796.	[bug]		marcin
	Kea HTTP client re-establishes connection with the HTTP server
	when timeout occurs. Prior to this change the client tried to
	reuse the connection after timeout often getting subsequent
	timeouts. Re-establishing the connection may help avoid further
	timeouts during the High Availability operation.
	(Gitlab #1390)

1795.	[bug]		razvan
	Added check for 'renew-timer' value to be lower than or equal to
	'rebind-timer' value at subnet and shared network level.
	(Gitlab #505)

1794.	[func]		razvan
	The 'status-get' command send to DHCPv4 or DHCPv6 servers will return
	information about multi threading settings ('multi-threading-enabled',
	and only if this setting is active, 'thread-pool-size' and
	'packet-queue-size').
	(Gitlab #1305)

1793.	[doc]		tmark
	Added Leasequery hook library to the list of available hook
	libraries in the ARM.
	(Gitlab #1372)

1792.	[doc]		tmark
	Added the Database Connectivity section to the ARM which explains
	how Kea servers respond to backend database connectivity issues.
	(Gitlab #1284)

1791.	[doc]		tmark
	Updated the ARM section for the Lease Commands hook library
	which incorrectly stated that a command return value of 2 would
	be returned when no lease(s) matched the command. The value
	returned is actually 3.
	(Gitlab #1384)

1790.	[bug]		marcin
	Fixed a bug in Kea Configuration Backend observed when using certain
	MariaDB	database versions. As a result of this bug the Kea servers were
	unable to fetch configurations stored in the database upon startup. The
	bug was related to the usage of timestamps which in MariaDB must be
	set to 1970-01-01 00:00:01 UTC or later. In some cases the Kea CB used
	out of bounds timestamp values. This bug was observed when using MariaDB
	10.4.13.
	(Gitlab #1382)

1789.	[bug]		razvan
	Fixed a bug in the lease reclaim process which would not reschedule the
	timer if the operation failed.
	(Gitlab #1335)

1788.	[bug]*		fdupont
	When a host reservation in a subnet reserves an address, the
	address must be within the subnet. This check was previously
	only done by the host command hook library. Note it does not
	apply to prefix delegation.
	(Gitlab #1254)

1787.	[bug]		razvan
	The recount leases functions consider leases in 'declined' state as
	'assigned' so that when the lease is reclaimed or reused, no negative
	counters are generated. The 'subnet[X].reclaimed-leases' and
	'reclaimed-leases' are now cumulative counters and are never
	decremented or reset until server restart. Removed references to non
	existent 'declined-reclaimed-addresses' counters.
	(Gitlab #1336)

1786.	[bug]		razvan
	Update lease stats when using commands from lease-cmds hook.
	(Gitlab #1065)

1785.	[func]		fdupont
	If enabled, the default value for queue capacity in congestion control
	has been trimmed down from 500 to 64. The feature continues to be disabled
	by default.
	(Gitlab #285)

1784.	[build]		wlodek
	Socket path in kea ddns default config was changed to
	/tmp/kea-ddns-ctrl-socket.
	(Gitlab #1379)

1783.	[doc]		tomek
	Installation instructions for RADIUS hook updated.
	(Gitlab #1310)

1782.	[bug]		tmark
	Corrected a bug that causes kea-dhcp4/kea-dhcp6 servers to crash after
	losing connectivity to a configuration backend database. The servers
	now correctly honor the max-reconnect-tries parameter.
	(Gitlab #1369)

1781.	[bug]		razvan
	Reject invalid declined state for PD prefix in add and update
	commands in lease-cmds hook.
	(Gitlab #1349)

Kea 1.7.10 (development) released on Jul 29, 2020

1780.	[doc]		wlodek
	Added a section to Kea ARM about tuning performance for kea-dhcp4
	and kea-dhcp6.
	(Gitlab #1285)

1779.	[build]		tmark
	Library version numbers bumped for release.
	(Gitlab #1346)

1778.	[func]*		fdupont
	Changed the order of subnets to follow ascending subnet identifier.
	(Gitlab #1265)

1777.	[doc]		fdupont
	Added in the Developer's Guide an example about how to cross
	compile Kea for a Raspberry Pi.
	(Gitlab #1221)

1776.	[func]		fdupont
	DHCP servers now log a fatal error message when a reconfiguration
	attempt left a no longer working server. Documentation was
	updated tp propose remedy actions.
	(Gitlab #507,#1166)

1775.	[doc]		vicky
	A Code of Conduct has been added.
	(Gitlab #1143)

1774.	[func]		tmark
	leaseX-del commands now support a new parameter, update-ddns,
	which instructs the server to remove DNS entries for a
	lease after it has been deleted.
	(Gitlab #544)

1773.	[perf]		fdupont
	Kea statistics now uses standard c++11 chrono library instead
	of POSIX time library from boost.
	(Gitlab #1174)

1772.	[perf]		fdupont
	Set kea-lfc process priority to lower than default.
	This change should alleviate CPU utilization spikes caused
	by LFC process observed on some systems.
	(Gitlab #1311)

1771.	[func]		fdupont
	Duplicate ChangeLog entry removed.

1770.	[func]		fdupont
	Added kea-admin lease-stat-recount command which recounts cached
	statistics in MySQL and PostgreSQL lease databases.
	(Gitlab #1196)

1769.	[build]		fdupont
	Added detection of the musl libc which implements dlclose() as
	a no-operation: this behavior breaks Kea expectations for
	hook library unloading.
	(Gitlab #771)

1768.	[func]*		fdupont
	Removed the support of the Logging toplevel entry. Now loggers must
	be defined in each server toplevel entry.
	(Gitlab #916)

1767.	[bug]		fdupont
	Fixed unit tests failing on systems where an interface is named	eth0.
	(Gitlab #1043)

1766.	[func]		fdupont
	Optimized the interface manager code and removed the 16 bit limit
	to interface indexes.
	(Gitlab #553)

1765.	[bug]		fdupont
	Corrected a bug in MySQL Config Backend which occasionally caused
	the DHCP servers to overlook some configuration changes. This
	issue could occur when the server fetched configuration changes
	within one second after they they were applied in the database.
	(Gitlab #1247)

1764.	[doc]		fdupont
	Added thread safety consideration sections to library documentations
	in the developer guide.
	(Gitlab #996,#1264)

1763.	[bug]		fdupont
	Changed the way hook libraries are unloaded. Now unload is done
	in two phases: the first phase calls unload() entry points and
	removes callouts, the second phase unmaps hook library memory
	spaces. This should lead to fewer problems including fewer crashes
	at exit time. On the other hand, incorrect libraries can stay
	in memory until exit and prevent any (re)load.
	(Gitlab #1282)

Kea 1.7.9 (development) released on June 24, 2020

1762.	[bug]		fdupont
	Fixed the control command execution: either it was deferred by
	DHCP packet processing or a spurious error message was logged.
	(Gitlab #1234)

1761.	[bug]		fdupont
	Found and fixed a possible source of incorrect statistics cached
	in MySQL and PostgreSQL lease databases which in some cases
	made servers fail to start.
	(Gitlab #944,#1196)

1760.	[bug]		razvan
	Fixed log message on DHCPv6 IA_NA lease renew.
	(Gitlab #1276)

1759.	[bug]*		fdupont
	Fixed the way configuration global entries are parsed in DHCPv4
	and DHCPv6 servers. We expect that the change will not be visible
	for sane configurations.
	(Gitlab #1245)

1758.	[func]*		fdupont
	Earlier Kea versions converted "comment" entries to "user-context"
	scope in the configuration when using config-get. This backwards
	compatibility has now been removed. This may affect users who use
	config-get or config-write commands and use comments in their
	configurations.
	(Gitlab #1100)

1757.	[bug]		fdupont
	config-backend-pull commands were fixed to be applied to the
	current configuration
	(Gitlab #1189)

1756.	[bug]		fdupont
	Made the parking lot API generic thread safe.
	(Gitlab #1255)

1755.	[func]*		fdupont
	Implemented various race avoidance mechanisms in the multi-threaded
	packet processing: only one query from the same client is processed,
	subsequent queries from the same client are dropped at the exception
	of the most recent which will be processed after. When picking
	a free address or prefix from a pool the resource is considered
	as not free for other threads. This is used by the lease commands
	hooks library to avoid conflicts with a minimal overhead.
	Finally individual lease reclamation is exclusive of multi-threaded
	packet processing.
	(Gitlab #1147)

Kea 1.7.8 (development) released on May 27, 2020

1754.	[func]		marcin
	Improved the procedure of restarting the servers in the terminated
	HA state. The servers can now be restarted sequentially without the
	risk of returning to the terminated state right after restart.
	Previously, the servers had to be both shutdown before being
	restarted to avoid returning to the terminated state.
	(Gitlab #1205)

1753.	[func]*		marcin
	Extended the response to the status-get command to include
	information about the progress of the failover procedure
	while the active servers are in the communication interrupted
	state. The new data allow for monitoring the number of clients
	attempting to communicate with the partner which is presumably
	offline, total number of packets sent to the partner and so on.
	The syntax of the response was modified and is incompatible with
	previous Kea versions.
	(Gitlab #1087)

1752.	[doc]		tmark
	Added documentation for the Leasequery premium
	hook library to the ARM.
	(Gitlab #1180)

1751.	[perf]		marcin
	Corrected performance issue occurring while loading large configurations
	via the MySQL Config Backend. Improper database indexing caused long
	server startup time as well as long time to respond to various
	commands, such as subnet4-list or subnet6-list.
	(Gitlab #1242)

1750.	[func]		razvan
	Refactored HooksManager so that no lazy initialization is possible
	from dhcp processing functions. The function getHooksManager is now
	private.
	(Gitlab #1227)

1749.	[func]		fdupont
	When the version is a development (vs. stable) one (second
	number is odd, e.g. in 1.7.x) a server or agent logs a
	warning to dissuade use in production.
	(Gitlab #1184)

1748.	[func]		marcin
	Added two extensions to the HA hooks library. Firstly, the active
	servers no longer wait for the lease update acknowledgments from
	the backup servers. Secondly, the new passive-backup mode allows
	for running a single active server with a number of backup
	servers.
	(Gitlab #999)

1747.	[bug]		fdupont
	Multi-threading and congestion handling were made incompatible:
	when both are enabled by a configuration the dhcp-queue-control is
	silently disabled, when packet-queue-size is not 0 and the
	multi-threading packet queue is full the oldest packet is dropped
	to make room for a new received one.
	(Gitlab #1173)

1746.	[bug]		fdupont
	lease4-add and lease6-add commands now return an error when the
	lease already exists.
	(Gitlab #1170)

1745.	[bug]		fdupont
	Made state model and external sockets thread safe.
	(Gitlab #1095)

1744.	[func]		razvan
	Stopping packet processing when changing or reloading configuration.
	(Gitlab #1188)

Kea 1.7.7 (development) released on Apr 29, 2020

1743.	[doc]		tomek
	ISC now provides a dashboard solution for Kea. Added documentation
	pointers about the ISC Stork project.
	(Gitlab #1191)

1742.	[func]		fdupont
	Added new cumulative statistics: for each assigned IPv4 address,
	IPv6 NA address or IPv6 PD prefixes cumulative-assigned-addresses,
	cumulative-assigned-nas or cumulative-assigned-pds global and
	per subnet is increased. A spelling error in the result-set of
	the stat-lease4-get of the stat cmds hook library was fixed.
	(Gitlab #816)

1741.	[func]		fdupont
	When the MySQL InnoDB reports a deadlock (very rare event)
	the failed query is rerun.
	(Gitlab #1160)

1740.	[bug]		fdupont
	Incorrect signal handling in the process library (used for
	control agent, d2 and netconf server but not by DHCPv4 or
	DHCPv6 servers) was replaced by the boost ASIO signal set.
	(Gitlab #1096)

1739.	[func]		razvan
	Added multi threading configuration parameters which can be used
	to adjust server performance according to setup resources and needs:
	enable-multi-threading, thread-pool-size and packet-queue-size.
	There is also an automatic detection implemented by using
	thread-pool-size set to 0. However, the packet-queue-size must be
	manually configured and does not scale automatically.
	The temporary -N command line option was removed.
	The multi threading is disabled by default.
	(Gitlab #893)

1738.	[func]		fdupont
	Added new global parameters statistic-default-sample-count and
	statistic-default-sample-age to set the default values used
	for sample keeping limits.
	(Gitlab #1005)

1737.	[func]		tmark
	Added store-extended-info parameter to kea-dhcp4 and kea-dhcp6
	which enables the storage of additional information per lease.
	This has been added in anticipation of supporting LeaseQuery.
	(Gitlab #1010)

1736.	[doc]		fdupont
	A default logging syntax has been updated to reflect recently added
	multi-threading capabilities. The process is now identified by
	name/process-id.thread-id, e.g. kea-dhcp4.dhcpsrv/8475.12345, where
	12345 is the thread-id. Its exact syntax is OS dependent. The
	logging syntax can be tweaked using `pattern` option for logging.
	(Gitlab #1150)

Kea 1.7.6 (development) released on Mar 25, 2020

1735.	[func]		wlodek
	Added clean output mode to perfdhcp with configurable separator
	for periodic reports.
	(Gitlab #1046)

1734.	[doc]		vicky
	A list of supported OSes is now described in a separate
	platforms.rst file.
	(Gitlab #1055)

1733.	[func]		tmark
	Added lease4-resend-ddns and lease6-resend-ddns commands to
	the Lease Commands hook library.  These commands may be used to
	instruct kea-dhcp4 or kea-dhcp6 to resend a request to update a
	lease's DNS entries to kea-dhcp-ddns.
	(Gitlab #1106)

1732.	[func]		marcin
	Client classes specified within host reservations can be used
	to influence subnet choice within a shared network and pool
	selection within a subnet.
	(Gitlab #1139)

1731.	[func]		razvan
	The NameChangeSender class is thread safe, making DNS updates
	compatible with multi-threading packet processing.
	(Gitlab #1148)

1730.	[func]		razvan
	Added -N command line switch that enables experimental multi-threading
	support. Number of threads can be specified (e.g. -N8) or Kea can be
	told to autodetect number of CPU threads (-N0). This feature is
	experimental. It hasn't been tested extensively and is known to cause
	problems with DDNS and HA. Do not use in production!
	(Gitlab #893)

1729.	[func]		razvan
	The RAII MultiThreadingCriticalSection class is now able to
	automatically stop and start the packet thread pool in order to
	perform server configuration and avoid race conditions in non
	thread safe code.
	(Gitlab #1016)

1728.	[bug]		tmark
	Memfile now supports commas in the hostname and user-context
	columns.  Commas in either column now escaped as "&#x2c" when
	written out, and unescaped when read back in.
	(Gitlab #608)

1727.	[bug]		tmark
	When shutting down due to lost backend database connectivity,
	kea-dhcp4 and kea-dhcp6 processes will exit with a non-zero value.
	This was temporarily altered by #1108. In addition, the "shutdown"
	command now supports an "exit-value" argument.
	(Gitlab #1115)

1726.	[func]		razvan
	Handling SKIP and DROP state in hooks so that the same operation
	is not performed multiple times. Some hooks will throw exceptions
	if the pktX_receive or pktX_send is handled by other hooks, in
	such case, the configuration order of the hooks must be changed.
	(Gitlab #1088)

Kea 1.7.5 (development) released on Feb 26, 2020

1725.	[func]		wlodek
	Added perfdhcp command option to enable checking address
	and/or prefix uniqueness.
	(Gitlab #1021)

1724.	[func]		razvan
	Added packet thread pool in dhcpv4 and dhcpv6 servers. It adds
	the ability to handle processPacket function on multiple threads.
	When enabled, parked packets are also added to the queue of items
	to be handles by the thread pool. The packet thread pool is
	currently disabled and there is no option to enable it yet.
	(Gitlab #892)

1723.	[func]		tmark
	Hostname sanitizing is now globally enabled by default.  Prior
	to this it was disabled.
	(Gitlab #1048)

1722.	[bug]		razvan
	Compilation fix for MySQL/MariaDB on Ubuntu 19.10.
	(Gitlab #1071)

1721.	[func]*		fdupont
	Added multi_threading_compatible function in hooks to retrieve
	the compatibility with multi-threading. This function is called
	when the library is loaded and if it reports 0 (incompatible) and
	multi-threading is enabled, then the configuration will be
	rejected. The absence of this function from the library defaults
	to incompatibility with multi-threading. All hooks and premium
	hooks must be updated to be able to be used with multi-threading.
	However, not all libraries are (or will ever be) compatible.
	(Gitlab #947)

1720.	[func]*		tomek
	The next step status in pkt4_send hook point now is able to
	distinguish between SKIP (Kea will skip packing the packet with
	the assumption that a hook already did that) and DROP (Kea will
	drop the packet). Previously both SKIP and DROP were interpreted
	as skip packing.
	(Gitlab #1090)

1719.	[func]		razvan
	Prepared CalloutManager to be used in multi-threading by moving
	the current library index and hook index to the CalloutHandle.
	This change removes the CallountHandle::getLibraryHandle, along
	with the possibility of dynamically registering/deregistering
	callouts inside callouts.
	(Gitlab #957)

1718.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 now shutdown gracefully by executing
	the shutdown command, if connectivity with a backend database
	has been lost and retries are either disabled or have been
	exhausted. Prior to this they simply invoked exit() which
	could orphan control socket files or cause segfaults unloading
	the CB Cmds hook library.
	(Gitlab #1108)

1717.	[func]		razvan
	Prepared PgSqlHostMgr to be used with multi-threading by using a
	connection pool with thread context.
	(Gitlab #1074)

1716.	[func]		razvan
	Implemented thread safe stats manager and stats context.
	(Gitlab #891)

1715.	[bug]		tmark
	Kea servers now detect and remove orphaned control channel
	sockets.  This corrects a failure of the servers to restart
	with an error of "address already in use" following a fatal
	loss of database connectivity.
	(Gitlab #1097)

Kea 1.7.4 (development) released on Jan 29, 2020

1714.	[build]		razvan
	Bumped up library version numbers for Kea 1.7.4 release.
	(Gitlab #1101)

1713.	[bug]*		tmark
	Code added under #35 to permit scoping of DDNS behavioral parameters
	was refactored to improve performance.
	(Gitlab #981)

1712.	[bug]		tmark
	Corrected an issue in the MySQL CB hook library which could
	cause subnet and shared-network options, properly added to
	the CB database, to be discarded when fetched from the backend.
	(Gitlab #1093)

1711.	[func]		razvan
	Prepared MySqlHostMgr to be used with multi-threading by using a
	connection pool with thread context.
	(Gitlab #1073)

1710.	[bug]		fdupont
	The code that handles default parameters and parameters
	inheritance, such as applying global values to subnet level,
	has been updated slightly. Although unlikely, there is small
	possibility this may affect boot-file-name, client-class,
	interface, match-client-id, authoritative, next-server,
	reservation-mode, and server-hostname values in Subnet4 and
	client-class, interface, interface-id, rapid-commit, and
	reservation-mode in Subnet6.
	(Gitlab #724)

1709.	[func]		fdupont
	MySQL Configuration Backend now allows for storing DDNS related
	configuration in the database.
	(Gitlab #946)

1708.	[doc]		tomek
	Clarified the relationship between comments and user context.
	(Gitlab #1079)

1707.	[func]		marcin
	High Availability hooks library supports controlled maintenance
	of the servers. The new ha-maintenance-start command puts one
	of the servers in the partner-in-maintenance state and causes
	this server to take over the entire DHCP traffic directed to the
	HA service. The second server in the in-maintenance state can be
	safely shutdown for the maintenance. This new mechanism solves
	the problem present in earlier versions of Kea when the
	administrator had to rely on the failover mechanism to promote
	one of the servers to handle the DHCP traffic while the other
	server was down.
	(Gitlab #1024)

1706.	[bug]		fdupont
	Fixed BOOTP hook. It now properly handles BOOTP packets and sends
	valid responses.
	(Gitlab #1064)

1705.	[bug]		fdupont
	Modified option 43 parsing to interpret sub-option codes 0 and 255
	as PAD and END when no sub-option with these codes are defined.
	This adds control of illegal but common use of these reserved
	code points in option 43.
	(Gitlab #950)

1704.	[func]		fdupont
	Prepared memfile lease manager to be used with multi-threading.
	(Gitlab #894)

1703.	[bug]		niclas rozenvik
	A fix in the --with-gtest option. It is now able to detect the
	libgtest.a. Thank you to Niclas Rozenvik for reporting the issue
	and proposing a fix!
	(Gitlab #1080)

1702.	[func]		razvan
	Update and delete operations on database backends use lease old
	expire value (internal storage) to detect concurrent actions on
	the same lease.
	(Gitlab #1040)

1701.	[func]		razvan
	Initialize all option definitions at program startup instead of
	using lazy initialization to make access thread safe and lock-less.
	(Gitlab #889)

1700.	[func]		godfryd
	Enabled checking Kea merge request in GitLab CI by Danger tool
	(see https://danger.systems/guides/dangerfile.html).
	(Gitlab #672)

Kea 1.7.3 (development) released on Nov 18th, 2019

1699.	[func]		fdupont, marcin
	Implemented status-get command which returns general status
	information about a Kea server status and optionally
	HA specific information if the HA hooks library is present.
	(Gitlab #1041)

1698.	[doc]		wlodek
	Avalanche scenario for perfdhcp is now documented.
	(Gitlab #876)

1697.	[doc]		wlodek
	Forensic logging documentation now mentions database
	configuration.
	(Gitlab #943)

1696.	[func]		fdupont
	A new hook library libdhcp_bootp has been implemented. Once
	loaded, this hook will provide support for BOOTP packets, as
	defined in RFC1497. Please see the "BOOTP support" Section in the
	ARM for details.
	(Gitlab #898)

1695.	[func]		fdupont
	Added support of BOOTP leases with infinite valid lifetime.
	This includes representation of such leases in MySQL and
	PostgreSQL databases which the expire date can be a 32 bit
	integer.
	(Gitlab #897)

1694.	[doc]		marcin
	Described the usage of the ha-heartbeat command to check the
	states of the HA enabled DHCP servers.
	(Gitlab #998)

1693.	[func]		fdupont
	Client supplied ciaddr is now sent back when responding to
	DHCPINFORM
	(Gitlab #992)

1692.	[build]		fdupont
	Better support for google test 1.10.0.
	(Gitlab #954)

1691.	[build]		tomek
	Google test version detection improved.
	(Gitlab #206)

1690.	[func]		fdupont, razvan
	As a preparation for upcoming multi-threading, the PgSQL
	connection pool has been implemented. This code is not
	usable on its own yet, but it will allow all threads
	to share a pool of connections in the future. This
	should improve the overall PgSQL lease backend performance.
	Fixed some log messages that were missing lease type details
	in DHCPv6 PostgreSQL lease manager actions.
	(Gitlab #1044)

Kea 1.7.2 (development) released on Nov 27, 2019

1689.	[bug]*		fdupont
	The default Kea Control Agent's configuration file uses port 8000
	instead of 8080 for the agent. This corrects the mismatch between
	the default port number used by the kea-shell and the agent.
	(Gitlab #793)

1688.	[func]		fdupont
	Added a new callout (hook point) executed when the server has
	completed a configuration update using the Config Backend.
	(Gitlab #596)

1687.	[doc]		fdupont
	Described for developers the way for a hook library to be loadable
	only for specific server(s) and applied as an example to ha.
	(Gitlab #50)

1686.	[func]		razvan
	Added a generic ThreadPool class which can be used to process
	functor work items in parallel, on multiple threads. It uses
	a queue container to manage the work items.
	(Gitlab #883)

1685.	[build]		fdupont
	Small build improvement. The fcntl.h header is included in more
	portable way. This should make it easier to build on Alpine systems and
	possibly other systems.
	(Gitlab #765)

1684.	[func]		fdupont
	As a preparation for upcoming multi-threading, the MySQL
	connection pool has been implemented. This code is not
	usable on its own yet, but it will allow all threads
	to share a pool of connections in the future. This
	should improve the overall MySQL lease backend performance.
	(Gitlab #960)

1683.	[bug]		wlodek
	Perfdhcp is able to parse incoming packet and determine
	if included IA_NA/IA_PD options are correct, counter
	of rejected leases is introduced for all DHCP v6 message
	exchanges. Perfdhcp will no longer send Request/Renew/Release
	message without proper IA_NA/IA_PD included.
	(Gitlab #572)

1682.	[bug]*		tmark
	Added logic to core code and HA hook lib to allow HA peers
	to detect and handle out of bandwidth socket events.  This
	corrects a defect introduced in Kea 1.6.0 that can cause
	an HA server to become unresponsive when an HA socket has
	been closed by a peer.  Note that there is a change to the
	signature of the external socket callback handler invoked
	by IfaceMgr.  Custome hook libraries happen register external
	sockets with IfaceMgr will require modification and
	recompilation.
	(Gitlab #964)

Kea 1.7.1 (development) released on Oct 30, 2019

1681.	[func]		fdupont
	Added new command config-backend-pull which forces the server
	to immediately poll the configuration updates from the
	configuration backend
	(Gitlab #904)

1680.	[bug,build]	Kristoffer Larsen
	A bug in Makefile has been fixed. The changes made to
	src/lib/dhcpsrv/alloc_engine_messages.mes are now picked up
	properly.
	(Gitlab #752)

1679.	[func]		fdupont
	Added new commands to the lease_cmds hooks library to search for
	leases by hardware address, client-id, DUID and hostname. Now
	hostnames are stored in lower case within the lease database.
	(Gitlab #393)

1678.	[build]		fdupont
	The arguments passed to configure are now stored and are available
	using -W command line option.
	(Gitlab #869)

1677.	[doc]		wlodek
	Sample configs now all use the same paths for control sockets.
	(Gitlab #795)

1676.	[func]		fdupont
	A new hook - flex-option - has been developed. It allows setting
	up DHCPv4 and DHCPv6 option values dynamically, using expression.
	This capability is very useful when you want to generate option
	value procedurally. For details, see new section "Flexible Option
	for Option value settings" in the Kea Administrator Reference
	Manual.
	(Gitlab #219,!523, git 2bf854c029b9b07ee6161bc1fcb4dfdc9846ee42)

1675.	[func]		fdupont
	Both DHCPv4 and DHCPv6 can now listen on and send responses
	to a custom UDP port, as specified with the -p command line
	option. This capability is mostly useful for testing.
	(Gitlab #677,!548, git 47e709fb7b89464d4473e8c7cb138f539042d68b)

1674.	[perf]		fdupont
	Added a Multi Threading Manager singleton class in the util library.
	(Gitlab #962,!566, git 66b090e54b45bdeefda266ddd62e42b46ed48d1d)

1673.	[bug]		tmark
	Fixed a bug introduced in Kea 1.6.0 (see #539) that caused
	kea-dhcp4 and kea-dhcp6 to discard inbound packets containing
	string options that consist solely of nulls.  The servers
	will now quietly omit empty or all-null string options from
	inbound packets.
	(Gitlab #900,!561, git c75a7c10bde74f59d481a7717b4e03b9cb2268a6)

1672.	[build]		fdupont
	Deprecated bind1st and bind2nd templates were replaced with
	lambda expressions or plain bind templates.
	(Gitlab #919,!521, git b12fa3374454c9c0d749557d5532aab55dbc58d9)

1671.	[bug]		tmark
	Corrected an issue in kea-dhcp6 where the server would fail
	to extend the expiry of a existing dynamic lease assigned to
	client with host reservation.
	(Gitlab #754,!558, git c223380012b82c93292528b593002c2b80b5361b)

1670.	[func]		fdupont
	Added searches for host reservations by hostname and by hostname
	and subnet.
	(Gitlab #392,!529, git 50068ada6b277c9251de9062501d8c478a8f5529)

1669.	[func]		tmark
	Rather than within the 'dhcp-ddns' section, DDNS behavioral
	parameters may now be specified at global, shared-network,
	and subnet scopes.  Implemented for both kea-dhcp4 and
	kea-dhcp6.  Not yet supported by Config Backend or Netconf.
	(Gitlab #35,!517, git 49ce6286f5d00f99c1c890f12cbc0fd633c9dbf6)

1668.	[build]		fdupont
	The Kea util thread library was removed.
	(Gitlab #907,!519, git 1b27dc52aae23753643461086f0950b125bf9c93)

1667.	[build]		fdupont
	The availability of C++11 thread, mutex, condition variable and
	atomic libraries is now checked by ./configure.
	(Gitlab #918,!520, git baf4097520c1cd38366ee4f33a95dde040906e9e)

1666.	[doc]		tmark
	Added note in ARM about manually admining cb data being possible
	but not supported.
	(Gitlab #917,!518, git f242e5c2e0e14331172671477dce3a6597691b55)

Kea 1.7.0 (development) released on Sep 25, 2019

1665.	[build]		tmark
	Bumped up library version numbers for Kea 1.7.0 final release.
	(Gitlab #924,!526, git c4061d0fdd660c8e375b4e1317603935ccc00b39)

1664.	[build]		razvan
	Make sysrepo_config detect installed sysrepo version.
	(Gitlab #766,!449, git e1a236fa4f4680d3eadade6b5f5a6a6065620a5b)

1663.	[build]		fdupont
	Dropped support for Botan 1.x crypto library in Kea as these
	versions are now end of life.
	(Gitlab #345,!498, git ba028eee986c0da963754c6fcb74790081557bec)

1662.	[bug]		marcin
	Prevent deadlock in the Kea DHCP servers caused by allocating
	memory in the system signal handler. The issue was found on
	CentOS 7.6, but could possibly affect Kea running on any other
	OS.
	(Gitlab #796,!504, git f858d9d0b63a18370ebb8bd7d1b8250d0c5a1cb5)

1661.	[bug]		tmark
	kea-dhcp4 now rejects inbound client messages that have
	neither a hardware address nor a client identifier.
	(Gitlab #821,!501, git 60baf65d0c9de384b0da147b50b7fc3180fc54dd)

1660.	[func]		franek
	Statistics of the DHCP packets are now initialized upon the
	server startup. This makes the statistics available for fetching
	via control channel immediately after the server is started.
	(Gitlab #755,!503, git f0238d1b6e88dfedaa91029ec3b65e06c14cab34)

1659.	[bug]		razvan
	Corrected an issue in the DHCPv4 server logic whereby the user-defined
	option definitions were not committed which could result in
	configuration failures when values for such options were specified.
	(Gitlab #729, !434, git e5b68fb226161dcdef0e4d2d9d03d9bdb95af5e2)

Kea 1.6.0 (stable) released on Aug 28, 2019

1658.	[bug]		tmark
	Renamed the column "array" in option definition tables
	in MySQL schema to "is_array" to avoid a reserved word
	conflict introduced by MySQL 8.0.17.
	(Gitlab #853,!26-p, git 6665c3b6d0f9f2a45b7710e8e9a36fff8f99bf7f)

1657.	[bug]		marcin, tomek
	Corrected multiple occurrences of out of bounds vector reads.
	These could cause server to assert when GLIBCXX_ASSERTIONS
	was enabled during compilation. Also, eliminated overflows as
	a result of strncpy.
	(Gitlab #851,!24-p, git 4b1d6ffc5ae4f1e1fa5990a644c9786e7f6afea6)

1656.	[bug]		marcin
	Corrected a bug in the Kea MySQL Configuration Backend which
	caused the Kea DHCPv6 server to incorrectly require the server
	tag to be provided with the remote-subnet6-option-set command.
	In addition, corrected issues with setting and deleting
	pool specific DHCP options via the Configuration Backend.
	(Gitlab #847,!23-p, git 578bc6c997679c507c2f9e419783d34de77816cd)

1655.	[bug]		marcin
	Corrected a bug in the Kea MySQL Configuration Backend which
	prevented the DHCP servers from discovering and fetching the
	changes applied with the new commands. The new commands set
	and delete the options embedded within the subnets, shared
	networks and pools.
	(Gitlab #845,!22-p, git 7fb2255b212e4e98ff4dbf6d8e2e0ada78701110)

1654.	[sec]		tmark
	kea-dhcp4 Memfile logic now ensures during reading and writing
	that leases which are not in the declined state, have either
	a hardware address, client id, or both. kea-dhcp6 Memfile logic
	now ensures leases which are not declined have a non-empty DUID.
	CVE:2019-6474
	(Gitlab #805,!6-p, git 9705445210cf2a5c4bbe86fde4ce010c45b7aac1)

1653.	[sec]		tmark
	Added a new parameter, "max-row-errors", to Memfile lease database
	configuration for kea-dhcp4 and kea-dhcp6.  This parameter can be
	used to limit the number of rows discarded due to error during
	lease file loading after which the server will abandon the effort
	and exit. The default value of 0 disables the limit.
	CVE:2019-6474
	(Gitlab #805,!5-p git af7393c517cea37a7091075e5d0d24793bccf013)

1652.	[sec]		tmark
	Prevent the DHCP servers from asserting when malformed
	hostname or FQDN options are received.  Now the servers will
	drop the DHCP packets containing the malformed options.
	CVE:2019-6473
	(Gitlab #730,!2-p git a2a98c421bb400a81218bd28d6a6f62accd31b1f)

1651.	[sec]		tmark
	Added logic to kea-dhcp6 to catch values for client or
	server DUIDs that exceed 128 bytes to inbound packet
	sanity checking.
	CVE:2019-6472
	(Gitlab #722,!1-p git bb1a64b8945950f4439121ce4fef566d37c8630c)

1650.	[build]		marcin
	Bumped up library version numbers for Kea 1.6.0 final release.
	(Gitlab #841,!490, git 2e88e2554905dd66b9974c9fc513ee7e7b825a46)

1649.	[doc]		sgoldlust
	API documentation updated and cleaned up.
	(Gitlab #810,!471, git f1ae84186beb54d45f8455236827108289b0b0d6)

1648.	[func]		fdupont,marcin
	Client classification information (client-class,
	require-client-classes) and excluded prefix (excluded-prefix,
	excluded-prefix-len) may now be specified in the MySQL
	Configuration Backend.
	(Gitlab #659,!387, git 1f2cae397b48e2a28a7a7e61f6392691b9d32c13)

1647.	[doc]		marcin
	Updated "Local and Relayed Traffic in Shared Networks" sections
	of the Kea ARM. Explained that all subnets within a shared
	network should have the same subnet selector, i.e. interface
	name or relay IP address.
	(Gitlab #496,!483, git 1335e5643cc142c65bfc49c13280e9aaf3eeec21)

1646.	[func]		fdupont
	YANG models updated to cover the latest parameters:
	pattern and max-row-errors.
	(Gitlab #823,!477, git 79d0d45ec0c791560e297ca77fc88842b0a33868)

1645.	[func]		tmark
	Binary option data may now be specified as a single-quoted
	text string, within double quotes: "'some text'".  This is
	handy for binary options that convey text such as urls or
	file names.
	(Gitlab #761,!447, git 215d84f00208ac8a2710c28abc3386d6b765ede6)

1644.	[doc]		marcin, fdupont
	Added a warning about class dependence on built-in classes.
	(Gitlab #727,!466, git 9977d2927cf9b9cf1cd13de30aa5551ca900165b)

1643.	[build]		godfryd
	Added an optional --with-site-packages switch to configure
	script. It allows python package installation in a separate
	directory (mostly useful on Debian systems when building native
	packages).
	(Gitlab #721,#480, git 66332000ff618fbb41656981c7bbf3bb940066fe)

1642.	[doc]		fdupont, marcin
	User documentation for remote-option{4,6}-* commands.
	(Gitlab #826,!479, git 9b469ab63a9627e377a219cf8f83033e4e613b11)

1641.	[func]		tmark
	Added a new Logger output option, 'pattern', which can be
	used to customize log message content and layout.
	(Gitlab #665,!460, git 2add51ecf0d91d2a9ac797594c38472190c18460)

1640.	[func]		fdupont
	Added sub-option expression for client classification and flex-id.
	Users can access sub-option with option[12].option[34].hex or
	option[12].option[34].exist
	(Gitlab #150,!385, git 70bb412f20b706484538680906d6fcfd7ee6da68)

1639.	[func]		fdupont
	Updated YANG models with the latest changes in kea-dhcp4 and
	kea-dhcp6.
	(Gitlab #433,!473, git c46e8da1561e7d0c6c6f481d2e32cc9ae398324c)

1638.	[bug]		franek, razvan
	Kea statistics improvements: Correct statistic-get{all} commands.
	(Gitlab #756,!470, git 59fb24794af8a9ca8ee3621bc01dfd507350b2c1)

1637.	[bug]		tmark
	Corrected an issue in kea-dhcp6 where the server would assign
	a different lease each time a client with a dynamic host
	reservation returned via a SOLICIT.
	(Gitlab #754,!440, git c548d9330e6f626e538343c5e6361457057efdd7)

1636.	[bug]		razvan
	Http request and response parser now accepts 0 for Content-Length.
	(Gitlab #708,!423, git 09d75804e050083b502a96c8e77b0e98c735ae3d)

1635.	[doc]		godfryd, tomek
	Converted API documentation to Sphinx format.
	(Gitlab #777,!464, git 3ba1a265537330308c313a38b85e84cbe02704ae)

1634.	[func]		franek, razvan
	Kea statistics improvements: Added commands for set sample age and
	set sample count.
	(Gitlab #731,!459, git dde1b96b33ed20dbe2c815f1168e62b66635e39f)

1633.	[bug]		fdupont
	Added missing YANG Kea test module in distributions.
	(Gitlab #747,!436, git a800e79c7917acc723cbc71b626adc360e15a8d7)

1632.	[doc]		razvan, tmark
	Fixed doc examples.
	(Gitlab #649,!381, git e14b90735ff57be0776270364064952d353d7e3a)

1631.	[bug]		marcin
	Corrected the bug in mysql_cb hooks library which in some cases
	caused the pools to be orphaned and left in the database after
	the subnet has been updated.
	(Gitlab #632,!438, git ea15b537d62c66e03923b5fdce91db8795f436b4)

1630.	[build]		fdupont
	Added support for sysrepo 0.7.8 (and libyang 1.0-r3).
	(Gitlab #742,!430, git 6776a829f90768225ea794145e522560d26fe959)

1629.	[func]		tmark
	High Availability logging now also emits server and partner system
	times when reporting clock skew issues.  Prior to this it reported
	only the skew between the two servers.
	(Gitlab #174,!414, git 9715ddecb0143d997a57edea564f5c180a7f8577)

1628.	[bug]		fdupont
	Improved the error message from MySQL CB -set commands when
	a specified server does not exist.
	(Gitlab #732,!429, git 82f34e60363eec72a117939a5526bdb1ececb53c)

1627.	[func]		fdupont
	Added new command server-tag-get to DHCPv4 and DHCPv6 servers.
	(Gitlab #470,!386, git 3cb43f112662ba3f9d2fc7152dfa1639401b1491)

1626.	[bug]		marcin
	Automatically delete embedded options as a result of deleting
	a subnet, pool or shared network from the MySQL Configuration
	Backend. Prior to this change, the options were unnecessarily
	left in the database. The database schema version was affected
	and its version bumped up to 8.2.
	(Gitlab #680,!426, git 03f0af3900bdd9eaa951b23cc9508f0618d3f1bb)

Kea 1.6.0-beta2 (development) released on July 24, 2019

1625.	[build]		tmark, marcin
	Bumped up libraries version numbers for Kea 1.6.0 beta2 release.
	(Gitlab #740,!427, git 359fe51531e802f052bd4172d4e295378155dbd5)

1624.	[doc]		marcin
	Documented a usage of the server tags with the Kea Configuration
	Backend in the Kea ARM.
	(Gitlab #643,!421, git 4c60b02e619bce2c434bbf9ee0e775d8776b2d74)

1623.	[bug]		fdupont
	Eliminated the issue whereby the DHCP server could terminate as a
	result of the remote-network4-del and remote-network6-del commands.
	(Gitlab #738,!425, git b34151b647aae8690fe0996090e13403a8e3ad55)

1622.	[bug]		fdupont
	Corrected server tags returned with the metadata when fetching
	option definitions from the MySQL configuration backend
	(Gitlab #737,!424, git 1cc95ae2a66102427e583b4924383fd414e24f0f)

1621.	[func]		fdupont
	Both kea-dhcp4 and kea-dhcp6 now support a special class, 'DROP'.
	When the class is defined, inbound client packets that match the
	class's match expression will be dropped without further processing.
	Each such drop is logged at DEBUG level and accounted for in
	drop statistics.
	(Gitlab #606,!375, git bfa5b2c50324e9d2339daa8309774f49a5e7bf3c)

1620.	[func]		franek, razvan
	Kea statistics improvements: Support for storing more than one
	sample.
	(Gitlab #696,!418, git c7b8c275758c96f56081e02da429f5dd9d653b87)

1619.	[func]		marcin
	Add support for associating subnets with the server tags in the
	mysql_cb hooks library.
	(Gitlab #717,!417, git e121ec4e0a04bc5bebdbfecf9cc1606b50e71263)

1618.	[func]		marcin
	Add support for associating the shared networks with the server
	tags in the mysql_cb hooks library.
	(Gitlab #716,!412, git 326fdbeb51dc1f6eebbdbbdcce78cfac87a61bd9)

1617.	[bug]		fdupont
	During the application of the config backend the external config
	is initialized to the default values so when a global parameter
	is changed and deleted it gets back a sane value.
	(Gitlab #630,!355, git 237afd3c512ed4d05ae76de76cce21dca643a889)

1616.	[func]		fdupont
	Renamed kea-admin lease-init, lease-version and lease-upgrade
	commands to db-init, db-version and db-upgrade. Only the lease-*
	command is now lease-dump.
	(Gitlab #466,!393, git cbd2ed23f2ea0649ccf608fe818197d2923108f0)

1615.	[func]		fdupont
	Added check for keyword name and type in parsers of objects
	managed by the config backend (options, option definitions,
	subnets and shared networks).
	(Gitlab #575,!358, git c9d87afad8db924da0aadc1b8ab40638bd0a6738)

1614.	[func]		marcin
	Add support for associating the DHCP option definitions with
	the server tags in the mysql_cb hooks library.
	(Gitlab #715,!411, git 5511725555138213de4f48dc1091d65b5db47034)

1613.	[func]		marcin
	Add support for associating the global DHCP options with the
	server tags in the mysql_cb hooks library.
	(Gitlab #714,!409, git 711c1dca9de388b786942fe5bedb8b8cf63b85ba)

1612.	[bug]		razvan
	Fixed crash caused by unloading premium libraries which use
	custom host cache containers.
	(Gitlab #639,!410, git d3f7e9d9a18d93fb014c8e637e15c6ae9ca9269e)

1611.	[doc]		fdupont
	Clarified how Kea handles subnet prefixes in server configuration.
	(Gitlab #419,!333, git f260b51148b4f7584165e13fcf2320fdd5992a74)

1610.	[build]		fdupont
	Removed the obsolete compatcheck top directory.
	(Gitlab #667,!391, git 8cb113a52f0cf56fbdb5cb0e87464135234c2ac1)

1609.	[bug]		fdupont
	Fixed the implementation of authentication keys in DHCPv6
	host reservations. Please note this includes a PostgreSQL
	schema update.
	(Gitlab #550,!297, git f45511f0445cd4204671771175f7f0d34df54b0e)

1608.	[bug]		fdupont
	Missing debug DHCP6_PACKET_SEND logging message was added.
	(Gitlab #699,!401, git ac96edbe30be5c93f5e3d2512961f1bc99c3253a)

1607.	[bug]		tmark
	Corrected an initialization issue which caused lease sanity
	checking to be enabled inside the Lease File Cleanup (LFC)
	process.  The LFC cannot meaningfully perform sanity checking
	as it does not have access to the full server configuration.
	(Gitlab #686,!403 git 68b2cb0385779ef0c520164e418dee124d7cb364)

1606.	[bug]		tmark
	Corrected an error with retrieving DHCPv6 leases, whose IAID
	values are larger than int32_t max, from Postgresql lease
	databases.
	(Gitlab #651,!384, git 67e047df61d56558d474514a21ed0db96152557a)

1605.	[func]		marcin
	Extended mysql_cb hooks library to support new API calls for
	managing the DHCP servers in the database. In addition, added
	support for associating the global parameters with the server
	tags.
	(Gitlab #642,!373, git 8ca1021809a6c44cf8a6589a959e94ca9ca76c29)

1604.	[bug]		fdupont
	Improved configuration failure messages when the problem is
	from the configuration backend and not the configuration file.
	(Gitlab #616,!379, git 637e9f03cc502068822ab0310f2e070d4a4da339)

1603.	[perf]		tmark
	High Availability now registers its HTTP sockets with Interface
	Manager's main thread allowing the thread can monitor them for
	IO readiness. This should improve the responsiveness of HA peers
	to each other.
	(Gitlab #691,!395, git 4a0b024bc6d83b26fe702d95ee7ce0c914b37d8e)

1602.	[func]		fdupont
	Added more information to sanity-checker log messages.
	(Gitlab #685,!392, git 5367cd1196662739bbff5e99072ab6a55cfb0489)

1601.	[func]		fdupont
	Kea servers now add the lease validity lifetime to informational
	lease allocation log messages.
	(Gitlab #694,!399, git cb29b532cf1f8790f9752d7e8253b0aa31ce05e6)

1600.	[bug]		fdupont
	Fixed prefixLengthFromRange() routine.
	(Gitlab #583.!377, git 10bd31217d8a0a77345c4cba7a59314f70c1b509)

1599.	[perf]		marcin
	Improved performance of the DHCPv6 server running with High
	Availability by aggregating multiple lease updates in a single
	lease6-bulk-apply command instead of generating multiple
	lease6-update commands, one for each allocated lease.
	(Gitlab #689,!394, git 65021b840b94da3d118e541fba5469c8ed15175b)

1598.	[bug]		razvan
	Added unittests for long (> 65536 chars) tokens in parsed configs
	so any crash related to parsers could be detected.
	(Gitlab #604,!376, git 811735b67fcdb5592c3e020792c154f2f454259c)

1597.	[func]		fdupont
	Added new configuration parameters for handling user lease
	time hints to kea-dhcp4: min-valid-lifetime and max-valid-lifetime;
	and to kea-dhcp6: min-preferred-lifetime, max-preferred-lifetime,
	min-valid-lifetime, and max-valid-lifetime.
	(Gitlab #295,!325, git 8641448c4106bf28ea32df72e5e0ad520d3946ae)

1596.	[func]		marcin
	Implemented lease6-bulk-apply command in the lease_cmds hooks
	library.
	(Gitlab #683,!390, git 122473c18b632ddfa22b8a48f6d9399bc18e2598)

1595.	[func]		fdupont
	Removed unused t1_ and t2_ members from internal lease class.
	(Gitlab #567,!357, git 6072db5f4ca6cfa9573152c255f97dd170acbd57)

1594.	[bug]		fdupont
	Kea no longer uses the .../var/kea directory, for instance pid
	files are now in .../var/run/kea.
	BEWARE this applies to the kea-dhcp6-serverid file so if the
	server will not find the file at its new location it will believe
	it is the first time it is being started and will generate a new
	server DUID.  If that happens, clients will keep trying to get to
	the old server and be confused.
	(Gitlab #538,!334, git 928b9ae57452aae1dff92ad689ba180fa975381c)

1593.	[bug]		marcin
	Fixed a bug in the Kea Control Agent which caused a sporadic crash
	after a timeout while sending the HTTP response to the controlling
	client.
	(Gitlab #491,!363, git ff204dfe4dd80702f8bb2edf83f8486e019a7e04)

1592.	[build]		tmark
	Files related to YANG and netconf are now only installed
	when the build is configured with --with-syspro.
	(Gitlab #584,!364, git 350ae513ed4e8e8e07b159658f88ec7d70b644d3)

1591.	[doc]		razvan
	Fixed classify and pd-exclude documentation examples.
	(Gitlab #590,!380, git 26b04d2d2d2a88be6abc5879a2fb48e05f0003fd)

1590.	[func]		fdupont
	It is now possible to specify hostname-char-set and
	hostname-char-replacement at the global scope allowing to sanitize
	host names without requiring a dhcp-ddns entry.
	(Gitlab #540,!374, git 0a5979369902070ee0c4faf3b713627455b99489)

1589.	[bug]		razvan
	Fixed configuring kea with tools/cql_config when using --with-cql
	from source.
	(Gitlab #522,!261, git bf7debc182e094a8b34f1f2df99cf4e9f84c8906)

1588.	[func]		marcin
	Extended APIs of the DHCPv4 and DHCPv6 configuration backends with
	the management functions for the server tags.
	(Gitlab #641,!352, git 022d2266e71ced7ec79e0717298ca8e88330a7e7)

1587.	[bug]		razvan
	Fixed IPv6 prefix delegation pools retrieval from the MySQL
	Configuration Backend.
	(Gitlab #637,!349, git 483273734e8608ed68624d7a868f20672c859c95)

Kea 1.6.0-beta (development) released on May 29, 2019

1586.	[build]		razvan, marcin
	Bumped up libraries version numbers for Kea 1.6.0 beta release.
	(Gitlab #617,!340, git c0434bf882b6ec483120e39f6b70b5a40fe7c711)

1585.	[bug, func]	marcin
	MySQL Configuration Backend supports DHCPv6 interface-id parameter.
	(Gitlab #628,!341, git 3a07c636ba4c7fceabe59ec597c44a9c8e3367eb)

1584.	[doc]		marcin
	Documented Kea Configuration Backend in the Kea Administrator
	Reference Manual.
	(Gitlab #71,!314, git 3a65b7a9104f2a988dacf1acc26312b4259e958d)

1583.	[bug]		fdupont, marcin
	Corrected a bug which caused failures to merge a subnet from the
	Configuration Backend into the DHCP server's configuration
	when subnet identifier was modified.
	(Gitlab #492,!252, git c9aba2b5e915c27a8539e6b8f0498179ba896da4)

1582.	[bug]		tmark
	Input values for DHCPv4 and DHCPv6 options of type 'string'
	will now be trimmed of any trailing null bytes (0x0).
	(Gitlab #539, !330, git b126558e9e39e9bff517dceac25a00e96d150085)


1581.	[bug]		marcin
	Corrected a bug whereby the DHCPv6 server did not take into
	account a relay address specified at the shared network level
	during the subnet selection.
	(Gitlab #620,!332, git c2383e404a5227f6b55655c09ccdc03930815500)

1580.	[bug]		jonatan.raudsepp
	Compilation fix for Alpine linux in Perfdhcp code. Thanks to
	Jonatan Raudsepp for sending a patch!
	(Gitlab #624,!337, git 19321df9e4490b75ac7b322afec9d231bcb6ffe3)

1579.	[bug]		razvan
	Fixed a bug which caused setting dhcp4o6-port to not function via
	Kea configuration backend.
	(Gitlab #577,!331, git 98c24fe1873795bbc94d426c54c588b05d79406f)

1578.	[func]		fdupont
	The configuration syntax has changed. The Logging scope that used
	to be shared between all servers has been deprecated. Each daemon
	is supposed to define its own loggers using 'loggers' array. The
	old configuration syntax is still accepted, but is considered
	deprecated.  Kea 1.6 will accept it, but that capability will be
	removed in the future. Please migrate your configuration to new
	syntax.
	(Gitlab #208,!196, git 37b8ec6c2c4b64681059f8fad26d112adbb7ee2b)

1577.	[func]		razvan
	Implemented host reservations page retrieval for Cassandra.
	(Gitlab #511,!278, git 152e82b49f5e5abd9d3a2a4825ed8620973f5ef1)

1576.	[doc]		fdupont
	New commands cache-get-by-id and cache-size are now documented.
	(Gitlab #594,!324, git 3753008cc77f71457b5d777560d8e36dc56e7acd)

1575.	[bug]		razvan
	Fixed issue with keactrl logging error when trying to stop running
	services.
	(Gitlab #534,!327, git 6ddee0a93ec4ad692cc385150c159d9e8da5232d)

1574.	[bug]		razvan
	Add logging to the MySQL config backend.
	(Gitlab #398,!315, git bc46fd3420afdf60ae8841866e8458f7f6e072e8)

1573.	[bug]		razvan
	Fixed build sysrepo from sources using sysrepo_config.
	(Gitlab #523,!262, git b86864a9b058a18eaaded2273dc5f40a9ec97c78)

1572.	[bug]		tmark
	Corrected an issue where kea-dhcp6 was incorrectly scheduling DNS
	entry removals when renewing leases with generated FQDNs.
	(Gitlab #577,!310, git 362f40bebbdbe083ec6420a43ee1c050edf6bba6)

1571.	[bug]		marcin
	The mysql_cb hooks library registers the MySQL backend for the
	DHCPv6 server.
	(Gitlab #603,!322, git 1ede298fcdc7a9b7018b6e300e2d759e33f73645)

1570.	[bug]		marcin
	Corrected the bug in the Kea HTTP library which could cause a server
	to assert when system clock was modified during the transaction.
	(Gitlab #599,!320, git 958abe5063b6e602c0070e336524e313c3a87671)

1569.	[perf]		fdupont
	Improved performance of the DHCPv4 server in cases when
	match-client-id set disabled by removing unnecessary query to the
	lease database."
	(Gitlab 509,!272, git 2ad41651c1118fe6f7dfb918df0694dd254706f1)

1568.	[bug]		tmark
	kea-dhcp6 now properly skips sanity checking prefix leases.
	Prior to this it was incorrectly subjecting them to sanity
	checks during memfile lease file reloads and then flagging
	the leases as incorrect.
	(Gitlab #591,!#313, git 12262c5df19673652be73cf1dd62d07527bee95d)

1567.	[bug]		marcin
	Kea HTTP client now always includes Host header in all HTTP requests.
	The Host header is required in all HTTP/1.1 requests. This corrects
	the problem whereby HA peers were unable to communicate via reverse
	HTTP proxy because the proxy was responding with Bad Request status
	when no Host header was included.
	(Gitlab #360,!305, git ddb6dbf4cf63e98d3954c5d46e0311abc4fd6cfc)

1566.	[func]		tmark
	kea-dhcp6 can now be configured to calculate values to
	send to clients for T1 and T2 times. Prior to this
	it was only possibly to specify explicit values.
	(Gitlab #365,!296, git 144b83a84c836d6ff17620b35cb74f830b13c2eb)

1565.	[func]		marcin
	MySQL Config Backend returns server tags associated with the
	configuration elements.
	(Gitlab #579,!309, git 1e2648df047fe964e8ad3e9deb1c85eea32b1219)

1564.	[func]		fdupont
	Implemented two new commands to manage subnets:	subnet4-update and
	subnet6-update. They allow an update of existing subnets
	configuration.
	(Gitlab #465,!265, git 71eb9188033f81dab56fc5a847a39f5497398b62)

1563.	[bug]		razvan
	Fixed compilation of google benchmarks.
	(Gitlab #520,!260, git 11aa890d30ecce5518b9f0bad389feea6be78167)

1562.	[bug]		marcin
	Corrected a bug whereby the DHCP server would trigger a segfault
	upon termination when MySQL configuration backend was in use.
	(Gitlab #571,!306, git 705e7bb6dd27ec90dd2807d4aac0905e3cb13de4)

1561.	[func]		tmark
	kea-dhcp6 now automatically deletes configuration elements
	that have been deleted from configuration backends.
	(Gitlab #566,!304, git 2e85376f1b57187b822c662144380e04372cffff)

1560.	[bug]		fdupont
	kea-dhcp4 now permits option code values of 0 and 255 for
	options defined in option spaces other than the "dhcp4" space.
	(Gitlab #564,!300, git 7a0a0b84d91893f08c0ee6f236daa05bede65166)

1559.	[func]		fdupont
	Added DHCPv6 support to the MySQL Config Backend hook.
	(Gitlab #397,!244, git 980091ecd717e41a61f0d7f6808213e450647d8e)

1558.	[func]		tmark
	In addition to a continuous string of digits, hexadecimal
	literals may now be a series of one or more octets separated
	by either colons or spaces.
	(Gitlab #484, git 251efcd5f518a215173845b22555276df0e0ffc6)

1557.	[bug]		marcin
	Added support for "reservation-mode" parameter in the shared network
	configuration parsers. It corrects a bug in Configuration Backend
	whereby host reservation mode was not stored in the database when
	specified via remote-network4-set command.
	(Gitlab #517,!301, git e6533001e9d850432254d3cfe995a4f7abcee6e2)

1556.	[bug]		fdupont
	Corrected parser for option definitions to refuse definitions with
	duplicate code or name.
	(Gitlab #503,!246, git 0befb653277463cd8f88740119fe90a93dbb1466)

1555.	[bug]		fdupont
	Corrected parsers for option definitions to prevent setting out of
	range option code values.
	(Gitlab #500,!247, git 5c139602d7656df74060fee63461ffba4f290547)

1554.	[func]		tmark
	kea-dhcp6 now uses globals, option definitions, options,
	share-networks, and subnets from configuration backends.
	(Gitlab #413,!288, git ff367e273ed8763b354db272c5955a78203d865e)

1553.	[func]		marcin
	DHCPv4 server automatically fetches incremental configuration updates
	from the configuration backends.
	(Gitlab #103,!277, git 319f7709edb40d6c01390a34942b9d4a200b333e)
	(Gitlab #103,!289, git 80087e2d0f90f9ba6623860fed4f4d33ee935ad0)

1552.	[bug]		marcin
	Corrected inheritance of the subnet and shared network specific
	parameters in the MySQL Configuration Backend.
	(Gitlab #552,!295, git 4812e4227a57b29bfa3995e71588233424a3abb1)

1551.	[func]		razvan
	Added consistency and serial-consistency parameters to CQL
	connection. Fixed all statements.
	(Gitlab #16,!287, git 56a9b6a860899274f9cafe2366a6731a46490e92)

1550.	[func]		marcin
	Implemented inheritance of the DHCPv4 global and shared network
	specific configuration parameters when using configuration
	backend.
	(Gitlab #490,!284, git 2508f942e879ef74b20c07ffdba37d187d6ea932)

1549.	[func]		tmark
	kea-dhcp6 can now be configured to fetch data from configuration
	backends. It does not yet utilize the data fetched.
	(Gitlab #104,!290, git d8a25c1ecd17ad24bdce6af19e7a42ce66d4c4f2)

1548.	[func]		razvan
	Added consistency and serial-consistency parameters to CQL
	connection.
	(Gitlab #16,!266, git 5771173d721464d879869fad6456211031858d6c)

1547.	[bug, doc]		fdupont
	Option value for sip-ua-cs-domains has been corrected in the
	Kea User's Guide. Thanks to Shawn Routhier from Infoblox for
	reporting this issue.
	(Gitlab #536,!281, git c128fd9a6b7bffc36ba4fe9a0badebe55441d673)

1546.	[func]		tmark
	kea-dhcp4 now uses options fetched from configured backends.
	(Gitlab #401,!254, git 6a33a6f1810f5899ff9c8bc79d0093eebad5c728)

1545.	[func]		fdupont
	A new parameter "data-directory" has been added to DHCPv6.
	If specified, it allows DHCPv6 server to store lease and
	server-id files in non-standard locations.
	(Gitlab #430,!263, git 1f094e18a21124abcaf846cab52c8cba65ca36bc)

1544.	[build]		fdupont
	Message compiler is no longer needed during compilation and
	generated message files are part of the distribution. They can be
	regenerated using --enable-generate-messages switch passed to
	configure script.
	(Gitlab #441,!233, git 499b7c36454bcac2553f7bf304d48d7d80f4d4ca)

1543.	[bug]		fdupont
	Corrected behavior of the remote-subnet4-set so as it is now
	possible to set the subnet using both an ID or a subnet prefix.
	(Gitlab #481,!251, git 9ef651950fde16e258e4b03dd21bbf6dd07d5231)

1542.	[test]		tmark
	MySQL, PostgreSQL, and CQL unit tests will now attempt to wipe
	the unit test data, rather than the (re)create the schema between
	each test.  This reduces test execution time appreciably.  The
	behavior may be overridden by defining environment variable:
	KEA_TEST_DB_WIPE_DATA_ONLY="false".  This will cause the schema
	to be recreated before each test but may dramatically increase
	test execution time.
	(Gitlab #526,!269, git 7e81d7bea27e919b652351880872aae68ad1b209)
	(Gitlab #531,!279, git 7f8c4fc535df3019789aea1881b7bb3bd539963a)

1541.	[bug]		fdupont
	Empty Relay Agent Information option is no longer sent in server
	responses. Thanks to Geoffrey Huang from Qingdao Agricultural
	University, and Jiaqi Liu from Qingdao WuKeSong Company
	Communication Limited, Shandong, PRC for reporting this issue.
	(Gitlab #519,#510,!271, git f3563396d2227e48e96a5d65587406d8d1868db5)

1540.	[func]		fdupont
	Added a new method deleteSharedNetworkSubnets4 in the config
	backend API to delete all subnets belonging to a shared network.
	(Gitlab #512,!256, git 76991c42d115641c7fdcd0f215137be578fb39a0)

1539.	[build]		fdupont
	Obsolete dns++.pc file for pkg-config was removed.
	(Gitlab #498,!274, git 93cd62c99f69cc379c08cd06791db522c1fb0aca)

1538.	[func]		marcin
	DHCP configuration parsers correctly handle unspecified parameters.
	This change was required for the MySQL Config Backend to record
	unspecified parameters as NULL in the database.
	(Gitlab #488,!259, git d3b33058651036be34200f16d2da230267415056)

1537.	[func]		godfryd
	Improved handling unix sockets in unit tests. Now by default
	they are created in temporary folder under /tmp folder. This
	fixes the issue with creating sockets with too long path
	in the case when source folder is deeply nested.
	(Gitlab #357,!258, git a45e2f68d7d1848adb0cf755954a3d76c9dff338)

1536.	[build]		tomek
	Many changes in keactrl, kea-admin, cql_config and sysrepo_config
	scripts. ISC is now using shellcheck to verify portability of
	our scripts.
	(Gitlab #480,!245, git 8818ba0260ba36710b88db6401069f9fe4f3a73a)

1535.	[func]		godfryd
	Added checking required Vagrant version by Hammer.
	Removed Hammer from EXTRA_DIST.
	(Gitlab #518,!257, git ea0006f6eb948d7d4a034b413c5086cbe483eb75)

1534.	[func]		marcin
	MySQL config backend correctly handles the optional values for
	subnets and shared networks. Also, updated the MySQL config
	backend to store and fetch T1 and T2 percentage settings.
	(Gitlab #489,!250, git 01fc4d5bb4105b90c7025e8ca8131c3c15203848)

1533.	[doc]		sgoldlust,stephen
	Kea User's Guide significantly updated.
	(Gitlab #362,!182, git 4b7a8df6054d18f2c90fe61d93533466f89e6324)

1532.	[func]*		marcin
	Renamed OptionalValue C++ object to Optional and modified its
	API. This object is now used to represent optional values in
	subnets and shared networks. This is an internal Kea logic
	change but it may impact existing user hooks libraries.
	(Gitlab #487,!232, git 1c58e0ce9b9fd6fc8864dbfb2335bc5841c78ff3)

1531.	[func]		tmark
	When fetching configuration data from configured backends,
	kea-dhcp4 will now merge option definitions.
	(Gitlab #400,!243, git 0c5d1417031e49bd0c247889989e187db2dd8f4b)

1530.	[bug]		adwol
	Potential syntax error in keactrl fixed. Thanks to Adam Osuchowski
	from Silesian University of Technology for providing a patch.
	(Gitlab #162,!241, git b1a1137f252432aa956ed6fea3da21c740857333)

1529.	[func]		tmark
	When fetching configuration data from configured backends,
	kea-dhcp4 will now merge global parameters.
	(Gitlab #402,!224, git dadaf76f8dd61b8bb3405aa5dc80029f09b2d4ec)

1528.	[func]		fdupont
	Aligned DHCPv4 and DHCPv6 specific tables used by the MySQL Config
	Backend. Extended MySQL schema to implement audit trail for the
	DHCPv6 Config Backend.
	(Gitlab #460,!232,!236, git 57f945f917db522773281c9e95ec8027afae6205)

1527.	[build]		adwol,fdupont,tomek
	Default Kea installation directory has been changed to
	${prefix}/lib/kea/hooks.
	(Gitlab #161,!240, git cfaf16cf02191bf5b7172cade3f58a626288b5f0)

1526.	[func]		tmark
	In addition to subnets, when fetching configuration data from
	configured backends, kea-dhcp4 will now merge shared-networks.
	(Gitlab #399,!215, git 6b57b6b5d678c91b6b380fbe08beafd06b0e7b1d)

1525.	[func]		fdupont
	Defined API for the DHCPv6 Configuration Backend.
	(Gitlab #458,!231, git f16e03d9bf1c10903c16b2614223b10880f73d50)

1524.	[func]		tomek
	Support for vendor options improved in DHCPv4 and DHCPv6. Kea is now
	able to send back vendor suboptions, even if the client packet didn't
	include DHCPv4 vivso (125) or DHCPv6 vendor (17) option. Usage of client
	classification in such a case is required, though.
	(Gitlab #464,!238, git 5c79da9358862657a631a9a8fc2ce79ae26b762e)

1523.	[bug]		fdupont
	IfaceMgr::send method now returns proper status that matches
	its documentation. Thanks to Matthias Stoeckl from Secunet
	for reporting this issue.
	(Gitlab #417,!221, git 4be58523f38097cea81ea06161aead58e00aeb2a)

1522.	[bug]		marcin
	The "unspecified" DHCP timer values (e.g. renew-timer) are
	represented as NULL values in the database. This corrects
	a bug whereby the unspecified timers defaulted to 0 which
	prevented the DHCP server from calculating the timers to
	be sent to the client. Instead a value of 0 was sent.
	(Gitlab #451,!227, git 5ec9a55528fbcfff4e0c808f9a745b9fd3a5dfae)

1521.	[func]		marcin
	Removed subsecond precision for the timestamps in MySQL config
	backend. It caused issues on systems with MySQL version prior
	to 5.6.4 which don't support subsecond timestamp values.
	(Gitlab #444,!229, git 71200e98f5a862908240a0d2e269b5da23290af9)

1520.	[build]		fdupont
	Made perfdhcp build optional and off by default: to build it
	please use the new --enable-perfdhcp configure flag.
	(Gitlab #340,!220, git b2d9a5559c348e82d6730809ccf1429097a9872c)

1519.	[bug]		Brent Bloxam
	A bug in kea-admin that always assumed the PostgreSQL database is
	always local has been fixed. Thank you to Brent Bloxam from
	Beanfield Metroconnect for submitting a patch!
	(Gitlab #423,!216, git d14e2f34c7d544aeb5e1e219f305fac9ab18c498)

1518.	[func]		marcin
	Extended MySQL schema to include the types of the global DHCP
	parameters in the database. The Kea servers will use this
	information to cast the values fetched from the database into
	their actual types. The supported types are: string, integer,
	boolean and real.
	(Gitlab #429,!217, git edd745c507ce5a888461df1489311de0c22cd312)

1517.	[func]		tmark
	kea-dhcp4 will now connect to and fetch configuration data from
	configured backends. At this point, only fetched subnet data is
	merged and used.
	(Gitlab #101,!202, git c572f8aea94349ff5fb4afee13a88ba811cc6459)

1516.	[func]		marcin
	Implemented audit trail for MySQL Configuration Backend. It allows
	for tracking incremental changes in the servers' configurations.
	Both mysql_cb hooks library and the MySQL schema have been updated
	to facilitate this feature.
	(Gitlab #396,!205, git 6d40db07ef641eef29405c42e718979e7a1e8675)

1515.	[func]		fdupont
	Changes required for new host commands that retrieve all host
	reservations from a given subnet (reservation-get-all,
	reservation-get-page) added. Also added documentation.
	(Gitlab #313,!199, git 991b2fadcb9e8171a78e27f95e4bfba6393d7824)

1514.	[func]		fdupont
	Control Agent and DHCP-DDNS daemons now support config-reload
	command, that instruct a given server to load again its
	configuration from a file on disk.
	(Gitlab #375,!192, git 93648a3a4918225e2c4413ae220fccc59eaea99a)

1513.	[func]		godfryd
	Fixed perfdhcp that now it keeps requested rate during performance
	testing. Previously it was always about 20% lower than expected.
	(Gitlab #283,!135, git 329f54bb151ec35888e9a8070cc5fa368d6f1f5e)

1512.   [func]      tmark
	kea-dhcp4 will now ignore empty Host Name (option code 12) values
	received from clients.  While an empty value for this option is
	not RFC-compliant, some clients do send them.  Prior to the this
	server would drop the entire packet.  In the spirit of being liberal
	in what we accept, the server will now simply omit the option.
	(Gitlab #40,!203, git f41bd35c3e7a3bdc1f31c5602fd91d5c84c60163)

1511.	[func]		fdupont
	Obsolete experimental secure DHCPv6 options (701-704) removed.
	(Gitlab #386,!196, git 1114527652615fb730e323946cafaf1c7ca72b42)

1510.	[bug]		fdupont
	DHCPv4 and DHCPv6 no longer crash if badly broken configuration
	is received.
	(Gitlab #381,!193, git f45fe7b7e3916d36d017b4ec5b50588fbf517d86)

1509.	[func]		tmark
	kea-dhcp4 can now be configured to calculate values to
	send to clients for for T1 and T2 (options 58 and 59
	respectively).  Prior to this it was only possibly to
	specify explicit values.
	(Gitlab #365,!194, git 67944844a40436cd69e0e5b4962f5c9cba89ef6f)

1508.	[func]		fdupont
	Implemented the management API using a control socket for the
	DHCP DDNS (D2) server. D2 now supports the following commands:
	build-report, config-get, config-set, config-test, config-write,
	list-commands, shutdown and version-get. Also, extended Control
	Agent (CA) to support one additional command: config-set.
	(Gitlab #30,!183, git ab27550cec365f42289eb5fa1bc39f33f01b19c2)

1507.	[func]		tmark
	kea-dhcp4 now ensures that the message type option (53) is
	the first option in outbound DHCPv4 packets.  This was done
	to accommodate non-compliant clients that require the option
	to be first.
	(Gitlab #363,!177, git 34f40035bf7a7849083138cacee440a9f0991d67)

Kea 1.5.0 released on Dec 14, 2018

1506.	[build]		marcin
	Bumped up libraries version numbers for Kea 1.5.0 final release.
	(Gitlab #338,!168, git 551c5d704804d0ab2ea276e95dbae66b9d0f5561)

1505.	[bug]		marcin
	Corrected an issue in the lease_cmds hooks library which caused
	errors while adding leases with high lease expiration time value
	to the database. Many thanks to Shawn Routhier from Infoblox for
	finding and reporting the issue.
	(Gitlab #337,!167, git 3fcdc28814310ac93b3903897e952b3b60cfa0bc)

1504.	[bug]		fdupont
	Created separate control buffers for reception and transmission
	over UDP sockets.
	(Gitlab #327,!166, git cbb573858d7b1a4d2ba2316db457aa55ab037fc3)

1503.	[doc]		fdupont, marcin
	Updated "JSON Configuration" section of the Kea User's Guide.
	(Gitlab #198,!160, git 94c66b3c071d7bbf4b247bf57cd75ddcc343177e)

1502.	[bug]		fdupont
	Unicode parser for JSON structures has been improved. It now
	handles escape sequences better.
	(Gitlab #45,!40, git ba9b18cf2af66f8fb80e3dbbe13da11c99764588)

1501.	[func]		fdupont
	keactrl now supports kea-netconf. The new daemon is disabled by
	default. Please edit keactrl.conf (netconf=yes) if you want to
	start using it.
	(Gitlab #186,!163, git 8f7d556456891e7c675082f7e6cc88da71a92fee)

1500.	[func, doc]	tmark
	Streamlined the isc::dhcp::PacketQueue interface and
	added a section on Congestion Handling to the developer's guide.
	(Gitlab #278,!162, git 0ce615f5da993ac90f675c5315ba7cb5c2ef3e1c)

1499.	[func]		tmark
	For Kea 1.5.0, congestion handling has been disabled by
	default.
	(Gitlab #277,!164, git 8d87c46a3cc7b7be4dd5f751b48449e92ee62d84)

1498.	[bug]		marcin
	Corrected behavior of the DHCP servers with respect to the
	"reconnect-wait-time" parameter setting. This parameter is
	specified in milliseconds, but the servers used to interpret
	it as specified in seconds.
	(Gitlab #173,!154, git 377f49e84ad6ebc91cbeac4116d24a15571c522d)

1497.	[func]		fdupont
	All YANG modules now have a revision specified. When starting,
	kea-netconf daemon will now check if the required modules are
	installed and have a proper revision. This should help spotting
	issues when migrating from older YANG modules.
	(Gitlab #204,!121, git 9e772e1472e073ee85924cfc706cb57a5e70a0b1)

1496.	[doc]		marcin
	Updated Kea documentation to reference RFC 8415, which is the
	new DHCPv6 specification. It obsoletes a number of RFCs:
	RFC 3315 (previous DHCPv6 specification), RFC 3633, RFC 3736,
	RFC 4242, RFC 7083, RFC 7283 and RFC 7550. Kea documentation
	now refers to RFC 8415 where appropriate instead of obsoleted
	RFCs.
	(Gitlab #288,!158, git 974b033a8de7a8e671156c33efeb13d4ac847c96)

1495.	[bug]		marcin
	Corrected an issue in the Memfile lease backend which caused
	errors while reading leases with very long lifetimes. Many
	thanks to Shawn Routhier from Infoblox for finding and reporting
	the issue.
	(Gitlab #303,!151, git ab92ab6fcd414f1efc7c5de6a641274da7c04e92)

1494.	[bug]		marcin
	Kea servers reject commands with unsupported parameters.
	(Gitlab #253,!147, git 7fc55489887c0e8f32db5c1fe9f46fa1cc2a4407)

1493.	[bug]		marcin
	Names carried in DHCPv4 Client FQDN option, Hostname option and
	stored in the lease database are case insensitive.
	(Gitlab #86,!152, git d9e23e2a6a3114b1c87de9c881ef10cdb1e00c61)

Kea 1.5.0-beta2 released on Nov 30, 2018

1492.	[doc]		fdupont
	Added a step by step netconf operation example in the
	Kea Administrator's Guide.
	(Gitlab #195,!131, git 994a826caf3c1a9f5f84d8b703a3b202120e91b6)

1491.	[build]		tomek
	coroutine.hpp from Boost 1.68 has been added the Kea source.
	It is used only if the Boost library provided by the system
	is very old and does not include that header. This effectively
	reverts the change done in Kea 1.4.0.
	(Gitlab #293,!45, git df0f507b8b750c8dff1f537cad5b5748b7841852)

1491.	[build]		marcin
	Bumped up libraries version numbers for Kea 1.5.0 beta2 release.
	Also, generated logger message files are now installed with Kea.
	(Gitlab #62,!144, git 7dc8d73a58504fd81a49b1c54651388d53d98d53)

1490.	[bug]		marcin
	Applied fixes in Cassandra Host Manager which prevents Kea
	crash during an attempt to delete non-existing reservation.
	In particular, this crash was observed as a result of sending
	reservation-del command over RESTful API.
	(Gitlab #27,!138, git 8666ed4754ffd27f3aa46a2cf3e4b161a1d877ee)

1489.	[doc]		fdupont
	Added examples of global host reservations.
	(Gitlab #136, !143, git bee8b8620f849f6bcaf2b31c3b130bb371c6312c)

1488.	[doc]		marcin
	Added stat_cmds to the list of available hooks libraries.
	(Gitlab #85,!142, git 08615372b4f869fe61b13559efa33d0d9794d79b)

1487.	[doc]		marcin
	Corrected broken links and various typos in Kea documentation
	which had been identified during Kea 1.5.0 beta1 release
	process.
	(Gitlab #263,!137, git 79a224288efa1e1c51b0f2ec11ff646563b306e1)

1486.	[func]		tmark
	For Kea 1.5.0-beta2, congestion handling has been enabled by
	default. This was done to expose the feature to more testing.
	We will finalize the default setting prior to releasing Kea 1.5.0.
	(Gitlab #276,!132, git fda1f985997412a58d3b4eee4a1ca0588d3f3beb)

1485.	[func]		fdupont
	Simplified and updated Kea YANG models. For instance the list of
	loggers was moved from the removed logging container to global
	config parameters.
	(Gitlab #204, !97, git 1de6c2987ec9067b7c1baa577c6dcd6ddd1b30fb)

1484.	[bug]		marcin
	Resolved issues with MySQL backend failing to insert a lease
	to the MariaDB database on OpenSUSE. This fix may also
	improve stability of the MySQL backend on other systems running
	MariaDB.
	(Gitlab #53,!125, git 038eddbc7b904289e4b74b5ef2406cb57f79a646)

1483.	[func]		tmark
	Use of congestion handling is now optional via the 'enable-queue'
	flag added to 'dhcp-queue-control'.  It is disabled by default.
	When disabled Kea's DHCPv4 and DHCPv6 servers will consume packets
	directly from interface sockets in the main thread (i.e. employs
	pre Kea 1.5 technique).
	(Gitlab #260, !120, git 9e304fae48d0d0658fd39a21aba9da528b4cc6f4)

1482.	[func]		fdupont
	The configuration parameter "reservation-mode" can be specified
	at global (new), subnet and shared network levels.
	(Gitlab #268,!126, git c72d381c39868308c7d11c7d4def3bdae0a0e04e)

1481.	[func]		fdupont
	Cleaned up the keatest-module YANG test module.
	(Gitlab #204,!98, git a830adcefd9306969216d35c51306df3610278bb)

1480.	[func]		fdupont
	The unused configuration parameter "always-include-fqdn"
	was removed. Configurations using it will be rejected as
	it is no longer recognized.
	(Gitlab #182,!128, git cafeba167e7c64370dd39eca4551f61acd89d3da)

1479.	[build]		fdupont
	Support for sysrepo 0.7.6 (and libyang 0.16-r2) was added.
	Previous versions of sysrepo (and libyang) are still supported.
	(Gitlab #176, !107, git 4304a10b21708afb2a7599c77bc7508a600333cb)

1478.	[bug]		marcin
	Performance improvements in the HTTP client code used in the
	Kea High Availability.
	(Gitlab #57,!122, git 7bd97af1f3d7670cd64cadf0d0cb9ddbe4e74909)

Kea 1.5.0-beta1 released on Nov 9, 2018

1477.	[build]		marcin
	Bumped up libraries version numbers for Kea 1.5.0 beta release.
	(Gitlab #261,!119, git 54d63139048e7fe2dd0384b547ed6f8b96ff0e8f)

1476.	[func]		tmark
	Added initial implementation of congestion handling to kea-dhcp4
	and kea-dhcpt6. This adds a new top level element to the server
	configurations, "dhcp-queue-control".  Both servers will now
	read client packets from interface sockets in a separate thread
	queueing them for server level processing.  For Kea 1.5-Beta
	this feature is always on.
	(Gitlab #42, !103, git 09d5ffebc8f9bfab2ab99c384eec9c3a3c915f39)

1475.	[func]		sebschrader
	Add authoritative feature for DHCPv4 from ISC DHCP: requests from
	unknown clients are dropped (default/previous behavior) or
	answered with DHCPNAK (new behavior with new authoritative flag
	set to true for the subnet). Patch proposed by Sebastian Schrader.
	(Gitlab #66, !115, git 0fc1b767826f214475025d8631227970de368de5)

1474.	[doc]		godfryd
	Updated list of supported operating systems.
	(Gitlab #205, !109, git 73253af554cf48434798282f8440a99b1494fd04)

1473.	[doc]		tomek
	Outdated FAQ section removed from the User's Guide.
	(Gitlab #118, !113, git 7d079384bd5f49e0e36a571ee964bfd7d6ebd25d)

1472.	[bug]		marcin
	Timeout is now reported by the HTTP client when connecting to the server
	takes too long. This eliminates HTTP client hangs when firewall is
	misconfigured and causes connection to never be established. This issue
	was found during Kea High Availability testing.
	(Gitlab #26,!106, git 9724823f160af0ef5e8ccdf779087ff08a04457a)

1471.	[bug]		lmasarati
	Fixed a bug in kea-admin that ignored specified remote hostname.
	Thank you to lmasarati and Thorsten Krohn for reporting it and
	proposing a patch!
	(Gitlab #61, #138, !114, git 901cac7dc85ad8dacf631bf3a5c266eefeb3e6a1)

1470.	[func]		marcin
	Improved lease database synchronization mechanisms in High
	Availability hooks library. The new implementation uses
	lease4-get-page and lease6-get-page commands to fetch leases
	from the partner server. This prevents timeouts occurring
	during long synchronizations as well as decreases CPU and
	memory consumption on the HA enabled servers during lease
	database synchronization.
	(Gitlab #78,!85, git c54ea216463dcc6df693c96c4a5f82c0fbec2ff6)

1469.	[doc]		marcin, fdupont
	Documented new class_cmds premium library which is used
	to modify client class configuration of the DHCP servers.
	(Gitlab #64,!41, git c1c1d0b71496d81b330a8c1eb95996bbf634ada0)

1468.	[build]		wlodek
	make distcheck fix.
	(Gitlab #202, !111, git 5d8fb5f7af5fa36f4cb2b89f10631683b2e230d5)

1467.	[doc]		fdupont, tomek
	Doxygen errors fixed.
	(Gitlab #180,!93, git d12fb04d71c3b2d0e84ebb2c957334454b5705c4)

1466.	[func]		fdupont
	Added random number generation in services provided by
	the crypto library (and ultimately by the crypto backend,
	i.e. Botan or OpenSSL).
	(Gitlab #29,!9, git 609ddc69613dc828b3d93673d61a2c259c3944aa)

1465.	[build]		marcin
	Removed libkea-process dependency on MySQL, Postgres and
	Cassandra libraries.
	(Gitlab #194,!104, git bcce7d3c2226c10218d537c4688344c3b7f8c84a)

1464.	[build]		marcin
	Exclude mysql_cb hooks library from the Kea 1.5.0 release. This
	library will be added back in Kea 1.6.0 release.
	(Gitlab #93,!105, git 49572aa300ea2b25712d7e8cea0dd0df34faf7ee)

1463.	[bug]		tmark
	Added missing parsing logic for the reservation-mode value,
	"global", to kea-dhcp6.  The parsing logic was somehow omitted
	and caused kea-dhcp6 configuration parsing to fail on values
	of "global".
	(Gitlab #129,!55, git 00352d701f61274f0993b468a413af6c5623af3d)

1462.	[build,doc]	tomek,sgoldlust,vicky
	Kea REST API is now documented. Thanks to Suzanne Goldlust for
	providing descriptions for great majority of commands and to
	Vicky Risk for review and corrections. Also, docgen, a new
	tool for documentation generation has been written.
	(Gitlab #10,!3, git 5d2e4d6fcc182a19eafa895abc35b1aee599fd23)

1461.	[doc]		marcin, fdupont
	Added new sample configurations providing all parameters at
	the exception of host reservations for DHCPv4 and DHCPv6 servers
	for testing of configuration managers.
	(Gitlab #130,!89, git 4bc7e0dbe4804f63c51d100a8f724327e3d3a936)

1460.	[func]		tmark
	While kea-dhcp4 and kea-dhcp6 configuration parsing supports
	configuration backend elements "server-tag" and "config-control",
	use of these parameters has been disabled. Development of this
	feature will resume after Kea 1.5 release.
	(Gitlab #101,!87, git 4292a7ef7ab268826f846812e7320e1fe1fc46ef)

1459.	[func]		marcin
	Implemented libdhcp_mysql_cb hooks library which provides
	Configuration Backend functionality for MySQL.
	(Gitlab #93, git 98456608056b3361352b3127767138845eeb5d00)

1458.	[func]		fdupont
	Control sockets for kea-netconf has been implemented. The code is
	not functional yet, but the capability of the kea-netconf daemon
	to communicate with CA, D2, DHCPv4 and DHCPv6 daemons is there.
	(Gitlab #153,!60, git 11486e255aef704114645f8e7c5fee9c3abf9e76)

1457.	[func]		tmark
	Both kea-dhcp4 and kea-dhcp6 configuration parsing support new,
	server-level configuration elements "server-tag" and "config-control".
	While these elements will parse, they are not yet used by the servers.
	(Gitlab #32,!23, git c0727407da8d749d9fb51d873a725369800c967b)

1456.	[build]		tomek
	Extended Kea version is now stored in a separate file for
	build performance reasons.
	(Gitlab #137,!42, git 87479e979ca3d3025cb4129ace991a59e32e0f62)

1455.	[func]		fdupont
	Implemented hexstring(value, separator) operator that can be used
	in any expression, such as client classification, flex-id or
	RADIUS attribute.
	(Gitlab #67,!34, git 004d9a29db09b1c203c52e23585bd275c52095fa)

1454.	[func]		fdupont
	Unused interface-id and rapid-commit parameters removed from
	DHCPv4 parser.
	(Gitlab #116,!24, git 7e47292f10acb9179241c991d3591e9bfa47c37d)

1453.	[func]		marcin
	Updated MySQL schema to facilitate Kea Configuration Backend
	feature.
	(Gitlab #89,!22, git e28c0c7b3e7a7729167cdad993f634ed1f0ac53b)

1452.	[func]		marcin
	Implemented libkea-cb library which includes basic class
	hierarchy for the Kea Configuration Backend.
	(Gitlab #28,!20, git fb5c031ecaf4182e56f62874e9a6bd4c1d755a77)

1451.	[build]		tmark
	Resolved a namespace issue with std::distance() in libdhcp++.cc
	when building with Boost 1.68.   Thanks to Huy Vu and Khem Raj
	for reporting and suggesting a fix.
	(Gitlab #109,!21, git 1fd301f998129e9926ffa35eac27768ae150633d)

1450.	[build]		tomek
	Dependencies improved. libkea-process no longer requires libkea-dhcpsrv.
	As a result, D2 and CA are no longer linked with libkea-dhcpsrv.
	(Gitlab #25,!14, git cdb3a6f2d98a303b80433df7e0d5698c77897b7f)

1449.	[func]		tmark
	Modified Kea 1.5.0 database upgrade scripts to convert
	subnet ID values of 0, to either null (MySQL and Postgres)
	or 0xFFFFFFFF (CQL), in existing host reservations. This
	is done to accommodate support for global host reservations.
	(Gitlab #15,!11, git 25b54fd9ced4c6d3a2c8ceff9cc7c866b56da2c1)

1448.	[build]*	marcin
	Created new Kea libraries: libkea-database, libkea-mysql,
	libkea-pgsql and libkea-cql. Some database specific code was
	moved from libkea-dhcpsrv to those new libraries.
	(Gitlab #92,!13, git 5feb6b8a53675c27715e9e8fbeb312bd6eb17547)

1447.	[doc]		tmark
	Updated Kea Administrator's Guide with discussions of the
	use of subnet ID parameters in hook library commands.
	(Gitlab #14,!15	git# 4a7da8069feab1e21132689a9368f8ccb4174683)

1446.	[func]		tmark
	kea-dhcp6 now supports global host reservations and a new
	global reservations-mode .  Prior to this reservations could
	only be specified per subnet.  This is supported by by Memfile,
	MySQL, PostgreSQL, and Cassandra host data sources.
	(Gitlab #13,!6, git# a5484c4d8852662be7da1e6e8b1d4c1a19e6502f)

1445.	[func]		tomek
	Implemented initial skeleton version of the kea-netconf tool.
	Currently it can't do anything, but the build system is now
	capable of detecting sysrepo (use --with-sysrepo in configure),
	there's a very basic documentation and unit-tests.
	(gitlab !1, git 89ff2093811d65220d99dc2a6516375c4ec953dc)

1444.	[bug]		tomek
	keactrl version tests now work properly on macOS.
	(Gitlab !5, git a8c385e1507ffd101f65b445783b0355b01decce)

1443.	[func]		tmark
	kea-dhcp4 now supports global host reservations and a new
	global reservations-mode .  Prior to this reservations could
	only be specified per subnet.  This is supported by by Memfile,
	MySQL,PostgreSQL,and Cassandra host data sources.
	(Trac #5705, git f991cffd06add941f8bf2937232f51d597623e21)

1442.   [func]		MayyaSunil
	Implemented new queries for IPv6 leases by DUID.
	(Github #99, git c20b5248da1283e596e35ad057ae242f4d613965)

1441.	[func]		marcin
	Added log message indicating that the control socket has been
	opened by a server.
	(Gitlab #8, git 3dbaf4917bea112466f1ee5726870c545950e114)

1440.	[func]		tmark
	The internal representation of an "unused" subnet-id has been
	changed from zero to 0xFFFFFFFF. The largest, valid value for
	a subnet's ID is now 0xFFFFFFFE.  Three new constants have been
	added so subnet_id.h:

	isc::dhcp::SUBNET_ID_GLOBAL
	isc::dhcp::SUBNET_ID_UNUSED
	isc::dhcp::SUBNET_ID_MAX

	which should be used in code/hooks in place of hard-coded values.
	(Trac #5704, git 90fe9ca2cd6f63bcc7168bdc3786677db57b65ec)

1439.	[func]		tomek
	keactrl and kea-admin tools can now report version.
	(Gitlab #9, git 4a00ab5d4b9ac9193fc5f924149aeaca7a88e2ef)

1438.	[func]		tomek
	subnet-id parameter is now optional in lease4-add, lease6-add,
	lease4-update and lease6-update commands. If not specified or
	its value is zero, Kea will attempt to figure out the correct
	value of subnet-id. If there is no matching subnet configured,
	the lease will be rejected.
	(Trac #5683, git a8ce7a78b5b294e6bce02de887552a1e4593db4e)

1437.	[func]		tomek
	DHCPv4 and DHCPv6 servers are now able to sanity check and
	possibly correct some inconsistencies in leases when loaded from
	disk (memfile). A new parameter to govern this behavior has been
	added.
	(Trac #5682, git 609bfa0a67caa91fac6834eb39260acfd19e3be4)

1436.   [func]      tmark
	Added two new configuration parameters to kea-dhcp4 and kea-dhcp6
	DhcpDdns sections: 'hostname-char-set' and 'hostname-char-replacement'.
	These values (when not empty) are used by the server to sanitize
	host name and FQDN domain names sent by clients prior to using them
	to construct DNS names.
	(Trac #5680, git 32466ab3d4688e66c8c2f9fd24d4a98fcc871ff6)

1435.	[func]		marcin
	Implemented ha-continue command in HA hooks library and
	updated the Kea User's Guide with the information how to
	pause and resume the HA state machine.
	(Trac #5675, git 98a9bd4f6766ff2f53681d84d55c56988be4d501)

1434.   [func]      MayyaSunil
	Code added to support storage of Authentication key host reservation.
	There is no way to use the code yet.
	(Github #88, git 66602af46b1a7d9f4197b1f285c928bd9f80ba2b)

1433.	[func]		marcin
	Implemented state HA state machine pausing in the high
	availability hooks library.
	(Trac #5674, git b9f3f082c7a88fe98fa4545b9649193ceb5e3ef5)

1432.	[func]		MayyaSunil
	Code added to handle Authentication option in DHCPv6. There
	is no way to use this code yet.
	(Github #93, git 022dae4393da9e714678d52886d4f478ba308ba9)

1431.	[func]		marcin
	Implemented lease4-get-page and lease6-get-page commands
	in lease_cmds hooks library.
	(Trac #5651, git b056828212f7b206ff8bd07c097fd6f427d22d71)

1430.	[func]		fdupont
	Lease objects and lease backends are now able to store user
	context. User context can store an arbitrary data as long
	as it is in JSON format. Database schemas updated.
	(Trac #5584, git b0b7a198b99fd417466708c80cb7cc2162ae480c)

1429.	[bug]		marcin
	Removed memory leak in the DHCPv4 and DHCPv6 servers which
	occurred when hooks libraries where loaded.
	(Trac #5664, git 2584b902d2617089bfa7238133490ddd855aa77a)

1428.	[bug]		marcin
	Corrected behavior of the standby server in the HA hot-standby
	mode, which failed to monitor delays in responses to the
	DHCP queries sent to the primary server after the primary
	server became unavailable. This resulted in transition of
	the standby server to the partner-down state immediately
	after detecting interruption in communication with the
	primary over the control channel.
	(Trac #5654, git 7a83f05fe40fb1b6812b055e2d6d633d9e00160c)

Kea 1.4.0 released on June 15, 2018

1427.	[bug]		marcin
	Resolved multiple problems causing slow synchronization of
	leases in the HA hooks library, including adjusting
	timeouts in control channel and improving performance of
	responses sent by the Command Manager to Control Agent.
	Also, introduced 'sync-timeout' configuration parameter
	into HA hooks library to control lease database
	synchronization timeout.
	(Trac #5649, git cbc29128863916a13364749bf681586aea2aa51e)

1426.	[func]		fdupont
	Added KNOWN and UNKNOWN built-in client classes: after host lookup
	if a matching host entry is found the incoming packet is added to
	the KNOWN class, if none is found to the UNKNOWN class. Then
	expressions depending directly or indirectly on these classes are
	evaluated. Note these classes may be used to select a pool but
	they may not to select a subnet.
	(Trac #5549, git 6a856ed9722b918a65dca15ff44314e28897784e)

1425.	[bug]		marcin
	Improved performance of the DHCP server running in High
	Availability configuration by optimizing the management of
	CalloutHandle objects passed to the callouts.
	(Trac #5647, git eea88d5c8f4d8efb6c5bfdfbf4e070a90069db5d)

1424.	[doc]		marcin
	List of hooks libraries provided by ISC includes an
	information which Kea servers the libraries can be attached
	to. The detailed description of each supported hooks library
	also contains this information.
	(Trac #5613, git 9d6f8de3d988c42c413a7d628e31854e9c80d8c9)

1423.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 now retain and emit global, scalar
	parameters specified in their configuration.
	(Trac #5378, git 4d05122f03d00b10a888c768fe1725cae9d6aea6)

1422.	[build]		fdupont
	Commented out BOOST_ASIO_DISABLE_THREADS in configure to reflect
	the current use of threads by boost ASIO in Kea.
	(Trac #5615, git f3fc8b1a4257a42a97aaf88a36287bbe33d1f65b)

1421.	[build]		marcin
	Moved libdhcp_ha (High Availability) hooks library from
	premium to main Kea repository and changed its license to
	MPLv2.0. Future ChangeLog entries for this library will be
	tracked in the Kea ChangeLog file.
	(Trac #5645, git 19b2553d4869bdd52b63b6f7969052d8a724f78d)

1420.	[doc]		marcin
	Updated list of loggers in the Kea Administrator's Manual.
	The updated list contains all loggers, including those
	from supported hooks libraries.
	(Trac #5622, git bd94afc0af7183452c94f3b5768c6138f79d3b60)

1419.	[doc]		marcin
	Documented "sync-leases" configuration parameter of the HA
	hooks library in the Kea Administrator's Manual.
	(Trac #5621, git 4ebac3a411aa02d1cc3d74e7eaf3212ad208159a)

1418.	[bug]		marcin
	Corrected bug in the allocation engine which caused occasional
	lease allocation failures when a loaded hooks library set the
	callout status to non default value, e.g. "skip" rather than
	"continue". In such cases, the server reported that it failed
	to allocate a lease "after 0 attempts".
	(Trac #5638, git f2e9b686ae52e1b06f660e1b522588b1440e2620)

1417.	[bug]		marcin
	Improved logging in the HTTP library both for the server and
	the client.
	(Trac #5205, git fd0bec610c89084d5a5d43ef032c9875c3e6ad46)

1416.	[bug]		fdupont
	Added support of recent Botan 2.x crypto backend.
	Note that Botan 1.[9-11] is still supported but not recommended.
	(Trac #5382, git 22651b1935a2397edfbddb9b8873c353c090f18e)

1415.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 now validate the schema version
	of lease and host backends after establishing a connection.
	If a schema version does not match the version the server
	expects, the server will emit an error log and close
	the connection. This applies to MySQL, PostgreSQL, and Cassandra.
	(Trac #5629, git 15c34afdba45be609e35284a209ad18ed66605f8)

1414.	[bug]		tmark
	kea-dhcp4 parsing now treats renew-timer and rebind-timer
	as optional with no defaults. The logic for sending them
	to the client was changed to: send rebind-timer only
	when it is less than the lease lifetime; and send renew-timer
	only when it less than either the rebind-timer if specified,
	or lease lifetime in the absence of rebind-timer.
	(Trac #5596, git 38426e16ec04a786e35a65d27cbcb7dbabfe79b5)

1413.	[func]		fdupont
	Removed getAll, get4 and get6 methods using both hardware address
	and DUID from host backend (aka host data source) APIs.
	This is an *incompatible* change.
	(Trac #5563, git db4c34b069f114f93d9f29cdeb02b536a0fbc982)

1412.	[func]*		marcin
	The client classes used by the High Availability hook library
	use upper case "HA_" prefix and they are now built-in classes.
	This means that those classes do not need to be	declared in the
	server configuration.
	(Trac #5632, git 2d590bfd7d1b0eca377eb99eef83a3083a1d7399)

1411.	[bug]		fdupont
	Fixed warnings about lambda's not using captured variables.
	(Trac #5591, git f88a505823d39faec7dc5f647f40e6454e5dfc74)

1410.	[bug]		marcin
	Fixed multiple hanging Control Agent unittests.
	(Trac #5576, git 310af68101cba74220652ec2b403520fc5666dc0)

1409.	[doc]		marcin
	Documented in the User's Guide how Kea HA service behaves
	when the clock skew between active servers becomes too
	high.
	(Trac #5603, git ffaff4d2a03600bb4f81d335b49a840e31d03c8c)

1408.	[func]		tomek
	perfdhcp now supports -o option that adds DHCP options.
	This may be used to simulate various clients.
	(Github #77, git b81dedb7f0a2516130e7bd799d9084c63f0e844c)

1407.	[bug]		tmark
	Corrected an issue where the destruction of loggers
	prior to the destruction of the TimerMgr singleton
	caused unit tests to segfault.
	(Trac #5626, git 9f4e3f9cd8acf8e7d1d3e714d8f904754377c00f)

1406.	[func]		fdupont
	Added pkg-config alternative to configure --with-cql path so
	now you can use either pkg-config or cql_config.
	(Trac #5488, git 55498ca3455517132533a39002ebfc05d26c7e38)

1405.	[bug]		tmark
	Corrected missing "override" warning in cql_lease_mgr.h
	(Trac #5625, git df3068ba0e520df4d96dd38e2de679beb99f2e23)

Kea 1.4.0-beta released on May 18, 2018

1404.	[doc]		tomek
	Hooks package installation instruction added to Kea
	User's Guide.
	(Trac #5427, git 7bc5e4297e8b2ccb87d5d5d79ae066fe32964841)

1403.	[build]		tomek
	Support for hook packages has been updated. The --with-tierX
	flags have been removed. Each hook library is now detected
	independently.
	(Trac #5619, git aa1f95d699dc664a5660db120ef71edee910a9b3)

1402.	[bug]		tomek
	Fixed a crash that was caused by hook library registering
	new hook points. This fixes unit-tests with forensic
	logging, but the problem was generic and could cause
	other libraries to segfault during unloading or reconfiguration.
	(Trac #5577, git 2f9d1aa95c16e12fabc50d581b966f20b6d8a950)

1401.	[bug]		tmark
	Corrected an issue which caused kea-dhcp4 and kea-dhcp6 servers
	to unload their hooks libraries upon receipt of the first client
	message following a dynamic reconfigure.
	(Trac #5564, git 5111f569bd251c2a98a2e6d958e8f6b640a1802d)

1400.   [func]		tmark
	A new hooks library, Stat Cmds, has been added to the open source
	distribution.  This library provides commands for fetching lease
	allocation statistics using lease backend as the source for
	lease counts per state.  This resolves an issue in deployments,
	where multiple Kea servers share a common lease backend, which made
	it difficult to obtain accurate lease statistics.
	(Trac #5589, git 36f20f1c8b28f629fe2896b817ac0f3c6026fe0e)

1399.	[func]		tmark
	Support for fetching lease allocation statistics by subnet-id
	or subnet-id range has been added to the Cassandra backend. This
	allows it to be used in conjunction with the Stat Cmds hooks
	library commands for fetching shared lease statistics.
	(Trac #5588, git 3fcfefdea5ac838936c2109ecbbbc32eabc8fdba)

1398.	[bug]		fdupont
	Fixed bug in configurations where "outbound-interface" parameter
	was set to "use-routing", which in some cases would reset outbound
	interface index to a negative value and cause the server to fail
	to respond to the clients.
	(Trac #5515, git 9d8d00f1f127ee606f09f7ff6006f0d142aac976)

1397.	[bug]		marcin
	A bug in http client library was fixed. The IPv6 address specified
	in brackets is now supported properly.
	(Trac #5620, git fe38c4368853e47bc993d6c3844cdddba5effde5)

1396.	[bug]		tmark
	The PostgreSQL schema was expanded to include two new tables:
	lease4-stat and lease6-stat and triggers to update them as leases
	are modified. This resolves an issue in deployments, where multiple
	Kea servers share a common PostgreSQL lease database, which made
	it difficult to obtain accurate lease statistics. Since these statistics
	are now tracked by the database, they do not have to be recalculated at
	startup or following reconfiguration. This may result in less
	processing overhead during these events. The new statistics will be
	accessible via a new Hooks library, being developed for Kea 1.4
	under #5589.
	(Trac #5587, git 36a0160de0df7789eea224954717be05c08638b7)

1395.	[bug]		tmark
	The MySQL schema was expanded to include two new tables:
	lease4-stat and lease6-stat and triggers to update them as leases
	are modified. This resolves an issue in deployments, where multiple
	Kea servers share a common MySQL lease database, which made it difficult
	to obtain accurate lease statistics. Since these statistics are now
	tracked by the database, they do not have to be recalculated at startup
	or following reconfiguration. This may result in less processing overhead
	during these events. The new statistics will be accessible via a new Hooks
	library, being developed for Kea 1.4 under #5589.
	(Trac #5586, git a070c327668c10de3b28f5e249f91d6d16a97ff5)

1394.	[doc]		marcin
	Documented High Availability hook library in the Kea
	Administrator Reference Manual.
	(Trac #5478, git 3db34400d0331e3d4fc208529eeb18f6abfb6562)

1393.	[build]		marcin
	Install new header files introduced since Kea 1.3 release.
	Also, bumped up libraries version numbers for Kea 1.4 beta
	release.
	(Trac #5590, git 64351229a30832735c5a81ac17ca1521aa2483b2)

1392.	[func]		fdupont, marcin
	Implemented new hook point "leases6_committed" in the DHCPv6
	server. It supports new next step status NEXT_STEP_PARK
	which causes the server	to "park" the client's DHCP packet.
	(Trac #5458, git 04d6fb0a0ac5b9dff2a02764cc9265f9a2a05ae8)

1391.	[func]		tmark
	For both kea-dhcp4 and kea-dhcp6, the "ip-address" parameter
	in the "relay" element for both subnets and shared networks,
	has been replaced with a list form, "ip-addresses".  Configuration
	parsing will continue to honor the singular form, but it should
	be considered deprecated.  In addition, an omission in 1.3 that
	caused shared network parsing to ignore the "relay' element has
	been corrected.
	(Trac #5535, git f4601abdb657122a8ba5d7784eded773ec01d171)

1390.	[doc]		tomek
	User's Guide documentation for RADIUS and Host Cache written.
	(Trac #5538, git c73337a8ec691874b8ac0b2efcd8708f1a79acbb)

1389.	[func]		fdupont
	dhcp6_srv_configured hook point added.
	(Trac #5530, git 3bb521f6ec8b4e2a1e57ec84b17ee12b0ccf0f83)

1388.	[build]		tmark
	Modified configure script to support --with-dhcp-mysql and
	--with-dhcp-pgsql but emit a deprecation warning message
	encouraging their replacement with --with-mysql and --with-pgsql.
	(Trac #5567, git 53761069761ddde44636baa30185322debfe4186)

1387.	[func]		tmark
	perfdhcp no longer requires -r (rate) be specified in order to use
	-D<max-drop>, -n<num-request>, -p<test-period> and -t<report> options.
	(Trac #5115, git c3ba89c56882cac1080899ad201f0c02056eef38)

1386.	[func]		fdupont
	Extended comment / user-context support to DHCP-DDNS and
	Control Agent configuration syntax.
	(Trac #5495, git fe79959e3bc3c46ccb89661cb27696671a8508b8)

1385.	[func]		tomek
	lease4-wipe and lease6-wipe are now able to wipe all leases
	from all configured subnets if subnet-id specified is 0
	or the subnet-id parameter is omitted.
	(Trac #5543, git ecaf777dff4b8d1100c2a97c4fb1cf8f8e63566d)

1384.	[func]		fdupont
	Significant improvements to client classification introduced.
	The order of classes evaluation has changed from alphabetical
	to the order of appearance. New 'member' expression allows
	combination of classes. The new 'only-if-required' and
	'require-client-class' parameters controlling the scope of
	a class have been introduced.
	(Trac #5474, git 3f2d93f0731fc1858b20e831a7d1f090ea8841fe)

1383.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 can now be configured to attempt to
	reconnect to MySQL backends if connectivity is lost.
	(Trac #5556, git b31da6f9a3545a2cac228eb17c59d72b6b4823f2)

1382.	[func]		fdupont
	Added support for generalized UDP Source Port for DHCP Relay
	(RFC 8357) for DHCPv4, DHCPv6 and DHCPv4-over-DHCPv6. Note
	this required changes to the inter-server protocol used by
	our 4o6 implementation, and is therefore not backward
	compatible.
	(Trac #5404, git 2a6049947ad4caaaa697dba8cb7669a09264f0bc)

1381.	[bug]		marcin
	Corrected a bug in the libkea-asiolink library which caused
	the DHCP servers to crash while processing commands over
	the unix domain socket on some systems.
	(Trac #5580, git cb5276a24436a9e9ce4d1ab4630e7193a4c2d803)

1380.	[func]		fdupont
	Implemented lease6-get-all command in lease_cmds hooks library.
	(Trac #5469, git a0bb7188df47a0f8020ff57739c5a6ab5f7e9828)

1379.	[func, bug]	marcin
	The network_state argument is provided to the callouts in
	the dhcp4_srv_configured hook point. Also, fixed a couple
	of minor bugs in the HTTP client classes.
	(Trac #5470, git 93e2b2198c3163afb81d51fdf5ec547602a12415)

1378.	[doc]		tomek
	New parameter subnets-action for network4-del and network6-del
	commands is now documented.
	(Trac #5441, git 8b2ffabb3d1ba709f319df2b34d0804ee824446b)

1377.	[doc]		tomek
	New parameters for Cassandra are now documented.
	(Trac #5484, git 56e7026ea2bfab99dbfa1a047dc920ec2f743540)

1376.	[func]		razvan
	Cassandra backend improvements: get all IPv4 leases, delete
	hosts, ability to store fixed DHCPv4 fields (next-server,
	server-hostname, boot-file-name) and user contexts in host
	reservations. Also, the ability to store MAC address details
	in DHCPv6 leases on PostgreSQL has been improved.
	(Github #70, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #5506, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #5507, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #5508, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #4530, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)

1375.	[func]		tmark
	When encountering errors unpacking vendor specific options,
	both kea-dhcp4 and kea-dhcp6 will now log the error, skip
	unpacking any remaining options, and then attempt to process
	the packet as is.  Prior to this the servers would log the issue
	and then drop the packet.
	(Trac #5551, git 59ef33ee17672c55cee4ec86ff59737b361a3c21)

1374.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 can now be configured to attempt to
	reconnect to Postgresql backends if connectivity is lost.
	(Trac #5477, git 8e62a058382b2245d418cfbf829776934c638e5e)

1373.	[func]		marcin
	Implemented leases parsing from JSON in libkea-dhcpsrv.
	(Trac #5466, git 84c2a2084b0fb7c086fc6b9502f7ff58b708174e)

1372.	[func]		marcin
	Implemented new hook points "dhcp4_srv_configured" and
	"leases4_committed" in the DHCPv4 server. The latter supports
	new next step status NEXT_STEP_PARK which causes the server
	to "park" the client's DHCP packet.
	(Trac #5457, git af43f07b0e227ccabcdf07a046a64cebb11bdccf)

1371.	[bug]		fdupont
	Fixed a bug in JSONfeed tool which did not correctly handle
	strings and interpret their content.
	(Trac #5513, git 231e923a85db7fb8305c7baa4d15f766fdf60942)

1370.	[bug]		tmark
	Fixed a bug which prevented inserting multiple host reservations
	where IPv4 address was unspecified or when selected subnet identifier
	was not specified (5416).  Corrected inconsistent data types for
	subnet id columns in both Postgres and MySQL schemas.  Now both
	schemas support up to MAX UINT32 in all subnet id columns. Exiting
	databases may be updated without data migration.
	(Trac #5416, #5522, git d1dd0f2e27ffa49515c17cf68d54f162359b6384)

1369.	[bug]		marcin
	Multiple critical performance optimizations in the allocation
	engine for shared networks.
	(Trac #5437, git 9d8bcd39802795d48c737a05ef3de3634a28ca4e)

1368.	[func]		tmark
	kea-dhcp4 now explicitly logs packets dropped due to a lack
	message type as a log type DHCP4_PACKET_DROP_0009.  Prior
	to this such packets were logged has having an unsupported
	message type of 0.
	(Trac #5553, git ff97e5ffb5f3478be71aae8130b6eff3208bd69a)

1367.	[func]		fdupont
	Added initial skeleton implementation for Radius hook library.
	(Trac #5524, git 832aa23b89eab71875bcbdb1e955eb92fdc0e01a)

1366.	[func]		fdupont
	Implemented FNV hashing function. Cassandra backend no longer
	explicitly depends on OpenSSL.
	(Trac #5502, git 71de75c3bb099f21fdef0d41806da281d6271287)

1365.	[func]		fdupont
	Both DHCPv4 and DHCPv6 servers can now listen on loopback
	interfaces. This capability requires setting socket type to UDP in
	DHCPv4. Note the feature has not been thoroughly tested.
	(Trac #5390, git f38cbd73581a7a0f8634a63cb17f9b60407e3acc)

1364.	[func]		fdupont
	Extended forensic (aka legal) logging with database capability.
	(Trac #5420, git 94bd3cc313e9f2a982ef8f8adf0cf44024c76499)

1363.	[func]		tmark
	Added support for automatically recalculating lease statistics
	to the CQL backend.
	(Trac #5487, git c807388d581ee1c3e479324f3c399f27feba1c96)

1362.	[func]		razvan, andrei
	A new parameter exit-wait-time has been added to perfdhcp. It is
	now possible to tell perfdhcp to wait certain amount of time after
	exit conditions are met before actually terminating.
	(Github #55, git 0cd1178ae092fa0c2f122d0e16fb673b4074a6e6)

1361.	[func]		razvan, andrei, tomek
	Support for Google Benchmark has been added. To compile
	benchmarking support, please use --with-benchmark option.
	(Github #36, git d6819971410b460d7742c762844e2e75ba580944)

1360.	[build,bug]	fdupont
	Cassandra build fixes for macOS.
	(Trac #5494, git cb0d735628aefd6bca2acc11b73d1f66b45d1c40)

1359.	[bug]		rcgoodfellow
	Fixed bug in kea-admin causing error on lease-dump.
	(Github #61, git 2c9454ec56edc8f3cff8a23329f53ced0d172280)

1358.	[func]		andreipavelQ,tomek
	The logging configuration is now applied early, which helps
	seeing errors in case the new configuration is faulty.
	(Github #41, git d77fbec5a003a69cab207aa741133015f2657878)

1357.	[build]		andreipavelQ
	--with-dhcp-mysql renamed to --with-mysql and
	--with-dhcp-pgsql renamed to --with-pgsql. These names were
	leftovers from old BIND10 times when Kea was part of bigger
	solution that also provided DNS services. Kea is now a stand-alone
	software, thus the -dhcp- doesn't make sense in those options any
	more.
	(Github #40, git 318c9e3d3db9bb938ced27932d8401172529a2ff)

1356.	[doc]		andreipavelQ
	Documentation has been upgraded to DocBook 5.0.
	(Github #39, git 9b6705bd6c534128ec18820ff0cbdd72b7fce9e9)

1355.	[func]		tomek
	Lightweight 4over6 options reinstantiated. Definitions for DHCPv6
	options 89 through 96 were added back. DHCPv4 v4 Parameters Option
	159 has its definition tweaked slightly.
	(Trac #5514, git 6a4aac2b3bfffe41460db6d1cd3c55b1430aa50c)

1354.	[build]		andrei
	Support for coverage tests has been improved.
	(Github #43, git 1949bb3abf71fb3997044d239eb683095166c39f)

1353.	[build,bug]	andrei, razvan
	Various small changes and bugfixes. Thank you to Andrei Pavel
	and Razvan Becheriu for submitting their patch.
	(Github #54, git 2efa7494228a1797dff8d9d74107a452c61e2386)

1352.	[func]		fdupont
	It is now possible to specify client classification restrictions
	on per pool basis. This capability will be useful for grouping
	certain types of devices into specific address and/or prefix
	pools.
	(Trac #5425, git 5f3a89d6e32e90cd9cbb2347c7b2208c3e1561e0)

1351.	[build]		andreipavelQ
	Compilation parameters unified (every file now includes config.h,
	several makefile tweaks).
	(Github #38, git 7206aa79c57be7466c4ab3dd558663c6c4f858b7)

1350.	[func]		fdupont
	Several hook points now support next step status DROP. This allows
	more flexibility with dropping packets from within hooks.
	(Trac #5443, git ff22a906915a34df327174f550f69a396a05bb2c)

1349.	[func]		marcin
	Implemented HTTP client classes in libkea-http.
	(Trac #5451, git 94267e252b372650e4235389251b49d6f5501322)

1348.	[build]		fdupont
	Modified configure.ac to include premium module m4 macros, if the
	module is present. Prior to this it relied on premium having it's
	own configure.ac script.
	(Trac #5400, git 38c4f2fb8fc8c8874a0e4671cc295a049acf675f)

1347.	[build]		fdupont
	Added support of boost 1.66.0 ASIO.
	(Github #60/Trac #5496, git bc2947de4296bd99b74e50e65f272c7ad5312429)

1346.	[func]		marcin
	Implemented lease4-get-all command in lease_cmds hooks library.
	(Trac #5468, git a378ec28489e98df64830d1f26c3bebd20e256b2)

1345.	[func]		marcin
	Implemented "force-create" parameter for lease4-update and
	lease6-update commands.
	(Trac #5472, git 369245e4c5308a701fd483123f2cb2fd7d3d0966)

1344.	[func]		andrei, razvan
	Support for host reservations stored in Cassandra added. The core
	functionality was added. There are some limitations (delete,
	client classes, fixed DHCPv4 fields, statistics recount, etc.)
	These will be addressed in upcoming tickets.
	(Github #37, git e37606fd2d0c02234a55f7445c52a12b2e7a82ec)

1343.	[func]		fdupont
	User-context and comments are now supported in many new scopes:
	global, shared-network, subnet, pool, host reservation, option,
	option definition, client-class, control-socket, dhcp-ddns,
	interfaces, loggers, and for DHCPv6 pd-pool and server-id.
	(Trac #5351, git 3405a8fa5d391d96cd15874fd3de3ac63ceb33b6)

1342.	[bug]		fdupont
	Fixed subnets and host reservations returned by config-get and
	config-write.
	(Trac #5452, git c24d057bed2692eaf3cdb6af889122eb582ffede)

1341.	[func]		razvan, andrei
	Significant update of Cassandra support. A lot of code for
	Cassandra Lease Manager has been updated and partially rewritten.
	(Github #35, git 41795494720cd9886c1e98d21eaeefd94d674e37)

1340.	[func]		marcin
	Added support for "dhcp-enable" and "dhcp-disable" commands in
	the DHCPv4 and DHCPv6 server.
	(Trac #5442, git 36dc68ff7aa8b3cfd265c4f982d10248590039bd)

1339.	[doc]		marcin
	Updated User's Guide describing how to selectively disable
	legal logging for a subnet.
	(Trac #5407, git 469080abd711f8e88a5133f76f4ab31a5549a858)

1338.	[func]		marcin
	Persistent HTTP/1.1 connections and HTTP/1.0 keep-alive
	are supported by RESTful API.
	(Trac #5448, git 05018f7cc0662d6956b9b7648646e0c17da948ba)

1337.	[doc]		marcin
	Added placeholder section for the libdhcp_ha hooks library.
	(Trac #5447, git d939b5b8bc4befb24daf863f2408d97493e4bfbf)

1336.	[bug]		marcin
	DHCPv6 server always sends prefixes with the lifetime of 0 for
	the prefix leases that should no longer be used, even if those
	prefixes are not included in the Renew/Rebind.
	(Trac #5403, git 91bb0855ff7ef86ff72b5a946ae716798d7bebc1)

1335.	[bug]		marcin
	Fixed a bug which prevented inserting multiple host reservations
	where IPv4 address was unspecified or when selected subnet
	identifier was not specified. This change affects both Postgres
	and MySQL backend.
	(Trac #5416, git 03fab8f7d5c2e8a5ea735b11ff75652aa31d791d)

Kea 1.3.0 released on October 27, 2017

1334.	[bug]		marcin
	Fixed a bug in the DHCPv6 server whereby a lease with zero
	lifetimes could be mistakenly included in the server's
	response.
	(Trac #5387, git 140e7239096c0d5b9fc82b2c9c461476bf9d5729)

1333.	[doc]		tmark
	Added a discussion of conflict resolution to the DHCP-DDNS chapter
	of the Kea admin guide.
	(Trac #5275, git ce3fe30524cdc21a9cabeafbdcb2fc3cd2e86cff)

1332.	[doc]		tomek
	Clarified list of supported options, added examples for using
	hex notation to specify option values.
	(Trac #5068, git c942586172a68a7fac09e366383d996ade7f3840)

1331.	[func]		marcin
	Default "lfc-interval" value is now set to 3600.
	(Trac #5341, git dd1af78a49bfb68b88e8215dde65e40a470af81c)

1330.	[bug]		fdupont
	The option length checks were relaxed for the V-I Vendor Class
	option.
	(Trac #5391, Github #57,
	 git 8c1ea6684a808e8d3af9ea7eccecd93adc801e8a)

1329.	[func]		marcin
	Added support for "client-id" identifier when querying for
	leases in the lease_cmds hooks library. Documentation
	updated accordingly.
	(Trac #5395, git aceafa67f4fbde55ed6724a7b7551ed251e4ee91)

1328.	[doc]		vicky
	Acknowledgements section updated.
	(Trac #5385, git fe0658896f3784cd8f59bd5158244d6975cfe4c1)

1327.	[build]		marcin
	Updated Kea libraries' version numbers and hooks version for
	the 1.3.0 release.
	(Trac #5375, git 70c0fc164c89716419b6ee42da3ca0d4be938a30)

1326.	[func]		fdupont
	server-hostname and boot-file-name are now allowed in global,
	subnet4 and shared network scopes in DHCPv4.
	(Trac #5277, git 5a2454ec063530867dca2c46a71e342ccd98a5bb)

1325.	[bug]		marcin
	Fixed a bug whereby a reserved address could be allocated to
	a different client when this client explicitly requested
	this address.
	(Trac #5393, git 0964c66d44516a04ec62c8e70be92f216fe3df5a)

1324.   [doc]           wlodek
	Added examples of configuration for iPXE boot with DHCPv6 Kea server
	(Trac #5356, git c68b9b381930d1e44fd5daa1b9d033035e32cff2)

1323.	[doc]		marcin
	Added new section to Kea Hooks Developer's Guide describing how
	to implement new control commands within hooks libraries.
	(Trac #5331, git b23f36ca4a410ba7bca7fd4a9f40c008c77e3c7c)

1322.	[build]		marcin
	Copy all header files from Kea libraries during "make install".
	(Trac #5372, git cb38d39a942351ec04a655a396dd7396ea20548b)

1321.	[doc]		marcin
	Better explained subnet selection within shared networks when
	client classification is in use.
	(Trac #5367, git 26b4d240c5a1ba73e5b61f45d5a832e52f6472dd)

1320.	[doc]		marcin
	Improved documentation of shared networks within Kea Administrator
	Reference Manual.
	(Trac #5381, git c4be6a71ed3705c182d7ba4417a06ed8fa59f2b5)

1319.	[func]		marcin
	Added support for DHCPv4 option 54 (dhcp-server-identifier).
	(Trac #5376, git aae2d91f101b8c61c0abfb3482de04a8dd074121)

1318.	[doc]		marcin
	Updated Kea Administrator's Manual with the information about
	new capability of flex-id hook library to use value derived from
	flexible identifier as a client identifier or DUID.
	(Trac #5384, git cce58fee4aa0476712209a7ed92fab587258b49b)

1317.	[bug]		fdupont
	The kea-admin script now behaves properly when -4 or -6 is missing
	while using lease-dump command.
	(Trac #5379, git 53870c07d1864faf2a25bdc4ed6c5cf2b0223f8d)

1316.	[bug]		marcin
	Corrected a bug which caused a returning DHCPv4 client performing
	4-way exchange to be assigned a different address from a shared
	network than previously allocated.
	(Trac #5388, git 601a387ba43d990947ee2e1a05e78851d8133a3c)

1315.	[bug]		marcin
	Created unit test for the case when there are several IPv6 subnets
	within a shared network and each subnet specifies the same
	DHCP option with a different value. This test verifies the fix
	applied with ticket #5364 which address the problem of assigning
	options from invalid subnet.
	(Trac #5366, git 112addd4619509c464dc051f4885e00dc1f69d26)

1314.	[bug]		marcin, tomek
	Improved unit tests for shared networks and corrected a bug
	in the allocation engine which caused wrong subnet id to be
	stored in the lease database and wrong subnet be used by the
	DHCPv6 server for options assignment.
	(Trac #5364, git 07ce52ee4ce65eeeea1890201812ac83a286658f)

1313.	[bug]		fdupont
	Empty output_options structure is no longer returned by config-get
	or config-write commands.
	(Trac #5267, git f2290503ed899f00c7f2f2b905b90bc360617340)

1312.	[func]		marcin, tomek
	Added new configuration parameter "outbound-interface", which
	controls how the outbound interface and source address is
	determined for the responses sent by DHCPv4 servers to relayed
	clients. The default setting is to use the same interface as
	the one over which the query has been received. The alternative
	is to use system routing to determine the right interface and
	source address.
	(Trac #5377, git d08088923ec1ea0d1cb8a947bd520174d874d25e)

1311.	[build]		fdupont
	Improvements in --enable-shell and other parameters passed while
	building dist tarball.
	(Trac #5210, #5339, #5352,
	git e531cda4e10114a8f14bcbf3d7e25b6584230875)

1310.	[bug]		marcin
	Documented "ia_pd" parameter for lease6_renew and lease6_rebind
	hook points.
	(Trac #5368, git 6842036714f84bf12529e1a43e12ac5a07e2e5c0)

1309.	[func]		fdupont
	Kea-shell script now has an optional --path parameter that allows
	using not empty URL path.
	(Trac #5361, git 9a31c417d52f1481185b0880a10a4b5f16d8462a)

1308.	[func]		fdupont
	Support for conditional token ifelse(condition, iftrue, iffalse)
	was added. It can be used in flex-id, client classification and
	possibly other expressions that may appear in the future.
	(Trac #5363, git 34c364abd23a1a745da79c10c69b94b8defad08b)

1307.	[func]		fdupont
	When an option is defined with a record type and the array
	flag is true the last record field is an array. All standard
	options supported by ISC DHCP and using this are now supported
	by Kea (so now there is no standard option supported only by
	ISC DHCP).
	(Trac #5226, git f66951dbda8f62122187ac3a99f0fdcc65b383d8)

1306.	[bug]*		marcin
	Respective Kea daemons now use their own default configuration
	files: kea-dhcp4.conf, kea-dhcp6.conf, kea-dhcp-ddns.conf and
	kea-ctrl-agent.conf. This change is aimed at eliminating the
	issue whereby 'config-write' command overrides configuration
	of all servers rather than just a configuration of the daemon
	to which this command has been sent.
	(Trac #5338, git 252e5e8a75fa42271b0cdb6edad3c152bbf3c515)

1305.	[bug]	tmark
	Corrected logic that was causing kea-dhcp4 to remove DNS entries
	when renewing leases with generated FQDN names.  Prior to this
	the server was incorrectly scheduling DNS removal when configured
	to generate the client's FQDN.
	(Trac #5369, git 18f57f502f1b9fb5bf7ef5ab995ddda60006fd39)

Kea 1.3.0-beta released on September 29, 2017

1304.	[bug,func]	fdupont
	The DHCPv4 Vendor Specific Information (code 43) option and
	private options (codes 224-254) can be redefined at the global
	scope or inside a client-class. This allows to support different
	definitions following the DHCPv4 Vendor Class Identifier (code 60)
	option or when defined as a binary option to accept with problems
	option 43 carrying a raw value.
	(Trac #5073, git b290b3cbaa926d4e9613f6607c5fcbae2301b266)

1303.	[func]		tmark
	The command handlers in the lease_cmds hook library are now
	implemented has hook callouts and registered with the Hooks
	manager. Prior to this they were registered as command handlers
	with the Command Mgr.
	(Trac #5332, git c902bda9f026720f6efbf2e5ad407302aeb5e466)

1302.	[func]		marcin, tomek
	DHCPv6 server supports shared networks. It allows for grouping
	multiple subnets and use them interchangeably to allocate
	IP addresses and other resources to a client located on the
	particular link. This mechanism is useful to extend an
	address space for the client belonging to a particular
	subnet and/or to segregate clients being on the same link but
	belonging to different classes, e.g. cable modem vs router.
	(Trac #5307, git 110d0c9e403af28e6810141f978d9bf55c381f14)

1301.	[func]		fdupont
	Added some standard option definitions which are supported
	by ISC DHCP but not (yet) by Kea.
	(Trac #5227, git 4bef838245f08fca5f2cf037cd3a75278b77f8f9)

1300.	[doc]		tomek
	Documentation for shared networks added.
	(Trac #5310, git 41fd3bb7ed2f4cd15db6cbd14713f4474f659c92)

1299.	[doc]		fdupont, tmark
	Added an example stunnel configuration file to demonstrate
	using kea-shell through https.
	(Trac #5282, git efe044fa90d53398e215d2bf31e00e83353e8774)

1298.	[func]		marcin, tomek
	DHCPv4 server supports shared networks. It allows for grouping
	multiple subnets and use them interchangeably to allocate
	IP addresses and other resources to a client located on the
	particular link. This mechanism is useful to extend an
	address space for the client belonging to a particular
	subnet and/or to segregate clients being on the same link but
	belonging to different classes, e.g. cable modem vs router.
	(Trac #5306, git 4f2fca69be32997c718ab2c7f37ac80ed4e41d15)

1297.	[func]		tmark
	Added a hook point, "command-processed", to kea-dhcp4
	and kea-dhcp6 servers. This hook point occurs after
	a control channel command has been received and
	processed.
	(Trac #5111, git 043d17b0688d4ab25b12469d27859983cb297d07)

1296.	[bug]		tmark
	Altered the mysql backend logic to disable auto_reconnect and
	set session value of wait_timeout to a very large values. This
	avoids a segfault in MySQL client library caused by auto-reconnects
	occurring when kea server's MySQL connection is idle for longer
	than the global MySQL wait_timeout.
	(Trac #5354, git 9881ef6d772f27de82c048e198ba0ff9e71b9351)

1295.	[bug]		tomek
	DHCPv4 and DHCPv6 servers are now able to parse shared networks.
	A basic shared networks examples added.
	(Trac #5357, git 74b824cc80f8be66084308c0bf12c1a71f311915)

1294.	[func]		marcin
	Implemented data structures holding configuration of shared
	networks. The new structures are unused until remaining tickets
	for shared networks implementation are completed.
	(Trac #5305, git 76dd46f7070c141cc89d772d69a897b67bd179a1)

1293.	[func]		tomek
	DHCP4_BUFFER_WAIT, DHCP4_BUFFER_WAIT_INTERRUPTED, DHCP6_BUFFER_WAIT,
	and DHCP6_BUFFER_WAIT_INTERRUPTED logging messages are no longer
	emitted.
	(Trac #5345, git 779040fa399fb2da271569dc315294463e28f852)

1292.	[func]		tomek
	User contexts are now supported for subnets. This adds a new
	functionality, but also makes the existing documentation example
	correct.
	(Trac #5350, git 828ecb6dbdaaedd97d2af79dfa9b7f4845d3a049)

1291.	[func]		fdupont
	The configuration parser now checks for mandatory parameters that
	are missing.
	(Trac #5124, git af0f3d50a835f64a5f8a47c47ef464b119a49643)

1290.	[bug]		marcin
	Corrected a bug causing illegal memory access while
	retrieving server hostname and boot file name fields from
	the host reservation database. Many thanks to Juan Settecase
	for his assistance in identifying this issue.
	(Trac #5340, git 2fdc7efcb862ced3c1054620bf14e75a0db6aed2)

1289.	[bug]		marcin, tmark
	Corrected handling of EAGAIN and EWOULDLBOCK errors in
	UnixDomainSocket. This was causing intermittent command
	channel write errors in kea-ctrl-agent on some Debian systems.
	(Trac #5336, git db251cb66ad77ba28ab44281323ddeb23cf29506)

1288.	[func]		marcin
	Documented subnet_cmds library in the Kea User's Guide.  Also moved
	several classes from dhcp<4/6> into lib/dhcpsrv to facilitate subnet
	command parsing.
	(Trac #5315, git d259f330a1690b20eb368f6252f5da2cdb6187de)

1287.	[bug]		tmark
	Logger configuration now correctly uses maxsize and maxver
	parameters, allowing log rotation to function properly.  Prior to
	this these values were not being propagated downward, causing log
	rotation to always be disabled.  The defaults for maxsize and
	maxver are 10Mb and 1 respectively.
	(Trac #5324, git 75f148458bdeeed27eb877cc2c3ce3069b152f38)

1286.	[func]		marcin
	Configured subnets are now indexed by subnet identifier and
	prefix for faster subnet lookups in the configuration.
	(Trac #5314, git 894aeb048b7281f947f87a5d6dc5112fac4a86fb)

1285.	[func]		tomek
	Several new commands implemented in lease_cmds library:
	lease4-del, lease6-del, lease4-update, lease6-update,
	lease4-wipe and lease6-wipe that allow deleting and updating
	leases and also wipe all leases from a specific subnet.
	(Trac #5280, #5281, 94ff2448c8cf6e3321f4d1b3666a2e2b736f6c50)

1284.	[func]		tomek
	A new library, lease_cmds, has been implemented. Its intended
	purpose is to support commands for lease management. Currently
	supported commands are: lease4-add, lease6-add, lease4-get,
	lease6-get. Additional commands and documentation are planned.
	(Trac #5272, #5279, git 785c2e521b198a03d26bde4a804638bfc19ce91b)

1283.	[func]		fdupont
	An 'always-send' parameter has been added to options
	configuration.  It allows an option to be always sent, even if
	a client didn't request it.
	(Trac #5241, git cef2b630c720a442710efc0d1615b7c7bce01e54)

1282.	[bug]		fdupont
	Now all interface service sockets are closed before interface
	re-detection. Note if the re-configuration fails they remain
	closed.
	(Trac #5333, git 8bff2ec336456de51d0d9d3ff011d28a6a61ef66)

1281.	[build]		tmark
	Configure script now correctly recognizes static boost_system
	library as well as checks for the presence of static glibc static
	libraries when --enable-satic-link is specified.
	(Trac #5337, git 42548148cbeaaa285519e121f493d52607f1e8a0)

1280.	[build]		waltsteverson
	Missing header for PD-exclude DHCPv6 option is now installed.
	(Github #51, git 36a8e1b8f687a6398af8a10f241e8d19e9de33d8)

1279.	[build]		waltsteverson
	Compilation fixes for Alpine Linux
	(Github #50, git 824afa63354e045a5e4f6437246c329d359e04dd)

1278.	[doc]		jsoref
	Many spelling corrections.
	(Github #52, git 1dcaef6f8e7901d628c8638fc2f8145ac0279586)

1277.	[func]*		marcin
	Added support to Command Manager to process commands using
	callouts implemented within hooks libraries.
	(Trac #5330, git 8041d177ed5587101ecb47a09820a7e67e42a066)

1276.	[build]		tmark
	The configure script now configures the build to require the Boost
	system library (boost_system) by default.  The library must be
	installed and you may need to specify "--with-boost-lib-dir=<path>".
	Prior to this the default was to attempt to build Boost with headers
	only.  Building with headers only may still be done, though it is
	strongly discouraged, by specifying "--enable-boost-headers-only".
	(Trac #5215, git b6f1ee0d1210e35631369fc697c76cc3cf2c4130)

1275.	[func]		marcin
	LibraryHandle object can now be used to register handlers
	for the control commands in a hook library.
	(Trac #5329, git 966cc24ae5593ebb08d6f02a11dab23463ebad7e)

1274.	[func]		marcin
	It is now possible to manage Control Agent with keactrl.
	(Trac #5108, git 53ba9f8197a25abd2c52ee3f5e95bc4e4be0241f)

1273.	[doc]		marcin
	Documented in the User's Guide that the server terminates
	when database connection is lost.
	(Trac #5320, git 5c8b277e8041b53b27a87b32d162ab41ef8b43d7)

1272.	[bug]		marcin
	Fixed inefficient leases indexing in the memfile lease
	manager causing increased CPU utilization during lease
	searches.
	(Trac #5328, git 23b490414f5575b252c8c42fbe93ad2c57d47953)

1271.	[doc]		marcin
	Documented how to setup secure connection to the Kea
	control	channel.
	(Trac #5304, git a920453bbcf9ffa7200eeddca6323faeff498f16)

1270.	[bug]		tmark
	Added a distribution rule to src/bin/d2/Makefile.am so
	d2_parser.yy will now be included in the distribution source
	tree. Also added entries for missing headers to asiolink/
	Makefile.am.
	(Trac #5325, git 199003d7aa9f8d4a7f8daa73f8259e951bc03217)

1269.	[func]		marcin
	Command manager can now handle large responses to control
	commands. Prior to this change the size of the response
	was limited to 64k. The server now also signals timeout
	after 10s if the connection lasts too long.
	(Trac #5318, git 8531a65521ea42f01f3bed444b054e92f7bd1a46)

1268.	[func]		fdupont
	Kea now re-detects network interfaces every time configuration is
	changed. 're-detect' parameter added to restore old behavior, if
	needed.
	(Trac #3389, git b2ce84790c33d1580dcfa773d7fcfb65c27addc7)

1267.	[bug]		fdupont
	Unit-tests for libdhcp now ignore ENOPROTOPT when setting
	SO_REUSEPORT to improve compatibility with older RedHat versions.
	(Trac #5243, git a7b478e1d1f7f0b38055086fe9ac053e4fab2850)

1266.	[func]		fdupont
	It is now possible to define options in DHCPv4 pools.
	(Trac #5288, git aa2839caab8d885e5bceca6f506162debd239b3f)

1265.	[func]		fdupont
	Extended classification relay6[nest] syntax to allows counting
	relays from the DHCPv6 client side by using negative number,
	e.g. relay6[-1] represents the first relay (closest to the
	client).
	(Trac #5287, git 7d0f7a8372dcf256fea8ac13330f0e3e7ed2e8ef)

1264.	[func]		marcin
	Kea's command manager has been re-implemented to use ASIO.
	Simultaneous connections over the control channel are now
	possible.
	(Trac #5317, git 4139a2f41bb3736615bdfa278746962a16384d0d)

1263.	[doc]		marcin
	Added example configurations of the nginx and Apache2 HTTPS
	servers running as reverse proxy for Kea RESTful API.
	(Trac #5302, git 48113aba218603afac4d457075458d4988e4082b)
	(Trac #5303, git b3113da16eb5c6fa323068f0a57dfa30f42893d2)

1262.	[func]*		marcin
	Renamed "dhcp4-server", "dhcp6-server" and "d2-server" parameters
	of the Control Agent configuration to "dhcp4", "dhcp6" and "d2"
	respectively.
	(Trac #5190, git fc67885022115df76425c6901959cedee63a93b9)

1261.	[bug]		marcin
	Eliminated valgrind errors in libkea-http.
	(Trac #5261, git 34addef4a654665c6022f0269d51970c72431ac2)

1260.	[bug]		fdupont
	Corrected logic in prefix delegation that was causing multiple
	entries to be written to the lease file when renewing or rebinding
	a prefix.
	(Trac #5104, git b9ab6ebe7a491c062bc8b0b42afc53f4d6cee011)

1259.	[func]		marcin
	Implemented timeout for the control commands forwarded between
	the Control Agent and Kea servers. The enhanced forwarding
	mechanism uses asynchronous calls over the unix domain sockets.
	It also detects the JSON structure boundaries when receiving it
	over the stream sockets.
	(Trac #5189, git e48d9399c215406f2dab1601d22d6c932b4af271)

1258.	[bug]		fdupont
	Fixed wrong python package path when kea-shell was configured
	without a prefix.
	(Trac #5214, git 44908c5fa56bfa7e1113078f43c458687a97388a)

Kea 1.2.0 released on April 28, 2017

1257.	[bug]		marcin
	Improved logging in the hosts manager.
	(Trac #5264, git 2fb9fd78e63f5d09810702847ad3e3b3020ea92b)

1256.	[bug]		tomek
	Control Agent now writes proper configuration when using
	config-write command.
	(Trac #5253, git a1b5da4db6ebfa9635bbe411ec363cdcc4fd1d28)

1255.	[bug]		marcin
	Fixed failing unit tests in libkea-http.
	(Trac #5260, git 43394f76efb1634155c04b205dec7361fc21f4f9)

1254.	[func]		tomek
	Various improvements needed for upcoming host commands library:
	host data source is now able to delete hosts, hosts can be exported
	to JSON format, C++11 code for configure script moved to separate
	file, several compilation warnings removed.
	(Trac #5208, git 88555d8f23745f3d615448e906796920cc7f44d0)

1253.	[func,doc]	tomek
	Default configuration file has been overhauled significantly. It
	now covers many additional options and features. Command channel
	is now enabled by default. Thanks to Dan Mahoney for his review.
	(Trac #5198, git 280de81cfe957ccab8a28074bdb0a4bc0e45104e)

1252.	[bug]		tmark
	kea-dhcp6 now correctly resets lease state and increments the
	assigned statistic when it reissues an expired-reclaimed lease
	to the lease's original client, in response to a REQUEST from
	said client.
	(Trac #5252, git 85bde7adbe6a78238bd5e17fecabfa918755f16c)

1251.	[func]		tomek
	New type of host identifier (flex-id) used in reservations has
	by added to MySQL and PostgreSQL schemas.
	(Trac #5195, git 37c26cc30b717019fbd6b7349279541edb351382)

1250.	[bug]		fdupont
	Do not unregister timers when running the config-test command.
	(Trac #5186, git e891b06940e41b4cfaa324c2ace8fdd761ee6662)

1249.	[bug]		tmark
	The assigned lease statistics were not being probably adjusted
	by either kea-dhcp4 or kea-dhcp6 when reclaimed expired leases
	were reissued.
	(Trac #5247, git 4e5193fb32b14325ccf5824614e58bcceb3e6388)

1248.	[bug]		marcin
	Improved socket connection handling code, corrected numerous
	failing and crashing tests for libkea-asiolink, libkea-http
	and kea-ctrl-agent on Debian, Fedora and Ubuntu.
	(Trac #5217, git 4bcb45f0c88aba3d0f70ca48d9fff6f1d4616bc2)

1247.	[bug]		marcin
	Resolved issues with DHCPv4 host reservations by 'client-id'
	when MySQL or PostgreSQL host database backend is in use.
	Also, the 'client-id' is used together with other host
	identifier types when 'host-reservation-identifiers' parameter
	is not specified.
	(Trac #5102, git 390d687d0f61635f5562d13860ff6362eee67853)

1246.	[func,bug]	tomek
	Restrictions in filename argument in config-write command have
	been removed. It is now possible to use absolute paths.
	DHCPv4, DHCPv6, D2 and Agent parsers did not handle flush,
	maxsize or maxver parameters in logger configuration correctly.
	This is now fixed.
	(Trac #5187, git a30ffcc67cfb7370c586d3c85147792e27aab4c7)

1245.	[func]		fdupont
	DHCPv4 domain-search option can now be defined using
	comma separated values.
	(Trac #5087, git eca0b8c6425bc922587675100f100b1aae54aee2)

1244.	[doc]		tomek
	User's Guide section about Kea shell added.
	(Trac #5171, git 3dc4908fe02e86c57ccd5ad2d2f8330655f438be)

1243.	[func]		tomek
	config-reload command implemented. It allows Kea DHCPv4 and DHCPv6
	servers to reload its original configuration file. Also,
	set-config command was renamed to config-set.
	(Trac #5213, git b209c2b577a2f9da71cc918d7a551f8efdc1c4cb)

1242.	[func]		fdupont
	Integer fields in options can now be specified in either
	decimal or hexadecimal format.
	(Trac #4540, git 4cbf341f4169cf1e1eae0721644797a726d89702)

1241.	[func]		fdupont
	Support for tuple-based options added. DHCPv6 option
	bootfile-param (code 60) can now be set in a more convenient
	manner.
	(Trac #4070, git 30102cacee95b91e6c4666f0c11f06232f19eeb9)

1240.	[bug]		marcin
	Corrected IOFetch unit test failures on Debian.
	(Trac #5216, git a7c2946678c43aedfb2e3c37b9730a10067528f3)

1239.	[func]		marcin
	Implemented additional sanity checks when adding host
	reservations into the configuration file.
	(Trac #5207, git ea42c6f479918235ae4a67a60d08720e2664720c)

Kea 1.2.0-beta released on April 7, 2017

1238.	[build]		tmark,tomek
	Library version numbers bumped for release.
	(Trac #5201	git 58c9c5b705d72031c1589c30c542384a9d43e0f3)

1237.	[bug]		marcin
	Fixed hanging Control Agent unit tests.
	(Trac #5200, git 65daafd135965f9eb0bd4c3a22085d4bd3c6ffbe)

1236.	[build]		zeitounator
	Improvements in tools/tests_in_valgrind.sh script.
	(Github #49, git 272e7babf9ebeab5f78850394d72c9431041e2e9)

1235.	[func]		MrMarvin
	kea-admin now supports -h (and --host) parameter that can specify
	MySQL or PostgreSQL database locations other than the default
	localhost.
	(Github #14, git 4038157a3499ad90956c98a2172c57b173f2b985)

1234.	[build]		fdupont
	Improved installation procedure for kea-shell.
	(Trac #5170, git 68a902fb723965ee6f5b7a8272224395917525cc)

1233.	[doc]		marcin
	Documented new component Kea Control Agent in the Administrator's
	Manual and the Developer's Guide.
	(Trac #5175, git abf7887ad65eb4b221a1fe61ea0c9773b4feaddb)

1232.	[func]		tomek
	host4_identifier and host6_identifier hook points have been added.
	Premium: Flexible Identifier (flex-id) hook point has been developed.
	It allows users to specify a custom expression that takes any
	option, field, characteristic or property of the packet to be
	used as identifier and then do reservations based on the evaluated
	expression for each incoming packet.
	(Trac #5132, git cd497526d5bff7ae55bb41c9264fb33943a0cf62)

1231.	[func]		marcin
	Control agent forwards commands to be handled by other Kea
	servers.
	(Trac #5078, git 19a50ed1ccafae19ef10d84cba73992cadf49753)

1230.	[bug]		fdupont
	kea-dhcp-ddns now correctly populates the original ID in the TSIG rdata
	when doing signed updates.  Prior to this the value was set to zero
	causing PowerDNS to reject then requests with a bad key error.
	(Trac #5071, git cafa3d5c24f0112b0b9384a9c1083fe8a3eeb2bf)

1229.	[func]		fdupont
	A new command: config-test has been implemented in DHCPv4, DHCPv6
	and control agent servers. It allows checking whether new
	configuration looks correct.
	(Trac #5150, git 5f6cf226e848baef8d9af64e16c1dbf617a0a798)

1228.	[bug]		fdupont
	Logging on syslog now uses correctly the given facility. If none
	is given the default facility is local0, and with an unrecognized
	value user (log4cplus default). The syslog openlog() ident
	parameter is the program name.
	(Trac #5053, git 532d9f0e459ab1450a83a5015a2dd54745794383)

1227.	[func]		fdupont, tomek
	Additional commands: version-get, build-report have been
	implemented for DHCPv4, DHCPv6 and Control Agent
	components. Control Agent also now supports shutdown command.
	(Trac #102, git 9d2b8326fc032876d74c1768c61c630987c25cc5)

1226.	[func]		fdupont
	Command line option -t support added to libprocess and implemented
	for kea-dhcp-ddns and kea-ctrl-agent. It allows configuration sanity
	checking. Note that some parameters, such as ip-address, port, and
	DNS server addresses for instance for kea-dhcp-ddns are not fully
	checked as sockets are not opened or connections are not attempted.
	(Trac #5152, git 2231d79ebebd3cdf432cd4a8ac32018d180e27b6)

1225.	[func]		tomek
	Two new commands: config-get (retrieves current configuration)
	and config-write (writes current configuration to disk) have been
	implemented.
	(Trac #5151, git ffb26811736a2ae6f9b5556b9823aa284b7e0aec)

1224.	[func]		fdupont
	toElement(), a crucial functionality for upcoming get-config
	and write-config command, has been implemented.
	(Trac #5114, git df38c26f957c9ac329718ac9d70ffbcf7b95c4e9)

1223.	[func]		tomek
	Kea-shell, a management client able to connect to REST interface
	provided by Control Agent, has been added. Control Agent now
	uses bison parser, which provides better sanity checks, improved
	comments and file inclusions.
	(Trac #5137, git 816dc5ccfa374bd9942a49c7bac475f6d0523caa)

1222.	[func]		fdupont
	Obsolete parameter 'allow-client-update' has been removed
	from DHCPv4 and DHCPv6 components.
	(Trac #5145, git 01fde297a978e2bd832655ac7276e5aa3a7e8400)

1221.	[func]		tomek
	Control agent is now able to parse the input configuration and
	store it in its configuration syntax structure. Upcoming tickets
	will take advantage of that information.
	(Trac #5134, git 828304f2f408888e4b096418e90e35ba524979d0)

1220.	[func]		parisioa, fdupont, tomek
	DHCPv4 and DHCPv6 parsers have updated to accept database port
	parameter. The parameter for Cassandra is now called
	"contact-points" (was "contact_points" previously).
	(Trac #5061, git d12b6f4a6d80d6bc854f2a8a086e412dc37867bc)

1219.   [func]		marcin
	Control Agent uses libkea-http to process commands over
	the RESTful interface.
	(Trac #5107, git 88ce715926a46b6b3832630116fc7782adc46c7b)

1218.	[func]		tmark, tomek
	Configuration parsing for D2 has been migrated to bison/flex
	and the SimpleParser framework.  This includes changes to
	libprocess which render the CPL agnostic to the underlying
	parsing mechanisms.
	(Trac #5110, git feb2cedc0936364a923ab78542a21114533dd0f5)

1217.	[func]		marcin
	Implemented libkea-http library.
	(Trac #5077, git cd72284b5b221e620770883db7e166c4d3ba7eb6)
	(Trac #5088, git 715d18f961801ffbd798a65b19459178c3a53857)
	(Trac #5099, git 7e8df7993f295431e2cb6a13858f746649c4e18d)

1216.	[func]		fdupont, tomek
	Command line option -t implemented for DHCPv4 and DHCPv6.  It
	allows configuration sanity checking. Note that not all parameters
	are completely checked. In particular, service and control channel
	sockets are not opened, and hook libraries are not loaded.
	(Trac #3770, git 1d12582e270935ee7b72548d9c66753f4eea4ca4)

1215.	[doc]		tomek
	Developer's Guide updated to cover flex/bison parser.
	(Trac #5112, git 44139d821c1f4e43dbff22d49101a0854e4f9f5b)

1214.	[func]		tomek
	Bison parser implemented for Control-agent. The code is able
	to syntactically parse input configuration, but the output
	is not used yet.
	(Trac #5076, git d99048aa5b90efa7812a75cdae98a0913470f5a6)

1213.	[bug]		fdupont
	Option string values containing comma can now be specified
	correctly by preceding comma with double backslashes (e.g.
	"foo\\,bar").
	(Trac #5105, git fa79ac2396aa94d7bac91bd12d3593ebaaa9386d)

1212.	[doc]		andreipavelQ
	Many spelling corrections.
	(Github #47, git a6a7ca1ced8c63c1e11ef4c572f09272340afdd7)

1211.	[func]		andreipavelQ
	Updated PostgreSQL version reporting to be in line with
	MySQL and Cassandra.
	(Github #42, git 7ef4a190facadd66775b4a44c696d1c4215616cd)

1210.	[doc]		andreipavelQ
	Doxygen version updated to 1.8.11.
	(Github #45, git ce72998382b62269823fa0dcbfa41dfa9c72b69e)

1209.	[func]		tomek
	Relay options are now printed in DHCPv6 when sufficiently detailed
	debug logging is requested.
	(Trac #5131, git 5bf58b21fcf07f2e2e97275efa1f76cde913b30a)

1208.	[func]		tomek
	Global DHCPv4 and DHCPv6 parsers have been migrated to the
	SimpleParser framework. Several parameters (renew-timer,
	rebind-timer, preferred-lifetime, valid-lifetime, match-client-id,
	next-server, decline-probation-period, dhcp4o6-port,
	echo-client-id) now have explicit default values.
	(Trac #5019, git f3538dd031e6f29abcd516f425d72c8f929abbb0)

1207.	[func]		fdupont
	Client classes parser migrated to SimpleParser. The 'name'
	parameter in 'client-classes' definitions is now mandatory.
	(Trac #5098, git e93906e48a6e2b0ff78c5e37dca642646fe47d43)

1206.	[func]		tomek
	'hooks-libraries' parser migrated to SimpleParser. The code will
	now refuse a configuration if a hook library fails to load.
	(Trac #5031, #5041, git 1bbaf4cbcf6fda59bacdf526a6c762315fdd88a1)

1205.	[func]		tomek
	Parsers for interfaces configuration converted to SimpleParser.
	Removed obsolete 'version' parameter in Dhcp6.
	(Trac #5020, #5038, git 3d8e48c640e302670c04907468d11faafbe9fe7b)

1204.   [func]         marcin
	Added 'control_command_receive' hook point to Kea Command
	Manager.
	(Trac #5100, git d0c7cb29a7df3588c540afb4ca56de55f26142e0)

1203.   [func]         marcin
	Implemented TCPAcceptor class in libkea-asiolink. This class
	provides means to listen and asynchronously accept new TCP
	connections.
	(Trac #5094, git 920ba90696ba9d8579a7db5e1efcf955d6654a96)

1202.	[func]		tomek
	Parsers for mac-sources, control-socket, and relay-info converted
	to SimpleParser. It is no longer accepted to specify empty
	mac-sources. Either specify actual values in mac-sources or
	don't specify mac-sources at all.
	(Trac #5032, git f1c9dee0936b48be28f890ffd428fbdeb87c12ea)

1201.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 now support the "set-config" command.
	The command causes the server to replace its current configuration
	with the configuration supplied as the command's argument.
	(Trac #5046, git 4afbdcf89c9f83d944f774d05bd401d3f2768d10)

1200.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 now support the Command Channel "libreload"
	command.  The command causes the server to unload and then load all
	currently loaded hook libraries.
	(Trac #3238, git d4d8665494e1847b34b66f8ef542851ea6f0213c)

1199.	[func]		tomek, fdupont
	Dhcp4 parser migrated to bison. This yields a number of user
	visible changes:
	- better comment handling (bash, C, C++ style comments)
	- file includes now supported
	- better syntax checking
	- added advanced.json config example
	- removed obsolete 'version' parameter
	(Trac #5017, git 1cf853c595a100c86f9b2b3353f1b5964d902147)

1198.   [func]         marcin
	Created kea-ctrl-agent. This application currently doesn't
	do anything. Future tickets will add REST API to allow for
	managing Kea services.
	(Trac #5075, git 1ec7586da5ae1474b52d5a395fb80ee37d6d568e)

1197.	[doc]		tomek
	Configuration examples now set lfc-interval to a default
	value of one hour.
	(Trac #5072, git cf4362196fa2b7892643d1e40b974bb450a3de7e)

1196.	[func]		tomek, fdupont
	Dhcp6 parser migrated to bison. This yields a number of user
	visible changes:
	- better comment handling (bash, C, C++ style comments)
	- file includes now supported
	- better syntax checking
	(Trac #5036, git 4c5902da95a5228275cdb151b357864cfa9c31f5)

1195.	[build]		fdupont
	Altered to compile in C++ 2011 standard mode. Also replace (most)
	instances of the deprecated std::auto_ptr with std::unique_ptr.
	(Trac #5066, git a060d4a983860bf3056d50d9bf7ee4355c8372f2)

1194.   [build]		marcin
	Moved StateModel class from D2 to libkea-util.
	(Trac #3175, git 270ec379aec2894104a299cdd1080e24007e25fb)

1193.	[doc]		stephen
	Update Hook Developers documentation to make it clearer where
	the Kea include files and libraries are located.
	(Trac #5069, git 14a78caaf3af9fe9a0ffe2c8af784eab78e813e0)

1192.   [build]     marcin
	Created libkea-process library and moved the Controllable
	Process Layer (CPL) from D2 to this new library.
	(Trac #5074, git 4563925f7966e9da2132eb427e742cc3d3feee5d)

1191.	[build]		tomek
	Optional support for premium package added.
	(Trac #5027, git 5ff51f28a1f05d941bb117986922a6f410f23c6c)

1190.	[func]		tomek
	User context implemented: an arbitrary user information can
	now be defined for address and prefix pools.
	(Trac #5023, git 4f81789e19b72c933bcf86e402b417c63bd7bd3f)

1189.	[func]		fdupont
	Owing to API changes, crypto code now requires OpenSSL 1.0.1 or
	later.
	(Trac #3908, git 4c14fdfd4187a4c8f7b775432082b76782e47663)

1188.	[doc]		vlegout
	Fixed several spelling mistakes.
	(Github #32, git d51c005519c4add6fd0c37bcd68b0fbe94941b2d)

1187.	[bug]		marcin
	DHCPv4 server allows for allocating multiple leases for the
	same hardware address if a different client identifier is
	used for each lease. This facilitates the PXE boot use cases
	where a booted machine may request a lease multiple times.
	(Trac #5029, git 03defed4d8bb9a997d31dbfcf30ae3f866bd3353)

1186.	[func]		marcin
	Support for DHCPv6 options defined in RFC6603 and RFC7598. Thanks
	to Andrei Pavel and Cristian Secareanu of Qualitance for submitting
	initial implementation.
	(Trac #Github24, git 59b62eb3ddd9db62c04bd47cd8fbdc1af62fbc1b)

1185.	[build]		marcin
	Install Kea headers to be used for building external libraries.
	Before this change some required headers were not installed.
	(Trac #5055, git a46087b7b7face4a1318658bbdcbf7602c1bb729)

1184.	[bug]		eest
	Fixes in the occasionally failing LFC unit test. This
	fix was provided by Patrik Lundin.
	(Github #31, git 69a5722bf3b41bf3b2bc0c2bcac966c23c08f62d)

1183.	[bug]		tmark
	kea-dhcp4 now correctly loads declined leases from CSV
	lease files. Prior to this, declined leases were being
	incorrectly and silently discarded.  In addition, both
	kea-dhcp4 and kea-dhcp6 will now emit an error log for
	each invalid row encountered when loading leases from
	CSV files.
	(Trac #5058, git 29b088079bed3c5059fdf8a43a4e79cd7f9a4207)

1182.	[func]		marcin
	DHCP servers detect overlapping pool ranges during
	configuration.
	(Trac #2280, git c8f931e0189c9630f5fba5d2a5553bed4abf36f7)

1181.	[func]		marcin
	Extended DHCPv6 server to allow for specifying DHCP options
	on address and prefix pool levels.
	(Trac #5022, git e3b2785c79aedbb0c8af7468d61f6d61dafd2282)

Kea 1.1.0 released on September 30, 2016

1180.	[doc]		stephen
	Editing pass through the Kea guide.
	(Trac #4484, git 63456fab1b978bd515198b9b9e604f293efd8217)
	(Trac #5008, git f09cd12d5b1abc60ccef98df2abc6c41b482a404)

1179.	[doc]		tomek
	Manual pages updated.
	(Trac #3515, git 4cf0395e11e724786c4d2a1d48805f1c770f4c99)

1178.	[doc]           tomek
	user_chk hook library is now documented in the User's Guide.
	(Trac #3209, git 4a8534d968a21cff3851619fb22d0032a1202c87)

1177.	[build]	marcin
	Updated Kea libraries version numbers for 1.1-final release.
	(Trac #5012, git 6e9a224b46def357141a31386fcc912b29dfe16d)

1176.	[doc]		tomek
	Developer's Guide has been updated.
	(trac #4299, git ed38076c183394feaef60e7123d0c488c9f6447d)

1175.	[bug]		marcin
	Corrected a bug whereby a client, for which there was no
	host reservation specified, did not obtain an IPv6 lease
	from a server when PostgreSQL or MySQL host database backend
	was in use. In addition, PostgreSQL host database backend
	allows for specifying NULL values in certain columns within
	host reservation tables.
	(Trac #5009, git d3109bb27786867fdc99954ba55367f0ad129e7a)

1174.	[bug]		tmark
	Modified kea-dhcp6 to avoid requesting DNS updates when
	existing leases are renewed without changes to the FQDN.
	(Trac #5007, git 05ea3a5eb75c06cf9814c63a1a54261bf58a954b)

1173.	[bug]		xxwolfsrainxx, marcin
	MySQL database creation scripts use single quotes for
	strings to avoid issues with creation of the database
	when MySQL server operates in ANSI_QUOTES mode.
	(Github #30, git e40a54a8e24b5f6427edd4afcd5cdc15012b8866)

1172.	[bug]		andir
	Kea build fixes for gcc 6, which uses C++14 by default.
	(Github #29, git ad68c3942839618c26d7ff017fbac7df139b5d01)

1171.	[doc]		marcin
	Updated supported operating systems and the prerequisites for
	installing and building Kea in the Kea Administrator
	Reference Manual.
	(Trac #4502, git af847837590ce5b37a300ebe15652fb172585b38)

1170.	[doc]		marcin
	Updated Kea Administrator's Reference Manual sections
	regarding host reservations. Added configuration examples
	for using host reservations with MySQL and PostgreSQL
	databases.
	(Trac #3684, git 71d21eac51d20ff5d368b17c437abc45c955a04c)

1169.	[doc]		marcin
	Updated Kea Administrator Reference Manual to explain the
	implications of using "kea_verbose" parameter in the keactrl
	configuration.
	(Trac #3950, git c5f4920fd1994882e1fae398ae29b455401296bd)

1168.	[doc]		marcin
	Corrected location of the Kea repository in the Kea Administrator
	Reference Manual.
	(Trac #4258, git f081000b892287316e54848ca1f62ca3512d4263)

1167.	[func]		marcin
	DHCP servers utilize client classes defined in host reservations.
	(Trac #4765, git 242fbc47b31da404e57be458ac065f811084cca9)

1166.	[bug]		marcin
	Corrected error message produced by the host database access
	parser when the database type was not specified.
	(Trac #4261, git 028dd49f4fa4843e68e23d11c237e9f4683470ba)

1165.	[func]		marcin
	Hostname option is returned to the client when requested using
	Parameter Request List option. Previously this option was only
	returned when a client has sent Hostname option to the server.
	(Trac #5005, git 96ab8ecaa3d5b2d6cd88d0b16406f433d2cdf841)

1164.	[bug]		marcin
	Corrected an issue whereby DHCPv4 server did not correctly set a
	server identifier in response message sent to a client on BSD
	systems.
	(Trac #5003, git 110c67325072a781d55cf0634f8f5f3385611f97)

1163.	[bug]		marcin
	Corrected swapped DHCPSRV_MEMFILE_GET_EXPIRED{4,6} messages
	in the Memfile lease manager.
	(Trac #4717, git ce5919d97879c3fda0858894b24418af135ef8f3)

1162.	[func]		pallotron
	Added two enhancements to perfdhcp: optionally using MAC
	addresses from a file in new DHCP transactions, and
	generation of DHCPv6 relayed messages.
	(Github #22, git c5b4a5981cf642ebb9aecb8acc07b87abdccbd91)

1161.	[bug]		fdupont
	Fixed interface manager receive methods which raise a bug on
	Fedora 24 / gcc 6.1?
	(Trac #4551, git 8d590e434062535e850a60a7892481df845ff390)

Kea 1.1.0-beta released on August 31, 2016

1160.	[build]		marcin
	Bumped up version numbers of Kea libraries and KEA_HOOKS_VERSION
	for the Kea 1.1.0 beta release.
	(Trac #4632, git 93941523e039a1cc4bb34182a290f9d7b805df34)

1159.	[func]		marcin
	MySQL database schema updated to version 5.0.
	(Trac #4562, git 0e40b35e280f0845686bcfdb2efb577c7878ede6)

1158.	[func]		tomek
	It is now possible to specify fixed fields (next-server,
	server-hostname and boot-file-name parameters) for client classes.
	(Trac #4626, git 89cf54524d8b55cc982ab2146915c0a90fc6efe2)

1157.	[func]		marcin
	Added support for static reservations for fixed fields in
	DHCPv4 messages: siaddr, sname and file.
	(Trac #4552, git 9b79fe005dd77328ea7c596fc6886f8fb838d1cf)

1156.	[bug]		tmark
	Lease statistics are now recalculated during server startup and
	after each successful reconfiguration for Memfile, MySQL, and PostgreSQL
	backends.  This addresses issues caused by accumulated values being lost
	across restarts and reconfigurations making rendering values incorrect.
	(Trac #4294 git 0abdcf15f85861ffcb67d50fa4ce3965d25e4a9f)

1155.	[func]		marcin
	Kea can be configured to operate using read-only host database.
	This is only supported for MySQL and PostgreSQL databases.
	(Trac #4489 git 0d8dc7affb67ad8066b44c6f81532b79a641d50b)

1154.	[bug]		stephen
	Changes to logging to avoid premature destruction of some
	objects during program exit.  On some systems this caused
	one of the unit test programs to crash when it terminated.
	(Trac #4494, git 023c2fc3688bcdbccb4b286bea873c8f9c06cd5f)

1153.	[func]		tomek
	Integers can now be used in client classification.
	(Trac #4483, git e90cf0ee4007521b86177be6d5fbb970c02c1075)

1152.	[doc]		marcin
	Use of PostgreSQL as a storage for host reservations is now
	documented in the Kea Administrator Reference Manual.
	(Trac #4282, git f2879919772c10b1ae8c45d0e761ef199cf84061)

1151.	[func]		tmark
	Support for assigning client classes to host reservations has
	been added to both the PostgreSQL and MySQL backends.
	(Trac #4277, #4213 git 6990ab9d542e984c59ce5a11ff926c3c732a75fc)

1150.	[bug]		tomek
	Extended gcc bug workaround to work on all versions of gcc
	from 5.2 up to, but not including 6.0. See ChangeLog entry
	1103 or Trac ticket #4243 for details.
	(Trac #4553, git 80243d9d246b982d86dd7e0d00597383cae01706)

1149.	[bug]		marcin
	Corrected a bug whereby clients were not assigned reserved
	addresses from an external database, as a result of unexpected
	closure of a connection to that database.
	(Trac #4544, git 7f682112dd5ab9fcd6bfa4e10505c246775f353d)

1148.	[func]		tomek
	The vendor options (124, 125 in DHCPv4 and 16, 17 in DHCPv6) are
	now accessible from client classification.
	(Trac #4270, #4271, git ef676368f9036625d73f7f34e3fe9b5eeeaee7f1)

1148.	[func]		fdupont
